/* BIN2PROG v1.a                                                           */
/* Comandos i:posicin inicial; f:posicin final t:byte, w:word, d:double  */
/* word; l:datos por linea; e:etiqueta                                     */

#include <io.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>

#define BUFFER 4096

void doasm(void);
void doc(void);
void docpp(void);
void domod_pas(void);
void dobas(void);
void dotxt(void);
void dodat(void);
void dolis(void);
void ayuda(void);
void salir(unsigned char);
void cabecera(char *);
unsigned char existe(char *);
unsigned char hayos2(void);
unsigned char haywinenh(void);

static char norg[64], ndest[64], etiqueta[11]={"BIN2PROG"};
static long ini, fin, tam;
static FILE *porg, *pdest;
static unsigned char tipo, lin;
static char *borg, *bdest;


/* ------------------------- Funcin principal ---------------------------- */
void main (unsigned char argc, char *argv[])
{
	register unsigned char i;

	cabecera(argv[0]);
	if (argc<3)
	{
		textcolor(12);
		cputs("Error(01): Faltan parmetros.\r\n");
		salir(1);
	}
	/* Pasa cada argumento a maysculas */
	for (i=0; i<argc; i++)
		argv[i]=strupr(argv[i]);

	/* Pon a los ficheros las extensiones por defecto, .BIN y .ASM */
	strcpy(norg, argv[1]);
	strcpy(ndest, argv[2]);
	if (strchr(norg, '.')==0)
		strcat(norg, ".BIN");
	if (strchr(norg, '.')==0)
		strcat(ndest, ".ASM");

	/* Valores por defecto de ini y fin, y comprueba la sobreescritura */
	porg=fopen(norg, "rt");
	if (porg==0)
	{
		textcolor(12);
		cputs("Error(04): Error al abrir el fichero orgen.\r\n");
		salir(4);
	}
	lin=7;
	ini=0;
	tipo=1;
	fin=filelength(fileno(pdest));
	fclose(porg);
	if (existe(ndest)!=0)
	{
		textcolor(12);
		cputs("Alarma(01): El fichero destino ya existe. Sobreescribirlo(s/N)?");
		if (toupper(getch())=='S')
		{
			cputs("\r\n");
			pdest=fopen(ndest, "wt");
			if (pdest==0)
			{
				textcolor(12);
				cputs("Error(05): Error al abrir el fichero destino.\r\n");
				salir(5);
			}
			fclose(pdest);
		}
		else                      
			salir(0);
	}
	/* Lee las opciones de la linea de comandos y actua en consecuencia */
	for (i=1; i<argc; i++)
	{
		/* Inicio de la conversin */
		if ((strncmp(argv[i],"/I", 2)==0) || (strncmp(argv[i],"-I", 2)==0))
		{
			ini=atol(&argv[i][2]);
			if (ini==0)
			{
				textcolor(12);
				cputs("Error(02): Parmetro incorrecto.\r\n");
				salir(2);
			}
		}
		/* Fin de la conversin */
		else if ((strncmp(argv[i],"/F", 2)==0) || (strncmp(argv[i],"-F", 2)==0))
		{
			fin=atol(&argv[i][2]);
			if (fin==0)
			{
				textcolor(12);
				cputs("Error(02): Parmetro incorrecto.\r\n");
				salir(2);
			}
		}
		/* Etiqueta del conjunto de datos */
		else if ((strncmp(argv[i],"/E", 2)==0) || (strncmp(argv[i],"-E", 2)==0))
		{
			strcpy(etiqueta, &argv[i][2]);
		}
		/* Datos por linea */
		else if ((strncmp(argv[i],"/L", 2)==0) || (strncmp(argv[i],"-L", 2)==0))
		{
			lin=atol(&argv[i][2]);
			if (lin==0)
			{
				textcolor(12);
				cputs("Error(02): Parmetro incorrecto.\r\n");
				salir(2);
			}
		}
		/* Tipo de dato */
		else if ((strncmp(argv[i],"/TB", 3)==0) || (strncmp(argv[i],"-TB", 3)==0))
			tipo=1;
		else if ((strncmp(argv[i],"/TW", 3)==0) || (strncmp(argv[i],"-TW", 3)==0))
			tipo=2;
		else if ((strncmp(argv[i],"/TD", 3)==0) || (strncmp(argv[i],"-TD", 3)==0))
			tipo=4;
		else if ((strncmp(argv[i],"/?", 2)==0) || (strncmp(argv[i],"-?", 2)==0))
			ayuda();
	}
	if (fin<=ini)
	{
		textcolor(12);
		cputs("Error(02): Parmetro incorrecto.\r\n");
		salir(2);
	}
	tam=fin-ini;
	if (tam>65000U)
	{
		textcolor(12);
		cputs("Alarma(02): El fichero destino tiene ms de 64K. Continuar(S/n)?");
		if (toupper(getch())=='N')
			salir(0);
	}
	cputs("\r\n");
	borg=malloc(BUFFER+1);
	bdest=malloc(BUFFER+1);
	if ((borg==0) || (bdest==0))
	{
		textcolor(12);
		cputs("Error(03): Memoria insuficiente.\r\n");
		salir(3);
	}
	setvbuf(porg, borg, _IOFBF, BUFFER);
	setvbuf(pdest, bdest, _IOFBF, BUFFER);
	if (strstr(ndest, ".ASM")!=0)
		doasm();
	else if (strstr(ndest, ".CPP")!=0)
		docpp();
	else if (strstr(ndest, ".MOD")!=0)
		domod_pas();
	else if (strstr(ndest, ".PAS")!=0)
		domod_pas();
	else if (strstr(ndest, ".BAS")!=0)
		dobas();
	else if (strstr(ndest, ".DAT")!=0)
		dodat();
	else if (strstr(ndest, ".LIS")!=0)
		dolis();
	else if (strstr(ndest, ".C")!=0)
		doc();
	else
		dotxt();
	free(borg);
	free(bdest);
	salir(0);
}

/* -------------------------- Convertir a ASM ----------------------------- */
void doasm(void)
{
	register unsigned char i;
	unsigned char byte;
	unsigned int word;
	unsigned long doubleword;
	unsigned long llevo;

	porg=fopen(norg, "rb");
	pdest=fopen(ndest, "wb");

	textcolor(2);
	cputs("Convirtiendo...\r\n");
	textcolor(7);
	cprintf("  Partimos del fichero binario:          %s.\r\n", norg);
	cprintf("  Generaremos el fichero en ASM:         %s.\r\n", ndest);
	cprintf("  Bytes a convertir:                     %ld (del %ld al %ld).\r\n", tam, ini, fin);
	if (tipo==1)
		cprintf("  Generando:                             %ld bytes de datos.\r\n", tam);
	else if (tipo==2)
		cprintf("  Generando:                             %ld words de datos.\r\n", tam>>1);
	else
		cprintf("  Generando:                             %ld double words de datos.\r\n", tam>>2);
	cprintf("  Identificador de los datos:            %s\r\n", etiqueta);
	cprintf("  Datos por linea:                       %u\r\n", lin);
	cprintf(" ---------------------------------------- -----------\r\n");
	cprintf("            Procesado                       (%3.0u\%)\r", 0);
	fseek(porg, ini, 0);
	llevo=0;
	fputs("; Fichero generado por BIN2PROG Versin 1 Revisin A\r\n", pdest);
	fputs("; (c) Copyright 1995 De trans Software\r\n", pdest);
	fputs(";                    Av. Meridiana 336, 7 C\r\n", pdest);
	fputs(";                    08027. Barcelona\r\n", pdest);
	fputs(";                    [Spain]\r\n", pdest);
	fputs("; Este programa es de dominio pblico, selo y cpielo tanto\r\n", pdest);
	fputs("; como quiera, siempre y cuando est ntegro y sin modificar\r\n", pdest);
	fprintf(pdest, "Longitud Equ %ld\r\n\r\n", tam);
	fprintf(pdest, "%s", etiqueta);
	do
	{
		if (tipo==1)
			fputs("           Db ", pdest);
		else if (tipo==2)
			fputs("           Dw ", pdest);
		else
			fputs("           Dd ", pdest);
		for (i=0; i!=lin; i++)
		{
			if (tipo==1)
			{
				byte=fgetc(porg);
				fprintf(pdest, "%u", byte);
				llevo++;
			}
			else if (tipo==2)
			{
				word=fgetc(porg)+256*fgetc(porg);
				fprintf(pdest, "%u", word);
				llevo++;
				llevo++;
			}
			else
			{
				doubleword=fgetc(porg)+256*fgetc(porg)+65536L*fgetc(porg)+16777216L*fgetc(porg);
				fprintf(pdest, "%u", doubleword);
				llevo+=4;
			}
			if (llevo>=tam)
				break;
			else
					fputs(", ", pdest);

		}
		cprintf("            Procesado                       (%3.0u\%)\r", (llevo*100)/tam);
		fputs("\r\n", pdest);
	}
	while (llevo<tam);
	cprintf("            Procesado                       (%3.0u\%)", 100);
	fclose(porg);
	fclose(pdest);
}


/* --------------------------- Convertir a C ------------------------------ */
void doc(void)
{
	register unsigned char i;
	unsigned char byte;
	unsigned int word;
	unsigned long doubleword;
	unsigned long llevo;

	porg=fopen(norg, "rb");
	pdest=fopen(ndest, "wb");

	textcolor(2);
	cputs("Convirtiendo...\r\n");
	textcolor(7);
	cprintf("  Partimos del fichero binario:          %s.\r\n", norg);
	cprintf("  Generaremos el fichero en C:           %s.\r\n", ndest);
	cprintf("  Bytes a convertir:                     %ld (del %ld al %ld).\r\n", tam, ini, fin);
	if (tipo==1)
		cprintf("  Generando:                             %ld bytes de datos.\r\n", tam);
	else if (tipo==2)
		cprintf("  Generando:                             %ld words de datos.\r\n", tam>>1);
	else
		cprintf("  Generando:                             %ld double words de datos.\r\n", tam>>2);
	cprintf("  Identificador de los datos:            %s\r\n", etiqueta);
	cprintf("  Datos por linea:                       %u\r\n", lin);
	cprintf(" ---------------------------------------- -----------\r\n");
	cprintf("            Procesado                       (%3.0u\%)\r", 0);
	fseek(porg, ini, 0);
	llevo=0;
	fputs("/* Fichero generado por BIN2PROG Versin 1 Revisin A */\r\n", pdest);
	fputs("/* (c) Copyright 1995 De trans Software */\r\n", pdest);
	fputs("/*                    Av. Meridiana 336, 7 C */\r\n", pdest);
	fputs("/*                    08027. Barcelona */\r\n", pdest);
	fputs("/*                    [Spain] */\r\n", pdest);
	fputs("/* Este programa es de dominio pblico, selo y cpielo tanto */\r\n", pdest);
	fputs("/* como quiera, siempre y cuando est ntegro y sin modificar */\r\n", pdest);
	fprintf(pdest, "#define longitud %ldL\r\n\r\n", tam);
	if (tipo==1)
		fprintf(pdest, "unsigned char %s[]={\r\n", strlwr (etiqueta));
	else if (tipo==2)
			fprintf(pdest, "unsigned int %s={\r\n", strlwr (etiqueta));
	else
			fprintf(pdest, "unsigned long int %s={\r\n", strlwr (etiqueta));
	do
	{
		for (i=0; i!=lin; i++)
		{
			if (tipo==1)
			{
				byte=fgetc(porg);
				fprintf(pdest, "%u", byte);
				llevo++;
				if (llevo<tam)
					fputs(", ", pdest);
			}
			else if (tipo==2)
			{
				word=fgetc(porg)+256*fgetc(porg);
				fprintf(pdest, "%u", word);
				llevo++;
				llevo++;
				if (llevo<tam)
					fputs(", ", pdest);
			}
			else
			{
				doubleword=fgetc(porg)+256*fgetc(porg)+65536L*fgetc(porg)+16777216L*fgetc(porg);
				fprintf(pdest, "%u", doubleword);
				llevo+=4;
				if (llevo<tam)
					fputs(", ", pdest);
			}
			if (llevo>=tam)
				break;
		}
		fputs("\r\n",pdest);
		cprintf("            Procesado                       (%3.0u\%)\r", (llevo*100)/tam);
	}
	while (llevo<tam);
			fputs("};", pdest);
	cprintf("            Procesado                       (%3.0u\%)", 100);
	fclose(porg);
	fclose(pdest);
}

/* -------------------------- Convertir a C++ ----------------------------- */
void docpp(void)
{
	register unsigned char i;
	unsigned char byte;
	unsigned int word;
	unsigned long doubleword;
	unsigned long llevo;

	porg=fopen(norg, "rb");
	pdest=fopen(ndest, "wb");

	textcolor(2);
	cputs("Convirtiendo...\r\n");
	textcolor(7);
	cprintf("  Partimos del fichero binario:          %s.\r\n", norg);
	cprintf("  Generaremos el fichero en CPP:         %s.\r\n", ndest);
	cprintf("  Bytes a convertir:                     %ld (del %ld al %ld).\r\n", tam, ini, fin);
	if (tipo==1)
		cprintf("  Generando:                             %ld bytes de datos.\r\n", tam);
	else if (tipo==2)
		cprintf("  Generando:                             %ld words de datos.\r\n", tam>>1);
	else
		cprintf("  Generando:                             %ld double words de datos.\r\n", tam>>2);
	cprintf("  Identificador de los datos:            %s\r\n", etiqueta);
	cprintf("  Datos por linea:                       %u\r\n", lin);
	cprintf(" ---------------------------------------- -----------\r\n");
	cprintf("            Procesado                       (%3.0u\%)\r", 0);
	fseek(porg, ini, 0);
	llevo=0;
	fputs("// Fichero generado por BIN2PROG Versin 1 Revisin A\r\n", pdest);
	fputs("// (c) Copyright 1995 De trans Software\r\n", pdest);
	fputs("//                    Av. Meridiana 336, 7 C\r\n", pdest);
	fputs("//                    08027. Barcelona\r\n", pdest);
	fputs("//                    [Spain]\r\n", pdest);
	fputs("// Este programa es de dominio pblico, selo y cpielo tanto\r\n", pdest);
	fputs("// como quiera, siempre y cuando est ntegro y sin modificar\r\n", pdest);
	fprintf(pdest, "#define longitud %ldL\r\n\r\n", tam);
	if (tipo==1)
		fprintf(pdest, "new unsigned char %s[]={\r\n", strlwr (etiqueta));
	else if (tipo==2)
			fprintf(pdest, "new unsigned int %s={\r\n", strlwr (etiqueta));
	else if (tipo==4)
			fprintf(pdest, "new unsigned long int %s={\r\n", strlwr (etiqueta));
	do
	{
		for (i=0; i!=lin; i++)
		{
			if (tipo==1)
			{
				byte=fgetc(porg);
				fprintf(pdest, "%u", byte);
				llevo++;
				if (llevo<tam)
					fputs(", ", pdest);
			}
			else if (tipo==2)
			{
				word=fgetc(porg)+256*fgetc(porg);
				fprintf(pdest, "%u", word);
				llevo++;
				llevo++;
				if (llevo<tam)
					fputs(", ", pdest);
			}
			else
			{
				doubleword=fgetc(porg)+256*fgetc(porg)+65536L*fgetc(porg)+16777216L*fgetc(porg);
				fprintf(pdest, "%u", doubleword);
				llevo+=4;
				if (llevo<tam)
					fputs(", ", pdest);
			}
			if (llevo>=tam)
				break;
		}
		fputs("\r\n",pdest);
		cprintf("            Procesado                       (%3.0u\%)\r", (llevo*100)/tam);
	}
	while (llevo<tam);
			fputs("};", pdest);
	cprintf("            Procesado                       (%3.0u\%)", 100);
	fclose(porg);
	fclose(pdest);
}

/* -------------------- Convertir a Modula-2/Pascal ----------------------- */
void domod_pas(void)
{
	register unsigned char i;
	unsigned char byte;
	unsigned int word;
	unsigned long llevo;

	if (tipo==4)
	{
		textcolor(12);
		cputs("Error(06): Pascal/Modula-2 no aceptan el tipo de dato Double Word.\r\n");
		salir(6);
	}
	porg=fopen(norg, "rb");
	pdest=fopen(ndest, "wb");

	textcolor(2);
	cputs("Convirtiendo...\r\n");
	textcolor(7);
	cprintf("  Partimos del fichero binario:          %s.\r\n", norg);
	cprintf("  Generaremos el fichero en PAS/MOD:     %s.\r\n", ndest);
	cprintf("  Bytes a convertir:                     %ld (del %ld al %ld).\r\n", tam, ini, fin);
	if (tipo==1)
		cprintf("  Generando:                             %ld bytes de datos.\r\n", tam);
	else
		cprintf("  Generando:                             %ld words de datos.\r\n", tam>>1);
	cprintf("  Identificador de los datos:            %s\r\n", etiqueta);
	cprintf("  Datos por linea:                       %u\r\n", lin);
	cprintf(" ---------------------------------------- -----------\r\n");
	cprintf("            Procesado                       (%3.0u\%)\r", 0);
	fseek(porg, ini, 0);
	llevo=0;
	fputs("(* Fichero generado por BIN2PROG Versin 1 Revisin A *)\r\n", pdest);
	fputs("(* (c) Copyright 1995 De trans Software *)\r\n", pdest);
	fputs("(*                    Av. Meridiana 336, 7 C *)\r\n", pdest);
	fputs("(*                    08027. Barcelona *)\r\n", pdest);
	fputs("(*                    [Spain] *)\r\n", pdest);
	fputs("(* Este programa es de dominio pblico, selo y cpielo tanto *)\r\n", pdest);
	fputs("(* como quiera, siempre y cuando est ntegro y sin modificar *)\r\n", pdest);
	fprintf(pdest, "CONST Longitud=%ld;\r\n\r\n", tam);
	if (tipo==1)
		fprintf(pdest, "VAR %s: ARRAY[1..%ld] OF BYTE =(\r\n", etiqueta, tam);
	else if (tipo==2)
			fprintf(pdest, "VAR %s: ARRAY[1..%ld] OF WORD =(\r\n", etiqueta, tam<<1);
	do
	{
		for (i=0; i!=lin; i++)
		{
			if (tipo==1)
			{
				byte=fgetc(porg);
				fprintf(pdest, "%u", byte);
				llevo++;
				if (llevo<tam)
					fputs(", ", pdest);
			}
			else
			{
				word=fgetc(porg)+256*fgetc(porg);
				fprintf(pdest, "%u", word);
				llevo++;
				llevo++;
				if (llevo<tam)
					fputs(", ", pdest);
			}
			if (llevo>=tam)
				break;
		}
		fputs("\r\n",pdest);
		cprintf("            Procesado                       (%3.0u\%)\r", (llevo*100)/tam);
	}
	while (llevo<tam);
			fputs(");", pdest);
	cprintf("            Procesado                       (%3.0u\%)", 100);
	fclose(porg);
	fclose(pdest);
}

/* ------------------ Convertir a Basic (Estructurado) -------------------- */
void dobas(void)
{
	register unsigned char i;
	unsigned char byte;
	unsigned int word;
	unsigned long llevo;

	if (tipo==4)
	{
		textcolor(12);
		cputs("Error(07): Basic no acepta el tipo de dato Double Word.\r\n");
		salir(7);
	}
	porg=fopen(norg, "rb");
	pdest=fopen(ndest, "wb");

	textcolor(2);
	cputs("Convirtiendo...\r\n");
	textcolor(7);
	cprintf("  Partimos del fichero binario:          %s.\r\n", norg);
	cprintf("  Generaremos el fichero en BAS:         %s.\r\n", ndest);
	cprintf("  Bytes a convertir:                     %ld (del %ld al %ld).\r\n", tam, ini, fin);
	if (tipo==1)
		cprintf("  Generando:                             %ld bytes de datos.\r\n", tam);
	else
		cprintf("  Generando:                             %ld words de datos.\r\n", tam>>1);
	cprintf("  Identificador de los datos:            %s\r\n", etiqueta);
	cprintf("  Datos por linea:                       %u\r\n", lin);
	cprintf(" ---------------------------------------- -----------\r\n");
	cprintf("            Procesado                       (%3.0u\%)\r", 0);
	fseek(porg, ini, 0);
	llevo=0;
	fputs("' Fichero generado por BIN2PROG Versin 1 Revisin A\r\n", pdest);
	fputs("' (c) Copyright 1995 De trans Software\r\n", pdest);
	fputs("'                    Av. Meridiana 336, 7 C\r\n", pdest);
	fputs("'                    08027. Barcelona\r\n", pdest);
	fputs("'                    [Spain]\r\n", pdest);
	fputs("' Este programa es de dominio pblico, selo y cpielo tanto\r\n", pdest);
	fputs("' como quiera, siempre y cuando est ntegro y sin modificar\r\n", pdest);
	fprintf(pdest, "LONGITUD=%ld!\r\n\r\n", tam);
	fprintf(pdest, "DIM %s\% (%ld!)\r\n", etiqueta, tam);
	fprintf(pdest, "FOR F=1 TO %ld!\r\n", tam);
	fprintf(pdest, "READ %s\%(F)\r\n", etiqueta);
	fputs("NEXT F\r\n", pdest);
	do
	{
		fputs("DATA ",pdest);
		for (i=0; i!=lin; i++)
		{
			if (tipo==1)
			{
				byte=fgetc(porg);
				fprintf(pdest, "%u", byte);
				llevo++;
			}
			else
			{
				word=fgetc(porg)+256*fgetc(porg);
				fprintf(pdest, "%u", word);
				llevo++;
				llevo++;
			}
			if (llevo>=tam)
				break;
			else
					fputs(", ", pdest);

		}
		cprintf("            Procesado                       (%3.0u\%)\r", (llevo*100)/tam);
		fputs("\r\n", pdest);
	}
	while (llevo<tam);
	cprintf("            Procesado                       (%3.0u\%)", 100);
	fclose(porg);
	fclose(pdest);
}

/* -------------------- Convertir a fichero de texto ---------------------- */
void dotxt(void)
{
	register unsigned char i;
	unsigned char byte;
	unsigned int word;
	unsigned long doubleword;
	unsigned long llevo;

	porg=fopen(norg, "rb");
	pdest=fopen(ndest, "wb");

	textcolor(2);
	cputs("Convirtiendo...\r\n");
	textcolor(7);
	cprintf("  Partimos del fichero binario:          %s.\r\n", norg);
	cprintf("  Generaremos el fichero en TXT:         %s.\r\n", ndest);
	cprintf("  Bytes a convertir:                     %ld (del %ld al %ld).\r\n", tam, ini, fin);
	if (tipo==1)
		cprintf("  Generando:                             %ld bytes de datos.\r\n", tam);
	else if (tipo==2)
		cprintf("  Generando:                             %ld words de datos.\r\n", tam>>1);
	else
			cprintf("  Generando:                             %ld double words de datos.\r\n", tam>>2);
	cprintf("  Identificador de los datos:            %s\r\n", etiqueta);
	cprintf("  Datos por linea:                       %u\r\n", lin);
	cprintf(" ---------------------------------------- -----------\r\n");
	cprintf("            Procesado                       (%3.0u\%)\r", 0);
	fseek(porg, ini, 0);
	llevo=0;
	fputs("Fichero generado por BIN2PROG Versin 1 Revisin A\r\n", pdest);
	fputs("(c) Copyright 1995 De trans Software\r\n", pdest);
	fputs("                   Av. Meridiana 336, 7 C\r\n", pdest);
	fputs("                   08027. Barcelona\r\n", pdest);
	fputs("                   [Spain]\r\n", pdest);
	fputs("Este programa es de dominio pblico, selo y cpielo tanto\r\n", pdest);
	fputs("como quiera, siempre y cuando est ntegro y sin modificar\r\n\r\n", pdest);
	fprintf(pdest, "Longitud de los datos: %ld.\r\n", tam);
	fprintf(pdest, "Identificador:         %s.\r\n", etiqueta);
	if (tipo==1)
		fputs("Tipo:                  Byte.\r\n", pdest);
	else if (tipo==2)
		fputs("Tipo:                  Word.\r\n", pdest);
	else
		fputs("Tipo:                  Double Word.\r\n", pdest);
	do
	{
		for (i=0; i!=lin; i++)
		{
			if (tipo==1)
			{
				byte=fgetc(porg);
				fprintf(pdest, "%u", byte);
				llevo++;
			}
			else if (tipo==2)
			{
				word=fgetc(porg)+256*fgetc(porg);
				fprintf(pdest, "%u", word);
				llevo++;
				llevo++;
			}
			else
			{
				doubleword=fgetc(porg)+256*fgetc(porg)+65536L*fgetc(porg)+16777216L*fgetc(porg);
				fprintf(pdest, "%u", doubleword);
				llevo+=4;
			}
			if (llevo>=tam)
				break;
			else
				fputs(", ", pdest);
		}
		cprintf("            Procesado                       (%3.0u\%)\r", (llevo*100)/tam);
		fputs("\r\n", pdest);
	}
	while (llevo<tam);
	cprintf("            Procesado                       (%3.0u\%)", 100);
	fclose(porg);
	fclose(pdest);
}

/* -------------------- Convertir a fichero de datos ---------------------- */
void dodat(void)
{
	register unsigned char i;
	unsigned char byte;
	unsigned long llevo;

	if (tipo!=1)
	{
		textcolor(12);
		cputs("Error(08): Los ficheros de datos slo aceptan el tipo Byte.\r\n");
		salir(8);
	}

	porg=fopen(norg, "rb");
	pdest=fopen(ndest, "wb");

	textcolor(2);
	cputs("Convirtiendo...\r\n");
	textcolor(7);
	cprintf("  Partimos del fichero binario:          %s.\r\n", norg);
	cprintf("  Generaremos el fichero en TXT:         %s.\r\n", ndest);
	cprintf("  Bytes a convertir:                     %ld (del %ld al %ld).\r\n", tam, ini, fin);
	cprintf("  Generando:                             %ld bytes de datos.\r\n", tam);
	cprintf("  Identificador de los datos:            %s\r\n", etiqueta);
	cprintf("  Datos por linea:                       %u\r\n", lin);
	cprintf(" ---------------------------------------- -----------\r\n");
	cprintf("            Procesado                       (%3.0u\%)\r", 0);
	fseek(porg, ini, 0);
	llevo=0;
	do
	{
		for (i=0; i!=lin; i++)
		{
			byte=fgetc(porg);
			fprintf(pdest, "%u\r\n", byte);
			llevo++;
			if (llevo>=tam)
				break;
		}
		cprintf("            Procesado                       (%3.0u\%)\r", (llevo*100)/tam);
	}
	while (llevo<tam);
	cprintf("            Procesado                       (%3.0u\%)", 100);
	fclose(porg);
	fclose(pdest);
}

/* ------------------------- Convertir a Listado -------------------------- */
void dolis(void)
{
	register unsigned char i;
	unsigned char byte;
	unsigned int linea=0, inst;
	unsigned long llevo, check=0;

	if (tipo!=1)
	{
		textcolor(12);
		cputs("Alarma(03): Ignorado el tipo de dato especificado, se asume Byte.\r\n");
		tipo=1;
	}
	if (lin!=8)
	{
		textcolor(12);
		cputs("Alarma(04): Ignorados los datos por linea, se asumen 8.\r\n");
		lin=8;
	}
	porg=fopen(norg, "rb");
	textcolor(2);
	cputs("Analizando...\r\n");
	for (llevo=ini; llevo!=fin; llevo++)
		check+=fgetc(porg);
	fclose(porg);
	porg=fopen(norg, "rb");
	pdest=fopen(ndest, "wb");
	cputs("Convirtiendo...\r\n");
	textcolor(7);
	cprintf("  Partimos del fichero binario:          %s.\r\n", norg);
	cprintf("  Generaremos el fichero en LIS:         %s.\r\n", ndest);
	cprintf("  Bytes a convertir:                     %ld (del %ld al %ld).\r\n", tam, ini, fin);
	cprintf("  Generando:                             %ld bytes de datos.\r\n", tam);
	cprintf("  Identificador de los datos:            %s\r\n", etiqueta);
	cprintf("  Datos por linea:                       %u\r\n", lin);
	cprintf(" ---------------------------------------- -----------\r\n");
	cprintf("            Procesado                       (%3.0u\%)\r", 0);
	fseek(porg, ini, 0);
	llevo=0;
	fputs("10 PRINT\"Fichero generado por BIN2PROG Versin 1 Revisin A\"\r\n", pdest);
	fputs("20 PRINT\"(c) Copyright 1995 De trans Software\"\r\n", pdest);
	fputs("30 PRINT\"                   Av. Meridiana 336, 7 C\"\r\n", pdest);
	fputs("40 PRINT\"                   08027. Barcelona\"\r\n", pdest);
	fputs("50 PRINT\"                   [Spain]\"\r\n", pdest);
	fputs("60 PRINT\"Este programa es de dominio pblico, selo y cpielo tanto\"\r\n", pdest);
	fputs("70 PRINT\"como quiera, siempre y cuando est ntegro y sin modificar\"\r\n", pdest);
	fprintf(pdest,"80 COLOR 2:PRINT \"Creando %s...\"\r\n",norg);
	fputs("90 COLOR 7:PRINT\"        Procesado.\";\r\n", pdest);
	fprintf(pdest, "100 OPEN \"O\",#1, \"%s\", 1024\r\n", norg);
	fputs("110 CHECKSUM!=0\r\n", pdest);
	fprintf(pdest, "120 FOR I!=1 TO %ld!\r\n",(tam/8)+1);
	fputs("130 LINSUM%=0\r\n", pdest);
	fprintf(pdest, "140 LOCATE ,1,:PRINT INT((I!*800)/%ld);\"\%\";\r\n",tam);
	fputs("150 FOR J\%=1 TO 8\r\n", pdest);
	fputs("160 READ BYTE\%\r\n", pdest);
	fputs("170 LINSUM\%=LINSUM\%+BYTE\%\r\n", pdest);
	fputs("180 PRINT #1,CHR$(BYTE\%);\r\n", pdest);
	fputs("190 NEXT J\%\r\n", pdest);
	fputs("200 CHECKSUM!=CHECKSUM!+LINSUM\%\r\n", pdest);
	fputs("210 READ SUMA\%\r\n", pdest);
	fputs("220 IF SUMA\%<>LINSUM\% THEN PRINT \"Error en DATA\";1000+10*I!\r\n",pdest);
	fputs("230 NEXT I!\r\n", pdest);
	fputs("240 CLOSE #1:PRINT\r\n", pdest);
	fprintf(pdest, "250 IF CHECKSUM!=%ld!  THEN PRINT\"Todo ha ido correctamente\":END\r\n", check);
	fputs("260 PRINT \"Error(99): El fichero generado puede no ser correcto.\"\r\n",pdest);
	fputs("270 REM DATAS A PARTIR DE LA LINEA 1000 (INCLUSIVE) Y CON PASOS DE LINEA DE\r\n", pdest);
	fputs("280 REM 10 EN 10\r\n", pdest);
	inst=1000;
	do
	{
		fprintf(pdest, "%u DATA ",inst);
		linea=0;
		for (i=0; i!=8; i++)
		{
				byte=fgetc(porg);
				linea+=byte;
				fprintf(pdest, "%u", byte);
				llevo++;
				if (llevo>=tam)
					break;
				else
					fputs(", ", pdest);
		}
		fprintf(pdest, "%u\r\n",linea);
		inst+=10;
		cprintf("            Procesado                       (%3.0u\%)\r", (llevo*100)/tam);
	}
	while (llevo<tam);
	fprintf(pdest, "%u DATA 0, 0, 0, 0, 0, 0, 0, 0, 0\r\n", inst);
	cprintf("            Procesado                       (%3.0u\%)", 100);
	fclose(porg);
	fclose(pdest);
}


void ayuda(void)
{
}


/* --------------------------- Salida al DOS ------------------------------ */
void salir(unsigned char e)
{
	cputs("\r\n\r\n");
	if (e==0)
	{
		textcolor(2);
		cputs("Todo ha concluido sin errores.\r\n");
	}
	textattr(7);
	fcloseall();
	exit(e);
}

/* ------------------------ Copyright y todo eso -------------------------- */
void cabecera(char *tray)
{
	textcolor(3);
	cputs("\r\n\n\r");
	cputs("            (c) Copyright 1994-1995 ");
	textcolor(11);
	cputs("De Trans Software\n\r");
	textcolor(3);
	cputs("                          Bin To Program  Versin 1 Revisin b\r\n");
	cputs("                 \n\r");
	cputs("                     Conversor de ficheros binarios a lenguajes de\r\n");
	cputs("                            programacin.\r\n");
	textcolor(3);
	cputs("\n\r");
	textcolor(3);
	if (haywinenh())
		cputs("[Windows]");
	else if (hayos2())
		cputs("[OS/2]");
	else
		cprintf("[DOS %u.%02u]", _osmajor, _osminor);
	textcolor(11);
	cprintf(" Dominio Pblico. Ayuda: %s /?\r\n\r\n", tray);
}

/* ------------------------ 1 si existe, 0 si no -------------------------- */
unsigned char existe(char *fich)
{
	FILE *flu;

	flu=fopen(fich, "rb");
	if (flu!=0)
		fclose(flu);
	return(flu);
}

/* ------------------ Mira si est corriendo bajo OS/2 -------------------- */
unsigned char hayos2(void)   /* Devolver 1 si corriendo bajo OS/2 */
{
	if (_osmajor>=3)
	{
		_AX=0x4010;
		geninterrupt(0x2F);
		return (_AX!=0x4010);
	}
	else
		return(0);   /* DOS 2.X, evitar llamada a INT 2Fh */
}

/* ------------ Mira si est corriendo bajo Windows Enhaced --------------- */
unsigned char haywinenh(void)   /* Devolver versin de Windows Enhanced */
{
	if (_osmajor>=3)
	{
		_AX=0x1600;
		geninterrupt(0x2F);
		if (!_AL)
			_AH=0;
		return ((_AL<< 8)|_AH);
	}
	else
		return(0);   /* DOS 2.X, evitar llamada a INT 2Fh */
}

