/*
					Biblioteca de funciones de acceso a ficheros indexados.

					v1.0: Guti escribe indexar, iopen, igets, check32.
					v1.1: Guti optimiza las funciones, y aparecen problemas misteriosos.

Si de iopen, quito la variable i, me peta el programa con el mensaje de no
encontr el tema, y si lo dejo, Turbo C me da el warning, de que he
declarado una variable que no uso.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *iopen (char *, char *, char *);
int indexar (char *, char *);
unsigned long check32 (char *);
void quitacrlf (char *);
void igets(char *, register int, FILE *);
int iload(char *, char *, char *, char[71][]);

/* --------------------------------------------------------------------------
	 Abre el fichero ndice, busca la clave, cierra el ndice, y abre el
	 orgen por donde est la clave.

	 Devuelve: 0 si hay algn error.
						 Un puntero al fichero orgen si no hay error
	 --------------------------------------------------------------------------
*/
FILE *iopen (char *norg, char *nidx, char *clave)
{
	FILE *lorg, *lidx;
	char linea[80];
	unsigned long int posicion;

	lidx=fopen(nidx, "rb");
	if (lidx==0)
	{
		puts("Error al abrir IDX");
		return (0);			/* No encontr el archivo ndice */
	}
	for (;;)
	{
		igets(linea, 79, lidx);
		if (strcmp (linea, clave)==0)
		{
			igets(linea, 79, lidx);
			posicion=atol(linea);
			fclose(lidx);
			if (posicion==0)
			{
				puts("Posicion es 0");
				return (0);
			}
			lorg=fopen(norg, "rb");
			if (lorg==0)
			{
				puts("Error al abrir ORG");
				return (0);		/* No encontr el archivo orgen */
			}
			fseek(lorg, posicion, SEEK_SET);
			return (lorg);
		}
		if (strcmp (linea, "|FIN")==0)
		{
			fclose(lidx);
			puts("No encontr el tema");
			return(0);
		}
	}
}

/* --------------------------------------------------------------------------
	 Indexa el fichero org, y guarda el resultado de la indexacin en idx

	 Devuelve: 0 si no hay ningn error.
	 --------------------------------------------------------------------------
*/
int indexar (char *norg, char *nidx)
{
	FILE *lidx, *lorg;
	char linea[80];    

	lorg=fopen(norg,"rb");
	if (lorg==0)
		return(1);
	lidx=fopen(nidx,"wb");
	if (lidx==0)
	{
		return(2);
	}
	fprintf(lidx,"Indices de SSI v1.01. (c) 1995 Swap Software Incorporated (SSI)\27\r\n");
	fprintf(lidx,"|INICIO\r\n");
	fprintf(lidx,"@IDX\r\n");
	fprintf(lidx,"%lu\r\n", filelength(fileno(lorg)));

	fprintf(lidx,"%lu\r\n",check32("c:\\tc\\c\\opti\\opti.pak"));

	lorg=fopen(norg,"rb");
	while (feof(lorg)==0)
	{
		fgets(linea,79,lorg);
		if ((linea[0]=='@') && (strlen(linea)>4))
		{
			fprintf(lidx,"%s%lu\r\n",linea, ftell(lorg));
		}
	}
	fprintf(lidx,"|FIN");
	fclose(lorg);
	fclose(lidx);
	return(0);
}

/* --------------------------------------------------------------------------
	 Calcula el checksum de 32 bits para el fichero org.

	 Devuelve: 0 si hay algn error.
	 --------------------------------------------------------------------------
*/
unsigned long check32 (char *norg)
{
	FILE *lorg;
	char borg[8193];
	unsigned long c32;
	register unsigned int i;

	c32=0;
	lorg=fopen(norg,"rb");
	if (lorg==0)
		return(0);
	while (fread(borg,1,8192,lorg)==8192)
	{
		for (i=0;i!=8192;i++)
			c32+=borg[i];
	}
	fclose(lorg);
	return(c32);
}

void quitacrlf(char *cadena)
{
	register unsigned int i;

	i=0;
	while (cadena[i]!=0)
	{
		if ((cadena[i]=='\r') || (cadena[i]=='\n'))
		{
			cadena[i]=0;
		}
		i++;
	}
}

void igets(char *linea, register int num, FILE *lfich)
{
	register unsigned int i;

	fgets(linea, num, lfich);
	i=0;
	while (linea[i]!=0)
	{
		if ((linea[i]=='\r') || (linea[i]=='\n'))
		{
			linea[i]=0;
		}
		i++;
	}
}

int iload(char *norg, char *nidx, char *tema, char buffer[][71])
{
	register unsigned int i=0;
	FILE *lorg;

//	i=0;
	lorg=iopen(norg, nidx, tema);
	if (lorg==0)
		return(0);
	for (;;)
	{
		igets(&buffer[i], 70, lorg);
		if (buffer[i][71]=='@')
			break;
		i++;
	}
	fclose(lorg);
	return(i);
}



