/*
					Biblioteca de funciones variadas.

					v0.9: Guti escribe optimiza, y la introduce en esta biblioteca.
					v1.0: Guti incorpora algunas rutinas interesantes del 2M.
*/

#include <stdio.h>
#include <dos.h>

int existevga(void);
int hay2m3(void);
int enos2(void);
int eswinenh(void);
void optimiza(void);
void antidebug(void);

int existevga()
{
  union REGS r;

  r.x.ax=0x1A00; int86 (0x10, &r, &r);
  return ((r.x.ax & 0xFF)==0x1A);
}

int hay2m3()     /* devolver 1 si 2M 3.X est instalado */
{
  int entrada, instalado=0;
	union REGS r; struct SREGS s;

  for (entrada=0xc0; (entrada<=0xff) && (!instalado); entrada++) {
    r.x.ax=entrada << 8; s.es=0x1492; r.x.di=0x1992;
    int86x (0x2f, &r, &r, &s);
    if (r.x.ax==0xFFFF)
      if ((peek(s.es,r.x.di-4)==9002) && (peek(s.es,r.x.di-2)==10787))
	if (strstr (MK_FP(s.es, r.x.di),"2M:3.")) instalado=1;
	if (strstr (MK_FP(s.es, r.x.di),"2MX:3.")) instalado=1;
    }
	return (instalado);
}

int esos2 (void)   /* Devolver 1 si corriendo bajo OS/2 */
{
  union REGS r;

  if (_osmajor >= 3) {
			r.x.ax=0x4010;
      int86 (0x2F, &r, &r);
      return (r.x.ax != 0x4010);
      }
    else return (0);   /* DOS 2.X, evitar llamada a INT 2Fh */
}


int eswinenh (void)   /* Devolver versin de Windows Enhanced */
{
	union REGS r;

  if (_osmajor >= 3) {
      r.x.ax=0x1600;
      int86 (0x2F, &r, &r);
      if (!r.h.al) r.h.ah=0;
      return ((r.h.al << 8) | r.h.ah);
      }
		else return (0);   /* DOS 2.X, evitar llamada a INT 2Fh */
}

void optimiza (void)
{
	setverify(0);
	setcbrk(0);
	outportb (0x43, 0x74);
	outportb (0x41, 80);			/* Menos significativo */
	outportb (0x41, 0);				/* Ms significativo */
}

void antidebug (void)
{
	union REGS r;
	
	int86(0x3,&r,&r);											/* Ejecuta la interrupcin 03h */
	outportb (0x21,128);									/* Debera petar el debug      */
	r.h.al=1;
	int86(0x21,&r,&r);										/* Desactiva la Int 1h         */
	int86(0x3,&r,&r);											/* Ejecuta la interrupcin 03h */
}