/*                                                                         */
/*  HEACOM.C    Versin 1 Revision 04                                      */
/*  Es el mdulo que va al principio de fichero .COM para aplicar los      */
/*  parches.                                                               */
/*                                                                         */
/*  Usar modelo de memoria LARGE. Optimizaciones para tamao               */
/*                                                                         */

#pragma option -1-
#pragma option -ml
#pragma option -O1
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>
#include <io.h>
#include <dir.h>
//#define COMERCIAL

extern unsigned int _stklen=2048;		/* 2K de pila para reducir el tamao */

void _fastcall copyright(char *);
void _fastcall ayuda(void);
void _fastcall salir(unsigned char);
void _fastcall openfiles (char *);
void _fastcall undiff0 (void);
void _fastcall calccrc(unsigned char comp);
unsigned int pascal memstr1 (unsigned char *, unsigned char *, unsigned int, unsigned int);
void _fastcall closefiles(void);

struct patch
{
	char ini[16];													// ini -> Marca Exe
	unsigned char marca;									// Marca Fichero Path
	unsigned int ver;
	unsigned char encriptado;
	char comment[255];
};

struct diff
{
	unsigned char marca;
	unsigned int  ver;
	char viejo[80];
	char nuevo[80];
	unsigned long lold;
	unsigned long lnew;
	unsigned long cold;
	unsigned long cnew;
	unsigned int date;
	unsigned int time;
	unsigned char attrib;
	unsigned long int longa;
	unsigned int buftam;
	unsigned int chunk;
};

unsigned char *bold, *bnew, *bpatch;
FILE *pold, *pnew, *ppatch;
struct patch p;
struct diff d;
char nold[14], nnew[14], npatch[14], pass[17];
char ext[5], fpatch[80], nada[128];


void main (unsigned char argc, char *argv[])
{
	copyright(argv[0]);
	if (memcmp(argv[1], "/?", 2)==0)
		ayuda();

	/* Instala mi interrupcin de Ctrl-Break */
//	setcbrk(1);
//	ctrlbrk(c_break);

	openfiles(argv[0]);
	undiff0();
	salir(0);
}

/* ------------------ Escribe el copyright del programa ------------------- */
void _fastcall copyright (char *ruta)
{
	char nombre[9], nada[80];

	fnsplit(ruta, nada, nada, nombre, nada);
  cputs("\r\nPatch Run-Time v1.04   (c) Copyright 1995-1997 by De Trans Software (D.T.S.)\r\n");
	#ifdef COMERCIAL
    cprintf("Registered version. Type %s /? if you need help.\r\n", nombre);
	#endif
	#ifndef COMERCIAL
    cprintf("Shareware version. Type %s /? if you need help.\r\n", nombre);
	#endif
}

/* ---------- Sale devolviendo un errorlevel, y con un mensajito ---------- */
void _fastcall salir (unsigned char n)
{
	cputs("\r\n");
	if (n==0)
		cputs("Everything went O.k.\r\n");
	else if (n==1)
		cputs("Error(01): Can't open PAT file.\r\n");
	else if (n==2)
		cputs("Error(02): Newer version of PATCH requiered.\r\n");
	else if (n==3)
		cputs("Error(03): Not enougth memory for allocating NEW buffer.\r\n");
	else if (n==5)
		cputs("Error(05): Not enougth memory for allocating PAT buffer.\r\n");
	else if (n==6)
		cputs("Error(06): Not enougth memory for allocating OLD buffer.\r\n");
	else if (n==7)
		cputs("Error(07): Not a valid PAT file.\r\n");
	else if (n==8)
		cputs("Error(08): Bad version of OLD file.\r\n");
	else if (n==9)
		cputs("Error(09): New file is damaged.\r\n");
	else if (n==10)
		cputs("Error(10): Can't open OLD file.\r\n");
	else if (n==11)
		cputs("Error(11): Can't create NEW file.\r\n");
	else if (n==12)
  {
		if (p.encriptado)
      cputs("Error(12): Wrong password or damaged PAT.\r\n");
		else
			cputs("Error(12): Damaged PAT.\r\n");
	}
	cputs("\r\n");
	exit(n);
}

/* ----------------- Lee la cabecera, y abre los ficheros ----------------- */
void _fastcall openfiles (char *fp)
{
	register unsigned int i;
	char aux[17];

	/* Pasa los parmetros a variables de la funcin */
	strcpy(fpatch, fp);

	/* Si no tienen extensiones, pon las extensiones por defecto */
	if (strchr(fpatch, '.')==0)
		strcat(fpatch, ".PAT");

	/* Pasa los ficheros a maysculas */
	strupr(fpatch);

	/* Consigue los nombres de los ficheros, sin trayectorias ni nada */
	fnsplit(fpatch, nada, nada, npatch, ext);
	strcat(npatch, ext);

	bold=malloc(60000U);
	if (bold==0)
		salir(6);
	bnew=malloc(60000U);
	if (bnew==0)
	{
		free(bold);
		salir(3);
	}
	bpatch=malloc(60000U);
	if (bpatch==0)
	{
		free(bold);
		free(bnew);
		salir(5);
	}
	ppatch=fopen(fpatch, "rb");
	if (ppatch==NULL)
		salir(1);

	i=fread(bpatch, 1, 20000U, ppatch);           // Por si es un exe.
	i=memstr1(bpatch, "Patch by D.T", i, 12);
	fseek(ppatch, (long) i, 0);

	if ((fread(&p, 1, sizeof(struct patch), ppatch))!=sizeof(struct patch))
		salir(7);

	if ((strcmp(p.ini, "Patch by D.T.S."))!=0)
		salir(7);

	if (p.marca!=2)
		salir(7);

	if (p.ver>109)
		salir(2);

  if (p.comment[254]=='S')
  {
    textattr(7+128);
    cputs("Patch created with the Shareware version of Patch Package!\r\n");
    cputs("Please don't distribute it.\r\n");
  }
  else if (p.comment[254]!='R')
    salir(7);

  cputs("\r\n");
	if (strlen(p.comment)>0)
	{
		printf("%s\r\n\r\n", p.comment);
	}

	if (p.encriptado)
	{
		cputs("\n\rInput password: ");
		aux[0]=16;
		cgets(aux);
		strcpy(pass, &aux[2]);
		strupr(pass);
	}
	else
		strcpy(pass, "D.T.S.");
}

/* ------------ Calcula el CRC-32 del fichero nuevo, o del viejo ---------- */
void _fastcall calccrc(unsigned char comp)
{
	register unsigned int i, leidos;
	unsigned long int aux;							// llevo
  unsigned char *tmp;

	if (comp==1)
	{
		rewind(pold);
		aux=0;
		do
		{
			leidos=fread(bold, 1, d.buftam, pold);
      tmp=bold;
			for (i=0; i!=leidos; i++)
      {
        aux+=*tmp;
        tmp++;
      }
		}
		while (leidos==d.buftam);
    if (aux!=d.cold)
			salir(8);
		rewind(pold);
	}
	else
	{
		rewind(pnew);
		aux=0;
		do
		{
			leidos=fread(bnew, 1, d.buftam, pnew);
      tmp=bnew;
			for (i=0; i!=leidos; i++)
      {
        aux+=*tmp;
        tmp++;
      }
		}
		while (leidos==d.buftam);
    if (aux!=d.cnew)
			salir(9);
	}
}

/* --------------------------- Aplica el PAT/EXE -------------------------- */
void _fastcall undiff0 (void)
{
  register unsigned int j=0;
	register unsigned char pi=0, files=0;
	unsigned char lenght;
	unsigned char push;
	int k=0;
	unsigned int leidos, leidos2, i=0;
	unsigned int iold=0, inew=0;
	char aux[80];

	do
	{
		if ((fread(&d, 1, sizeof(struct diff), ppatch)!=sizeof(struct diff)))
			salir(8);
		files++;
		if (d.marca!=1)
		{
			if (j==0xFFFF)
				salir(7);
			if (files!=0)
			{
				rewind(ppatch);
				fread(bpatch, 1, 20000U, ppatch);
				j=memstr1(bpatch, "Patch by D.T.", 20000U, 12);
				if (j==0xFFFF)
					salir(7);
				fseek(ppatch, (long) j, 0);
				fread(&p, 1, sizeof (struct patch), ppatch);
				pi=1;
				do
				{
					fread(&d, 1, sizeof(struct diff), ppatch);
					fseek(ppatch, (long) d.longa, 1);
					pi++;
				}
				while (pi<files);
				j=0xFFFF;
				continue;
			}
			else
				salir(7);
		}
		if (d.ver>109)
			salir(2);
    fnsplit(d.viejo, nada, nada, nold, ext);
		strcat(nold, ext);
		fnsplit(d.nuevo, nada, nada, nnew, ext);
		strcat(nnew, ext);

		pold=fopen(d.viejo, "rb");
		if (pold==NULL)
			salir(10);

		pnew=fopen(d.nuevo, "wb+");
		if (pnew==NULL)
			salir(11);

		if (filelength(fileno(pold))!=d.lold)
			salir(8);

    cprintf("\r\nPass 1: %12s (Calculating CRC).", nold);
		calccrc(1);
    cprintf("\r\nPass 2: %12s (Creating).", nnew);
    memset(bpatch, 0, (d.buftam<<1));

		leidos2=d.buftam;
		leidos=d.buftam<<1;
		lenght=strlen(pass)-1;
		pi=1;
		do
		{
			if (leidos2==d.buftam)
				leidos2=fread(bold, 1, d.buftam, pold);
      if (leidos==(d.buftam<<1))
			{
				leidos=fread(bpatch, 1, d.buftam<<1, ppatch);		// Arreglo 1
				i=0;
			}
			else
				i++;
			inew=0;
			do
			{
				push=bpatch[i] ^ pass[pi];
				switch (push)
				{
					case 1:
						i++;
						for (j=0; j!=d.chunk; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&bnew[inew], &bpatch[i], d.chunk);

						i=i+(d.chunk);

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 2:
						i++;
						for (j=0; j!=2; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&iold, &bpatch[i], 2);
						memcpy(&bnew[inew], &bold[iold], d.chunk);
						i+=2;

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;

					case 3:
						fwrite(bnew, 1, inew, pnew);

						k=(leidos-i)-1;
						fseek(ppatch, (long) -k, 1);
						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 4:
						fwrite(bnew, 1, inew, pnew);
						for (j=i+1; j!=leidos; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[j]=bpatch[j]^pass[pi];
						}
						i++;
						memcpy(&iold, &bpatch[i], 2);
						i+=2;
						fwrite(&bpatch[i], 1, iold, pnew);
						k=leidos-(i+iold);
						k--;
						fseek(ppatch, (long) -k, 1);
						break;

					default:
						closefiles();
						salir(12);
				}
				inew+=d.chunk;
			}
			while (push!=3 && push!=4);
		}
		while (push!=4);
		if ((i+d.chunk)>=leidos)
			push=0;
    fclose(pold);
		fflush(pnew);
		if (filelength(fileno(pnew))!=d.lnew)
			salir(9);
    cprintf("\r\nPass 3: %12s (Calculating CRC).", nnew);
		calccrc(2);
    _dos_setftime(fileno(pnew), d.date, d.time);
		fclose(pnew);
		if (memcmp(nnew, "_SAME_", 6)==0)
		{
			strcpy(aux, nold);
			aux[strlen(aux)-1]='~';
			rename(nold, aux);
			rename(nnew, nold);
		}
		_dos_setfileattr(d.nuevo, d.attrib);
    cputs("\r\n\r\n");
	}
	while (push!=0);
	closefiles();
}

/* ---- Busca en una regin de memoria de longitud ldest la cadena org ---- */
unsigned int pascal memstr1 (unsigned char *dest, unsigned char *org, unsigned int ldest, unsigned int lorg)
{
	/* ptro ->       DS:SI */
	/* ptrd ->       ES:DI */
	/* ptra ->       ES:BX optimizacin en ES:BX, pues ptrd y ptra comparten el mismo segmento */
	/* ldest ->      AX */
	/* lorg ->       DX */
	/* Temporales -> CL */
	/*               CX */

	asm {
		push		ds
		mov			dx, lorg
		/* ptrd=(unsigned char *) dest; */
		les     di, dest
		/* ldest=ldest+(unsigned int) ptrd; */
		mov     ax, ldest
		add     ax, di
		/* while (ptrd!=(unsigned char *)ldest) */
	}
while1:
	asm {
		cmp     ax, di
		je      endwhile1
		/* { */
		/* ptro=org; */
		lds     si, org
		/* ptra=ptrd; */
		mov		 	bx, di
		/* while (*ptra==*ptro) */
	}
while2:
	asm {
		mov     cx, es:[bx]
		cmp     cx, ds:[si]
		jne     endwhile2
		/* { */
		/* if (ptra>(unsigned char *) ldest) */
	}
if1:
	asm {
		cmp			ax, bx
		jg			else1
	}
then1:
	asm {
		pop			ds
	}
	/* return (0xFFFF); */
	return(0xFFFF);
else1:
	asm {
		/* ptra++; */
		inc			bx
		inc			bx
		/* ptro++; */
		inc			si
		inc			si
		/* if ((ptra-ptrd)==lorg) */
	}
if2:
	asm {
		mov     cx, bx
		sub     cx, di
		cmp     cx, dx
		jne     else2
	}
then2:
	asm {
		pop			ds
	}
	/* return ((unsigned int)(((ptra-4)-lorg))); */
	return ((unsigned int)(((_BX-4)-lorg)));
	/* } */
else2:
	asm {
		jmp     while2
	}
endwhile2:
	asm {
		 /* ptrd++; */
		inc		di
		/* } */
		jmp     while1
	}
endwhile1:
	asm {
		pop			ds
	}
	/* return (0xFFFF); */
	return(0xFFFF);
}

/* --------------------- Chapa ficheros, y libera memoria ----------------- */
void _fastcall closefiles (void)
{
	free(bold);
	free(bnew);
	free(bpatch);
  fclose(pold);
  fclose(pnew);
  fclose(ppatch);
}

/* --------------------- Muestra la ayuda por pantalla -------------------- */
void _fastcall ayuda (void)
{
  cputs("\r\n  Patch Run-Time, allows you to aply patches created by DIFF in a stand-alone\r\n");
	cputs("way, it means that the patches for upgrading versions of software are\r\n");
	cputs("self extractables.\r\n\r\n");
	#ifdef COMERCIAL
		cputs("  This is the registered version of Patch Run-Time, so, please, don't\r\n");
		cputs("distribute this program. Thank you for registering.\r\n\r\n");
		cputs("  You are allowed to distribute files that use PATCH package due of having\r\n");
		cputs("the registered version.\r\n\r\n");
		cputs("  If you have questions, or suggestions, please write to:\r\n\r\n");
	#endif
	#ifndef COMERCIAL
		cputs("  You are not allowed to distribute files that use PATCH package due of\r\n");
		cputs("having the shareware version.\r\n\r\n");
		cputs("  If you want to distribute files that use PATCH, you must register\r\n");
		cputs("by sending 2500 Ptas or 25 US$ to us, and you will receive the latest\r\n");
		cputs("registered version available, and a written permission for using PATCH.\r\n\r\n");
		cputs("  If you want to register, have questions, or suggestions, please write to:\r\n\r\n");
	#endif
	cputs("                    De Trans Software (DTS)\r\n");
	cputs("                    Javier Gutirrez Chamorro\r\n");
	cputs("                    Av. Meridiana 336, 7 C\r\n");
  cputs("                    08027. Barcelona. [SPAIN]");
	salir(200);
}

