/*                                                                         */
/*  INFOPAT.C   Versin 1 Revision 04                                      */
/*  Informa sobre el contenido de un fichero PAT o EXE.                    */
/*                                                                         */
/*  Usar modelo de memoria LARGE. Optimizaciones para velocidad            */
/*                                                                         */
/* Usando Turbo C v2.0, requiere que le reste 4 a la posicin donde
	 encuentra la marca, en principio con Borland C++ v4.0, esto no haca
	 falta */

#pragma option -1-
#pragma option -ml
#pragma option -O2
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <io.h>
#include <dir.h>
//#define COMERCIAL

struct patch
{
	char ini[16];
	unsigned char marca;
	unsigned int ver;
	unsigned char encriptado;
	char comment[255];
};

struct diff
{
	unsigned char marca;
	unsigned int ver;
	char viejo[80];
	char nuevo[80];
	unsigned long lold;
	unsigned long lnew;
	unsigned long cold;
	unsigned long cnew;
	unsigned int date;
	unsigned int time;
	unsigned char attrib;
	unsigned long int longa;
	unsigned int buftam;
	unsigned int chunk;
};

void _fastcall copyright (char *);
void _fastcall ayuda(void);
void _fastcall salir (unsigned char);
void _fastcall doit(void);
unsigned int pascal memstr1 (unsigned char *, unsigned char *, unsigned int, unsigned int);


FILE *pf;
struct patch p;
struct diff d;
char nf[80];

void main (unsigned char argc, char *argv[])
{
  register unsigned char fast;
  register unsigned int i;

  fast=0;
  for (i=1; i!=argc; i++)
  {
    if (memcmp(argv[i], "/.", 2)==0)
      fast++;
  }
  if (fast==0)
    copyright(strupr(argv[0]));
	if (memcmp(argv[1], "/?", 2)==0)
  	ayuda();
	if (argc<2)
		salir(1);
	strcpy(nf, argv[1]);
	strupr(nf);
	if (strchr(nf, '.')==0)
		strcat(nf, ".PAT");
	doit();
  if (fast==0)
    salir(0);
  else
    salir(200);
}

/* ------------------ Escribe el copyright del programa ------------------- */
void _fastcall copyright (char *ruta)
{
	char nada[80], nombre[9];

	fnsplit(ruta, nada, nada, nombre, nada);
	puts("\n");
  puts("            (c) Copyright 1995-1997 De Trans Software");
  puts("                              INFOPAT Version 1 Revision 04");
	puts("                ");
	puts("                            Fast and reliable Patch informer");
	puts("                      suporting .PAT and .EXE.");
	puts("");
	#ifdef COMERCIAL
    printf("Registered version. ");
	#endif
	#ifndef COMERCIAL
    printf("Shareware version. ");
	#endif
	printf("Type %s /? if you need help.\n", nombre);
}

/* ---------- Sale devolviendo un errorlevel, y con un mensajito ---------- */
void _fastcall salir (unsigned char n)
{
	puts("");
	if (n==0)
		puts("Everything went O.k.\n");
	else if (n==1)
		puts("Error(01): Wrong number of arguments.\n");
	else if (n==2)
		printf("Error(02): Error opening %s.\n", nf);
  else if (n==3)
		printf("Error(03): File %s is damaged or is not a valid Patch.\n", nf);
  else if (n==4)
		printf("Error(04): Unknown format for file %s.\n", nf);
	else if (n==5)
		puts("Error(05): Can't allocate buffer.\n");
  else if (n==200)
    puts("");
	puts("");
	exit(n);
}

/* ---------------------- Realiza todo el proceso ------------------------- */
void _fastcall doit(void)
{
  register unsigned char ratio, tratio;
	register unsigned int tfiles;
  char com, pas;
	unsigned char met, dif;
	unsigned int i;
	unsigned char *bf;
  long tpacked, tsize;
  char nada[80], nombre[15], ext[4];

	fnsplit(nf, nada, nada, nombre, nada);

	printf("\nScanning %s.\n\n", nf);
	pf=fopen(nf, "rb");
	if (pf==0)
		salir(2);

	bf=malloc(20000);
	if (bf==0)
		salir(5);

	i=fread(bf, 1, 20000, pf);
	i=memstr1(bf, "Patch by D.T.S.", i, 15);
	fseek(pf, (long) i, 0);
	free(bf);

	if ((fread(&p, 1, sizeof (struct patch), pf))!=sizeof(struct patch))
		salir(3);
	if ((strcmp(p.ini, "Patch by D.T.S."))!=0)
		salir(3);
	if (p.marca!=2)
		salir(3);
	if (p.encriptado)
		pas='';
	else
		pas=' ';
	if (p.comment)
		com='';
	else
		com=' ';
	puts("Ŀ");
	puts("     Name         Size       Packed    Ratio   CRC-32   CPMD  Ver. ");
	puts("Ĵ");
	/* Si tiene un mdulo autoextraible */
	if (i>20)
	{
    printf(" %12s  %10ld  %10ld   %3u%%           ", "<PATCH SFX>", (long) i, (long) i, 100);
		printf("       %u.%02u \n", p.ver/100, p.ver%100);
		tfiles=1;
		tsize=i;
		tpacked=i;
	}
	else
	{
		tfiles=0;
		tsize=0;
		tpacked=0;
	}
	do
	{
		fread(&d, 1, sizeof(struct diff), pf);
		if (d.marca!=1)
		{
			fclose(pf);
			salir(3);
		}
		if (d.ver>109)
		{
			fclose(pf);
			salir(4);
		}
		if (memcmp(d.nuevo, "_SAME_", 6)==0)
		{
			fnsplit(d.viejo, nada, nada, nombre, ext);
			strcat (nombre, ext);
		}
		else
		{
			fnsplit(d.nuevo, nada, nada, nombre, ext);
			strcat (nombre, ext);
		}
		ratio=(d.longa*100)/d.lnew;
		if (ratio>100)
			ratio=100;
		else if (ratio==0)
    	ratio=1;
		tfiles++;
    tsize+=d.lnew;
		tpacked+=d.longa;
		if (d.chunk==2048)
			dif='0';
		else if (d.chunk==1024)
			dif='1';
		else if (d.chunk==512)
			dif='2';
		else if (d.chunk==256)
			dif='3';
		else if (d.chunk==128)
			dif='4';
		else if (d.chunk==64)
			dif='5';
		else if (d.chunk==32)
			dif='6';
		else if (d.chunk==16)
			dif='7';
		else if (d.chunk==8)
			dif='8';
		else if (d.chunk==4)
			dif='9';
		if (d.buftam==4096)
			met='0';
		else if (d.buftam==6144)
			met='1';
		else if (d.buftam==8192)
			met='2';
		else if (d.buftam==10240)
			met='3';
		else if (d.buftam==12288)
			met='4';
		else if (d.buftam==14336)
			met='5';
		else if (d.buftam==16384)
			met='6';
		else if (d.buftam==18432)
			met='7';
		else if (d.buftam==20480)
			met='8';
		else if (d.buftam==22528)
			met='9';
		else if (d.buftam==24576)
			met='A';

		printf(" %12s  %10ld  %10ld   %3u%%  %04X%04X ", nombre, d.lnew, d.longa, ratio, d.cnew<<4, d.cnew>>4);
		printf(" %c%c%c%c  %u.%02u \n", com, pas, met, dif, d.ver/100, d.ver%100);
		fseek(pf, (long) d.longa, 1);
	}
	while (ftell(pf)<filelength(fileno(pf)));
	tratio=(tpacked*100)/tsize;
	if (tratio>100)
		tratio=100;
	else if (tratio==0)
		tratio=1;
	puts("Ĵ");
	if (tfiles>1)
		printf(" %-6u files  %10ld  %10ld   %3u%%            %c%c    %u.%02u \n", tfiles, tsize, tpacked, tratio, com, pas, p.ver/100, p.ver%100);
	else
		printf("  1      file  %10ld  %10ld   %3u%%            %c%c    %u.%02u \n", tsize, tpacked, tratio, com, pas, p.ver/100, p.ver%100);
	puts("");
	fclose(pf);
}

/* ---- Busca en una regin de memoria de longitud ldest la cadena org ---- */
unsigned int pascal memstr1 (unsigned char *dest, unsigned char *org, unsigned int ldest, unsigned int lorg)
{
  register unsigned char *ptro;
	register unsigned char *ptra;
  unsigned char *ptrd;

	ptrd=(unsigned char *) dest;
	ldest=ldest+(unsigned int) ptrd;

	while (ptrd!=(unsigned char *)ldest)
	{
		ptro=org;
		ptra=ptrd;
		while (*ptra==*ptro)
		{
			if (ptra>(unsigned char *) ldest)
				return (0xFFFF);
			ptra++;
			ptro++;
			if ((ptra-ptrd)==lorg)
				return ((unsigned int)(((ptra-4)-lorg)));
		}
		ptrd++;
	}
	return (0xFFFF);
}

/* --------------------- Muestra la ayuda por pantalla -------------------- */
void _fastcall ayuda(void)
{
  puts("");
  puts("           Version 1 Revision 04");
  puts("                       (c) Copyright 1995-1997");
  puts("                                  by");
  puts("                              De Trans Software (DTS)");
  puts("\n");
	puts("\n  InfoPat allows you to see the files contained in a PAT or EXE file.");
  puts("  InfoPat <File>\n");
	#ifdef COMERCIAL
    puts("  This is the registered version of InfoPat, so, please, don't");
    puts("distribute this program. Thank you for registering.\n");
    puts("  You are allowed to distribute files that use PATCH package due of having\n");
    puts("the registered version.\n");
    puts("  If you have questions, or suggestions, please write to:\n");
	#endif
	#ifndef COMERCIAL
    puts("  You are not allowed to distribute files that use PATCH package due of");
    puts("having the shareware version.\n");
    puts("  If you want to distribute files that use PATCH, you must register");
    puts("by sending 2500 Ptas or 25 US$ to us, and you will receive the latest");
    puts("registered version available, and a written permission for using PATCH.\n");
    puts("  If you want to register, have questions, or suggestions, please write to:\n");
	#endif
  puts("                    De Trans Software (DTS)");
  puts("                    Javier Gutirrez Chamorro");
  puts("                    Av. Meridiana 336, 7 C");
	puts("                    08027. Barcelona. [SPAIN]");
	salir(200);
}

