/*                                                                         */
/*  PATCH.C     Versin 1 Revision 04                                      */
/*  Es el fichero que se encarga de aplicar los parches.                   */
/*                                                                         */
/*                                                                         */
/*  Usar modelo de memoria LARGE. Optimizaciones para velocidad            */
/*                                                                         */

#pragma inline
#pragma option -1-
#pragma option -ml
#pragma option -O2
asm {
	.8086
	}
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>
#include <io.h>
#include <bios.h>
#include <dir.h>
#include <ctype.h>
//#define COMERCIAL

#define BUILD         98

void _fastcall copyright(char *);
void _fastcall ayuda(void);
void _fastcall info(char *);
void _fastcall salir (unsigned char);
unsigned char _fastcall cpu(void);
unsigned char _fastcall haywin(void);
unsigned char _fastcall hayos2(void);
void pascal wincar (unsigned char *, unsigned char *, unsigned char *);
unsigned char _fastcall haydos4 (void);
void pascal dos4car (unsigned char *, unsigned char *);
char * pascal puntua (long int);
void pascal getpw (char *, char);
void _fastcall openfiles (char *);
void _fastcall undiff0 (void);
void _fastcall undiff1 (void);
void _fastcall undiff2 (void);
void _fastcall undiff3 (void);
void _fastcall undiff4 (void);
void _fastcall calccrc(unsigned char);
void _fastcall closefiles (void);
unsigned int pascal memstr1 (unsigned char *, unsigned char *, unsigned int, unsigned int);

struct patch
{
	char ini[16];													// ini -> Marca Exe
	unsigned char marca;									// Marca Fichero Path
	unsigned int ver;
	unsigned char encriptado;
	char comment[255];
};

struct diff
{
	unsigned char marca;
	unsigned int  ver;
	char viejo[80];
	char nuevo[80];
	unsigned long lold;
	unsigned long lnew;
	unsigned long cold;
	unsigned long cnew;
	unsigned int date;
	unsigned int time;
	unsigned char attrib;
	unsigned long int longa;
	unsigned int buftam;
	unsigned int chunk;
};


unsigned char *bold, *bnew, *bpatch;
FILE *pold, *pnew, *ppatch;
struct patch p;
struct diff d;
char nold[14], nnew[14], npatch[14], pass[17];
char nada[128], ext[5], fpatch[80];

/* ----------------- Rutina de salida con Control-Break ------------------- */
int c_break(void)
{
  closefiles();
  salir(100);
	return(0);				/* Para mantener al compilador contento */
}

void main (unsigned char argc, char *argv[])
{
  register unsigned char proc, i;
  unsigned char fast, opt;

  fast=0;
  opt=255;
  for (i=1; i!=argc; i++)
  {
    if (memcmp(argv[i], "/.", 2)==0)
      fast++;
    else if (memcmp(argv[i], "/0", 2)==0)
      opt=0;
    else if (memcmp(argv[i], "/1", 2)==0)
      opt=1;
    else if (memcmp(argv[i], "/2", 2)==0)
      opt=2;
    else if (memcmp(argv[i], "/3", 2)==0)
      opt=3;
    else if (memcmp(argv[i], "/4", 2)==0)
      opt=4;
    else if (memcmp(argv[i], "/5", 2)==0)
      opt=5;
  }
  if (fast==0)
    copyright(argv[0]);
	if (argc<2)
		salir(4);
	if (memcmp(argv[1], "/*", 2)==0)
    info(strupr(argv[0]));
	else if (memcmp(argv[1], "/?", 2)==0)
		ayuda();

	/* Instala mi interrupcin de Ctrl-Break */
	setcbrk(1);
	ctrlbrk(c_break);

	openfiles(argv[1]);
  if (opt==255)
    proc=cpu();
  else
    proc=opt;
  if (proc==0)
		undiff0();
  else if (proc==1)
    undiff1();
	else if (proc==2)
		undiff2();
	else if (proc==3)
		undiff3();
	else if (proc==4)
		undiff4();
	else
		undiff4();
  if (fast==0)
    salir(0);
  else
    salir(200);
}

/* ------------------ Escribe el copyright del programa ------------------- */
void _fastcall copyright (char *ruta)
{
  register unsigned char row, col;
  unsigned char major, minor, mode;
  unsigned char rowbak, colbak;
  char nombre[9];
  char wmode[][9]={"Real", "Standard", "Enhaced", "Unknown"};
  char pro[][13]={"8088/8086", "186", "286", "386", "486", "Pentium", "Pentium Pro", "Unknown"};
  char nada[80];

	fnsplit(ruta, nada, nada, nombre, nada);
  _setcursortype(_NOCURSOR);
	textattr(8);
	cputs("\r\n\r\n");
	textattr(3);
  cputs("            (c) Copyright 1995-1997 ");
	textattr(11);
	cputs("De Trans Software\r\n");
	textattr(3);
  cputs("                               PATCH Version 1 Revision 04\r\n");
	cputs("                \r\n");
  cputs("                              Fast and reliable Patch files\r\n");
	cputs("                          extractor for DOS.\r\n");
	textattr(8);
	cputs("\r\n");
  textattr(3);
	#ifdef COMERCIAL
    cputs("Registered version ");
	#endif
	#ifndef COMERCIAL
    cputs("Shareware version ");
	#endif
	textattr(7);
	if (hayos2())
    cprintf("[%s under OS/2; %uK/%uK]", pro[cpu()], biosmemory(), (unsigned int) (farcoreleft()>>10));
	else if (haywin())
	{
		wincar(&major, &minor, &mode);
    cprintf("[%s under Windows v%u.%u %s; %uK/%uK]", pro[cpu()], major, minor, wmode[mode-1], biosmemory(), (unsigned int) (farcoreleft()>>10));
	}
	else if (haydos4())
	{
		dos4car(&major, &minor);
    cprintf("[%s under 4DOS v%u.%u; %uK/%uK]", pro[cpu()], major, minor, biosmemory(), (unsigned int) (farcoreleft()>>10));
	}
	else
    cprintf("[%s under DOS v%u.%02u; %uK/%uK]", pro[cpu()], _osmajor, _osminor, biosmemory(), (unsigned int) (farcoreleft()>>10));
	textattr(11);
	cprintf("\r\nType %s /? if you need help and %s /* for internal information.\r\n", nombre, nombre);
  colbak=wherex();
	rowbak=wherey();
	row=rowbak-9;
  for (col=1; col!=79; col++)
	{
		textattr(3);
		gotoxy(col, row);
		putch('');
		gotoxy(79-col, row+6);
		putch('');
		delay(10);
	}
	gotoxy(colbak, rowbak);
	sound(65);
	delay(20);
	nosound();
	_setcursortype(_NORMALCURSOR);
}

/* ------------- Indaga sobre el tipo de procesador instalado ------------- */
unsigned char _fastcall cpu(void) /*0=88/86, 1=188/186, 2=286, 3=386, 4=486, 5=586, 6=686, ... */
{
	asm {
		.486P
    /* Mirar si es 8088/8086/NEC V20 */
    xor     ax, ax
		pushf
		pop     bx
    and     bh, 0xF
		push    bx
		popf
		pushf
		pop     cx
    and     ch, 0xF0
    cmp     ch, 0xF0
    je      fin
    /* Mirar si es 188/186/NEC V30 */
		inc     ax
    push    0
    pop     bx
    test    bx, bx
    jne     fin
    /* Mirar si es 286 */
		inc     ax
    or      bh, 0xF0
		push    bx
		popf
		pushf
		pop     cx
		and     ch, 0xF0
		je      fin
		/* Mirar si es 386 */
		inc     ax
    mov     ebx, esp
    and     esp, 0xFFFC
		pushfd
		pop     edx
    mov     ecx, edx
    xor     edx, 0x40000
		push    edx
		popfd
		pushfd
		pop     edx
		push    ecx
		popfd
    xor     edx, ecx
    and     edx, 0x40000           /* Comprobar el bit de alineamiento */
    mov     esp, ebx
    jz      fin
    /* Mirar si es 486 */
		inc     ax
		pushfd
		pop     edx
    mov     ecx, edx
    xor     edx, 0x200000
		push    edx
		popfd
		pushfd
		pop     edx
		push    ecx
		popfd
    xor     edx, ecx                 /* Comprobar el bit ID */
    jz      fin
    /* Mirar si es Pentium o superior */
    mov     eax, 1
    db      0xF, 0xA2                /* CPUID */
		and     ah,0xF
    shr     ax, 8
	}
fin:
	return(_AX);
}

/* ------------------ Mira si est corriendo bajo OS/2 -------------------- */
unsigned char _fastcall hayos2(void)   /* Devolver 1 si corriendo bajo OS/2 */
{
	union REGS r;

	if (_osmajor>=3)
	{
		r.x.ax=0x4010;
		int86(0x2F, &r, &r);
		return (r.x.ax!=0x4010);
	}
	else
		return(0);   /* DOS 2.X, evitar llamada a INT 2Fh */
}

/* ---------------- Mira si est corriendo bajo Windows ------------------- */
unsigned char _fastcall haywin(void)   /* Devolver versin de Windows Enhanced */
{
	union REGS r;

	r.x.ax=0x160A;
	int86(0x2F, &r, &r);
	if (r.x.ax==0)
		return(1);
	else
		return(0);
}

/* --------- Averigua las caractersticas del windows actual -------------- */
void pascal wincar (unsigned char *major, unsigned char *minor, unsigned char *modo)
{
	union REGS r;

	r.x.ax=0x160A;
	r.x.bx=0;
	r.x.cx=0;
	int86(0x2F, &r, &r);
	*major=r.h.bh;
	*minor=r.h.bl;
	*modo=r.h.cl; /* 1: Real, 2:Estandard, 3:Extendido, 4:Desconocido */
}

/* ------------------ Mira si est corriendo bajo 4DOS -------------------- */
unsigned char _fastcall haydos4(void)
{
	union REGS r;

	r.x.ax=0xD44D;
	r.x.bx=0;
	int86(0x2F, &r, &r);
	if (r.x.ax!=0xD44D)
		return(1);
	else
		return(0);
}

/* --------------- Averigua la versi del 4DOS actual --------------------- */
void pascal dos4car (unsigned char *major, unsigned char *minor)
{
	union REGS r;

	r.x.ax=0xD44D;
	r.x.bx=0;
	int86(0x2F, &r, &r);
	*major=r.h.bl;
	*minor=r.h.bh;
}

/* ------------------------- Puntua un long ------------------------------- */
char * pascal puntua (long int n)
{
  register unsigned int i, j, k;
  char tmp[15];
  static char res[20];

  j=0;
  k=0;
  memset(tmp, 0, 15);
	memset(res, 0, 20);
	ltoa(n, tmp, 10);
	if (n<1000)
		return(tmp);
	strrev(tmp);
	for (i=0; i!=strlen(tmp); i++)
	{
		if (j==3)
		{
			j=0;
			res[k]=',';
			k++;
		}
		res[k]=tmp[i];
		j++;
		k++;
	}
	strrev(res);
	return(res);
}

/* ------------------- Consigue un password por teclado ------------------- */
void pascal getpw (char *pass, char len)
{
	register char tec, i;

	pass[0]=0;
	i=0;
	do
	{
		tec=bioskey(0);
		if (tec==8)
		{
			if (i>0)
			{
				cputs("\b \b");
				i--;
			}
		}
		else if (tec==13)
		{
		}
		else
		{
			if (i<len)
			{
				putch('*');
				pass[i]=tec;
				i++;
			}
		}
	}
	while ((tec!=13) && (tec!=27));
	pass[i]=0;
}

/* ---------- Sale devolviendo un errorlevel, y con un mensajito ---------- */
void _fastcall salir (unsigned char n)
{
	cputs("\r\n");
	if (n==0)
	{
		textattr(2);
		cputs("Everything went O.k.\r\n");
	}
	else if (n==1)
	{
		textattr(12);
		cputs("Error(01): Can't open PAT file.\r\n");
	}
	else if (n==2)
	{
		textattr(12);
		cputs("Error(02): Newer version of PATCH requiered.\r\n");
	}
	else if (n==3)
	{
		textattr(12);
		cputs("Error(03): Not enougth memory for allocating NEW buffer.\r\n");
	}
	else if (n==4)
	{
		textattr(12);
		cputs("Error(04): Wrong number of arguments.\r\n");
	}
	else if (n==5)
	{
		textattr(12);
		cputs("Error(05): Not enougth memory for allocating PAT buffer.\r\n");
	}
	else if (n==6)
	{
		textattr(12);
		cputs("Error(06): Not enougth memory for allocating OLD buffer.\r\n");
	}
	else if (n==7)
	{
		textattr(12);
		cputs("Error(07): Not a valid PAT file.\r\n");
	}
	else if (n==8)
	{
		textattr(12);
		cputs("Error(08): Bad version of OLD file.\r\n");
	}
	else if (n==9)
	{
		textattr(12);
		cputs("Error(09): New file is damaged.\r\n");
	}
	else if (n==10)
	{
		textattr(12);
		cputs("Error(10): Can't open OLD file.\r\n");
	}
	else if (n==11)
	{
		textattr(12);
		cputs("Error(11): Can't create NEW file.\r\n");
	}
	else if (n==12)
	{
		textattr(12);
		if (p.encriptado)
			cputs("Error(12): Wrong password or damaged PAT.\r\n");
		else
			cputs("Error(12): Damaged PAT.\r\n");
	}
  else if (n==100)
	{
		textattr(12);
    cputs("\r\Error(100): Program aborted by user.\r\n");
	}
  else if (n==200)
    cputs("\r\n");
	textattr(7);
	cputs("\r\n");
	setcbrk(0);
	exit(n);
}

/* --------------------- Muestra la ayuda por pantalla -------------------- */
void _fastcall ayuda (void)
{
	textattr(3);
  cputs("\r\n");
  cputs("                       Version 1 Revision 04\r\n");
  cputs("                            (c) Copyright 1995-1997\r\n");
  cputs("                                       by\r\n");
  cputs("                                  De Trans Software (DTS)\r\n");
  cputs("\r\n\r\n");
	textattr(7);
  cputs("  Patch Run-Time, allows you to aply patches created by DIFF in a stand-alone\r\n");
  cputs("way.\r\n");
  cputs("  Patch <Org>.\r\n\r\n");
	#ifdef COMERCIAL
		cputs("  This is the registered version of Patch Run-Time, so, please, don't\r\n");
    cputs("distribute this program. Thank you for registering.\r\n\r\n");
		cputs("  You are allowed to distribute files that use PATCH package due of having\r\n");
    cputs("the registered version.\r\n\r\n");
		cputs("  If you have questions, or suggestions, please write to:\r\n\r\n");
  #endif
	#ifndef COMERCIAL
    cputs("  You are not allowed to distribute files that use PATCH package due of\r\n");
		cputs("having the shareware version.\r\n\r\n");
    cputs("  If you want to distribute files that use PATCH, you must register\r\n");
    cputs("by sending 2500 Ptas or 25 US$ to us, and you will receive the latest\r\n");
		cputs("registered version available, and a written permission for using PATCH.\r\n\r\n");
		cputs("  If you want to register, have questions, or suggestions, please write to:\r\n\r\n");
	#endif
	textattr(15);
	cputs("                    De Trans Software (DTS)\r\n");
	cputs("                    Javier Gutirrez Chamorro\r\n");
	cputs("                    Av. Meridiana 336, 7 C\r\n");
	cputs("                    08027. Barcelona. [SPAIN]");
	bioskey(0);
	salir(200);
}

/* ----------------- Lee la cabecera, y abre los ficheros ----------------- */
void _fastcall openfiles (char *fp)
{
	register unsigned int i;

  /* Pasa los parmetros a variables de la funcin */
	strcpy(fpatch, fp);

	/* Si no tienen extensiones, pon las extensiones por defecto */
	if (strchr(fpatch, '.')==0)
		strcat(fpatch, ".PAT");

	/* Pasa los ficheros a maysculas */
	strupr(fpatch);

	/* Consigue los nombres de los ficheros, sin trayectorias ni nada */
	fnsplit(fpatch, nada, nada, npatch, ext);
	strcat(npatch, ext);

	textattr(15);
	cprintf("\r\nAplying %s.\r\n", fpatch);

	bold=malloc(60000U);
	if (bold==0)
		salir(6);
	bnew=malloc(60000U);
	if (bnew==0)
	{
		free(bold);
		salir(3);
	}
	bpatch=malloc(60000U);
	if (bpatch==0)
	{
		free(bold);
		free(bnew);
		salir(5);
	}
	ppatch=fopen(fpatch, "rb");
	if (ppatch==NULL)
		salir(1);

	i=fread(bpatch, 1, 20000U, ppatch);           // Por si es un exe.
	i=memstr1(bpatch, "Patch by D.T.", i, 12);
	fseek(ppatch, (long) i, 0);

	if ((fread(&p, 1, sizeof(struct patch), ppatch))!=sizeof(struct patch))
		salir(7);

	if ((strcmp(p.ini, "Patch by D.T.S."))!=0)
		salir(7);

	if (p.marca!=2)
		salir(7);

	if (p.ver>109)
		salir(2);

  if (p.comment[254]=='S')
  {
    textattr(7+128);
    cputs("Patch created with the Shareware version of Patch Package!\r\n");
    cputs("Please don't distribute it.\r\n");
  }
  else if (p.comment[254]!='R')
    salir(7);

  cputs("\r\n");
  if (strlen(p.comment)>0)
	{
		textattr(14);
    cprintf("%s\r\n\r\n", p.comment);
	}

	if (p.encriptado)
	{
		textattr(7);
		cputs("\n\rInput password: ");
    getpw(pass, 16);
		strupr(pass);
	}
	else
		strcpy(pass, "D.T.S.");
}


/* ------------ Calcula el CRC-32 del fichero nuevo, o del viejo ---------- */
void _fastcall calccrc(unsigned char comp)
{
	register unsigned int i, leidos;
	unsigned long int llevo, aux;
  unsigned char *tmp;
	char barra[51];

	if (comp==1)
	{
    textattr(135);
		gotoxy (1, wherey());
		cputs("                       ");
		gotoxy (1, wherey());
		cprintf("Pass 1: %s", nold);
		memset(barra, 0, 51);
		memset(barra, '', 50);
		textattr(15);
		gotoxy(23, wherey());
		cputs(barra);
		gotoxy(74, wherey());
		textattr(14);
		cputs("[000%]");

		rewind(pold);
		llevo=0;
		aux=0;
		do
		{
			leidos=fread(bold, 1, d.buftam, pold);
			llevo+=leidos;
      tmp=bold;
			for (i=0; i!=leidos; i++)
      {
        aux+=*tmp;
        tmp++;
      }
			memset(barra, '', ((llevo*50)/d.lold));
			textattr(15);
			gotoxy(23, wherey());
			cputs(barra);
			gotoxy(74, wherey());
			textattr(14);
			cprintf("[%03u%]", ((llevo*100)/d.lold));
		}
		while (leidos==d.buftam);
		textattr(7);
		gotoxy (1, wherey());
		cprintf("Pass 1: %s", nold);
		gotoxy(23, wherey());
		cputs("                                                         ");
		textattr(2);
		gotoxy(23, wherey());
		if (aux==d.cold)
			cputs("CRC checked succesfully.\r\n");
		else
			salir(8);

		rewind(pold);
	}
	else
	{
    textattr(135);
		gotoxy (1, wherey());
		cputs("                       ");
		gotoxy (1, wherey());
		cprintf("Pass 3: %s", nnew);
		memset(barra, 0, 51);
		memset(barra, '', 50);
		textattr(15);
		gotoxy(23, wherey());
		cputs(barra);
		gotoxy(74, wherey());
		textattr(14);
		cputs("[000%]");

		rewind(pnew);
		aux=0;
		llevo=0;
		do
		{
			leidos=fread(bnew, 1, d.buftam, pnew);
			llevo+=leidos;
      tmp=bnew;
			for (i=0; i!=leidos; i++)
      {
        aux+=*tmp;
        tmp++;
      }
			memset(barra, '', ((llevo*50)/d.lnew));
			textattr(15);
			gotoxy(23, wherey());
			cputs(barra);
			gotoxy(74, wherey());
			textattr(14);
			cprintf("[%03u%]", ((llevo*100)/d.lnew));
		}
		while (leidos==d.buftam);
		textattr(7);
		gotoxy (1, wherey());
		cprintf("Pass 3: %s", nnew);
		gotoxy(23, wherey());
		cputs("                                                         ");
		textattr(2);
		gotoxy(23, wherey());

		if (aux==d.cnew)
			cputs("CRC checked succesfully.\r\n\r\n");
		else
			salir(9);
	}
}

#pragma option -4
/* --------------------------- Aplica el PAT/EXE -------------------------- */
void _fastcall undiff4 (void)
{
  register unsigned int j=0;
	register unsigned char pi=0, files=0;
	unsigned char lenght;
	unsigned char push;
	int k=0;
	unsigned int leidos, leidos2, i=0;
	unsigned int iold=0, inew=0;
	unsigned long int llevo;
	char barra[51];
	char aux[80];

	do
	{
		if ((fread(&d, 1, sizeof(struct diff), ppatch)!=sizeof(struct diff)))
			salir(8);
		files++;
		if (d.marca!=1)
		{
			if (j==0xFFFF)
				salir(7);
			if (files!=0)
			{
        /* textattr(12);
				cputs("Warning(03): Damaged PAT. Self Reconstruction (Y/n)?");
				push=toupper(bioskey(0));
				cputs("\r                                                          \r");
				if (push!='Y')
          salir(7); */
				rewind(ppatch);
				fread(bpatch, 1, 20000U, ppatch);
				j=memstr1(bpatch, "Patch by D.T.", 20000U, 12);
				if (j==0xFFFF)
					salir(7);
				fseek(ppatch, (long) j, 0);
				fread(&p, 1, sizeof (struct patch), ppatch);
				pi=1;
				do
				{
					fread(&d, 1, sizeof(struct diff), ppatch);
					fseek(ppatch, (long) d.longa, 1);
					pi++;
				}
				while (pi<files);
				j=0xFFFF;
				continue;
			}
			else
				salir(7);
		}
		if (d.ver>109)
			salir(2);

		fnsplit(d.viejo, nada, nada, nold, ext);
		strcat(nold, ext);
		fnsplit(d.nuevo, nada, nada, nnew, ext);
		strcat(nnew, ext);

		pold=fopen(d.viejo, "rb");
		if (pold==NULL)
			salir(10);

		pnew=fopen(d.nuevo, "wb+");
		if (pnew==NULL)
			salir(11);

		if (filelength(fileno(pold))!=d.lold)
			salir(8);

		calccrc(1);

    textattr(135);
		gotoxy (1, wherey());
		cputs("                       ");
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		memset(barra, 0, 51);
		memset(barra, '', 50);
		textattr(15);
		gotoxy(23, wherey());
		cputs(barra);
		gotoxy(74, wherey());
		textattr(14);
		cputs("[000%]");
    memset(bpatch, 0, (d.buftam<<1));

		llevo=0;
		leidos2=d.buftam;
		leidos=d.buftam<<1;
		lenght=strlen(pass)-1;
		pi=1;
		do
		{
			if (leidos2==d.buftam)
				leidos2=fread(bold, 1, d.buftam, pold);
      if (leidos==(d.buftam<<1))
			{
				leidos=fread(bpatch, 1, d.buftam<<1, ppatch);		// Arreglo 1
				i=0;
			}
			else
				i++;
			inew=0;
			do
			{
				push=bpatch[i] ^ pass[pi];
				switch (push)
				{
					case 1:
						i++;
						for (j=0; j!=d.chunk; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&bnew[inew], &bpatch[i], d.chunk);

						i=i+(d.chunk);

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 2:
						i++;
						for (j=0; j!=2; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&iold, &bpatch[i], 2);
						memcpy(&bnew[inew], &bold[iold], d.chunk);
						i+=2;

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;

					case 3:
						fwrite(bnew, 1, inew, pnew);

						k=(leidos-i)-1;
						fseek(ppatch, (long) -k, 1);
						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 4:
						fwrite(bnew, 1, inew, pnew);
						for (j=i+1; j!=leidos; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[j]=bpatch[j]^pass[pi];
						}
						i++;
						memcpy(&iold, &bpatch[i], 2);
						i+=2;
						fwrite(&bpatch[i], 1, iold, pnew);
						k=leidos-(i+iold);
						k--;
						fseek(ppatch, (long) -k, 1);
						break;

					default:
            closefiles();
						salir(12);
				}
				inew+=d.chunk;
			}
			while (push!=3 && push!=4);
			llevo+=(inew-d.chunk)+1;
			memset(barra, '', ((llevo*50)/d.lnew));
			textattr(15);
			gotoxy(23, wherey());
			cputs(barra);
			gotoxy(74, wherey());
			textattr(14);
			cprintf("[%03u%]", ((llevo*100)/d.lnew));
		}
		while (push!=4);
		if ((i+d.chunk)>=leidos)
			push=0;

		fclose(pold);
		fflush(pnew);
		if (filelength(fileno(pnew))!=d.lnew)
			salir(9);
		textattr(7);
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		gotoxy(23, wherey());
		cputs("                                                         ");
		textattr(2);
		gotoxy(23, wherey());
		cputs("Just created.\r\n");
		calccrc(2);

		_dos_setftime(fileno(pnew), d.date, d.time);
		fclose(pnew);
		if (memcmp(nnew, "_SAME_", 6)==0)
		{
			strcpy(aux, nold);
			aux[strlen(aux)-1]='~';
			rename(nold, aux);
			rename(nnew, nold);
		}
		_dos_setfileattr(d.nuevo, d.attrib);
	}
	while (push!=0);
//	while (leidos==(d.buftam<<1) && push!=0);
  closefiles();
}


#pragma option -3
/* --------------------------- Aplica el PAT/EXE -------------------------- */
void _fastcall undiff3 (void)
{
  register unsigned int j=0;
	register unsigned char pi=0, files=0;
	unsigned char lenght;
	unsigned char push;
	int k=0;
	unsigned int leidos, leidos2, i=0;
	unsigned int iold=0, inew=0;
	unsigned long int llevo;
	char barra[51];
	char aux[80];

	do
	{
		if ((fread(&d, 1, sizeof(struct diff), ppatch)!=sizeof(struct diff)))
			salir(8);
		files++;
		if (d.marca!=1)
		{
			if (j==0xFFFF)
				salir(7);
			if (files!=0)
			{
        /* textattr(12);
				cputs("Warning(03): Damaged PAT. Self Reconstruction (Y/n)?");
				push=toupper(bioskey(0));
				cputs("\r                                                          \r");
				if (push!='Y')
          salir(7); */
				rewind(ppatch);
				fread(bpatch, 1, 20000U, ppatch);
				j=memstr1(bpatch, "Patch by D.T.", 20000U, 12);
				if (j==0xFFFF)
					salir(7);
				fseek(ppatch, (long) j, 0);
				fread(&p, 1, sizeof (struct patch), ppatch);
				pi=1;
				do
				{
					fread(&d, 1, sizeof(struct diff), ppatch);
					fseek(ppatch, (long) d.longa, 1);
					pi++;
				}
				while (pi<files);
				j=0xFFFF;
				continue;
			}
			else
				salir(7);
		}
		if (d.ver>109)
			salir(2);

		fnsplit(d.viejo, nada, nada, nold, ext);
		strcat(nold, ext);
		fnsplit(d.nuevo, nada, nada, nnew, ext);
		strcat(nnew, ext);

		pold=fopen(d.viejo, "rb");
		if (pold==NULL)
			salir(10);

		pnew=fopen(d.nuevo, "wb+");
		if (pnew==NULL)
			salir(11);

		if (filelength(fileno(pold))!=d.lold)
			salir(8);

		calccrc(1);

    textattr(135);
		gotoxy (1, wherey());
		cputs("                       ");
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		memset(barra, 0, 51);
		memset(barra, '', 50);
		textattr(15);
		gotoxy(23, wherey());
		cputs(barra);
		gotoxy(74, wherey());
		textattr(14);
		cputs("[000%]");
    memset(bpatch, 0, (d.buftam<<1));

		llevo=0;
		leidos2=d.buftam;
		leidos=d.buftam<<1;
		lenght=strlen(pass)-1;
		pi=1;
		do
		{
			if (leidos2==d.buftam)
				leidos2=fread(bold, 1, d.buftam, pold);
      if (leidos==(d.buftam<<1))
			{
				leidos=fread(bpatch, 1, d.buftam<<1, ppatch);		// Arreglo 1
				i=0;
			}
			else
				i++;
			inew=0;
			do
			{
				push=bpatch[i] ^ pass[pi];
				switch (push)
				{
					case 1:
						i++;
						for (j=0; j!=d.chunk; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&bnew[inew], &bpatch[i], d.chunk);

						i=i+(d.chunk);

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 2:
						i++;
						for (j=0; j!=2; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&iold, &bpatch[i], 2);
						memcpy(&bnew[inew], &bold[iold], d.chunk);
						i+=2;

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;

					case 3:
						fwrite(bnew, 1, inew, pnew);

						k=(leidos-i)-1;
						fseek(ppatch, (long) -k, 1);
						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 4:
						fwrite(bnew, 1, inew, pnew);
						for (j=i+1; j!=leidos; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[j]=bpatch[j]^pass[pi];
						}
						i++;
						memcpy(&iold, &bpatch[i], 2);
						i+=2;
						fwrite(&bpatch[i], 1, iold, pnew);
						k=leidos-(i+iold);
						k--;
						fseek(ppatch, (long) -k, 1);
						break;

					default:
						closefiles();
						salir(12);
				}
				inew+=d.chunk;
			}
			while (push!=3 && push!=4);
			llevo+=(inew-d.chunk)+1;
			memset(barra, '', ((llevo*50)/d.lnew));
			textattr(15);
			gotoxy(23, wherey());
			cputs(barra);
			gotoxy(74, wherey());
			textattr(14);
			cprintf("[%03u%]", ((llevo*100)/d.lnew));
		}
		while (push!=4);
		if ((i+d.chunk)>=leidos)
			push=0;

		fclose(pold);
		fflush(pnew);
		if (filelength(fileno(pnew))!=d.lnew)
			salir(9);
		textattr(7);
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		gotoxy(23, wherey());
		cputs("                                                         ");
		textattr(2);
		gotoxy(23, wherey());
		cputs("Just created.\r\n");
		calccrc(2);

		_dos_setftime(fileno(pnew), d.date, d.time);
		fclose(pnew);
		if (memcmp(nnew, "_SAME_", 6)==0)
		{
			strcpy(aux, nold);
			aux[strlen(aux)-1]='~';
			rename(nold, aux);
			rename(nnew, nold);
		}
		_dos_setfileattr(d.nuevo, d.attrib);
	}
	while (push!=0);
//	while (leidos==(d.buftam<<1) && push!=0);
  closefiles();
}


#pragma option -2
/* --------------------------- Aplica el PAT/EXE -------------------------- */
void _fastcall undiff2 (void)
{
  register unsigned int j=0;
	register unsigned char pi=0, files=0;
	unsigned char lenght;
	unsigned char push;
	int k=0;
	unsigned int leidos, leidos2, i=0;
	unsigned int iold=0, inew=0;
	unsigned long int llevo;
	char barra[51];
	char aux[80];

	do
	{
		if ((fread(&d, 1, sizeof(struct diff), ppatch)!=sizeof(struct diff)))
			salir(8);
		files++;
		if (d.marca!=1)
		{
			if (j==0xFFFF)
				salir(7);
			if (files!=0)
			{
        /* textattr(12);
				cputs("Warning(03): Damaged PAT. Self Reconstruction (Y/n)?");
				push=toupper(bioskey(0));
				cputs("\r                                                          \r");
				if (push!='Y')
          salir(7); */
				rewind(ppatch);
				fread(bpatch, 1, 20000U, ppatch);
				j=memstr1(bpatch, "Patch by D.T.", 20000U, 12);
				if (j==0xFFFF)
					salir(7);
				fseek(ppatch, (long) j, 0);
				fread(&p, 1, sizeof (struct patch), ppatch);
				pi=1;
				do
				{
					fread(&d, 1, sizeof(struct diff), ppatch);
					fseek(ppatch, (long) d.longa, 1);
					pi++;
				}
				while (pi<files);
				j=0xFFFF;
				continue;
			}
			else
				salir(7);
		}
		if (d.ver>109)
			salir(2);

		fnsplit(d.viejo, nada, nada, nold, ext);
		strcat(nold, ext);
		fnsplit(d.nuevo, nada, nada, nnew, ext);
		strcat(nnew, ext);

		pold=fopen(d.viejo, "rb");
		if (pold==NULL)
			salir(10);

		pnew=fopen(d.nuevo, "wb+");
		if (pnew==NULL)
			salir(11);

		if (filelength(fileno(pold))!=d.lold)
			salir(8);

		calccrc(1);

		textattr(135);
		gotoxy (1, wherey());
		cputs("                       ");
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		memset(barra, 0, 51);
		memset(barra, '', 50);
		textattr(15);
		gotoxy(23, wherey());
		cputs(barra);
		gotoxy(74, wherey());
		textattr(14);
		cputs("[000%]");
		memset(bpatch, 0, (d.buftam<<1));

		llevo=0;
		leidos2=d.buftam;
		leidos=d.buftam<<1;
		lenght=strlen(pass)-1;
		pi=1;
		do
		{
			if (leidos2==d.buftam)
				leidos2=fread(bold, 1, d.buftam, pold);
      if (leidos==(d.buftam<<1))
			{
				leidos=fread(bpatch, 1, d.buftam<<1, ppatch);		// Arreglo 1
				i=0;
			}
			else
				i++;
			inew=0;
			do
			{
				push=bpatch[i] ^ pass[pi];
				switch (push)
				{
					case 1:
						i++;
						for (j=0; j!=d.chunk; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&bnew[inew], &bpatch[i], d.chunk);

						i=i+(d.chunk);

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 2:
						i++;
						for (j=0; j!=2; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&iold, &bpatch[i], 2);
						memcpy(&bnew[inew], &bold[iold], d.chunk);
						i+=2;

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;

					case 3:
						fwrite(bnew, 1, inew, pnew);

						k=(leidos-i)-1;
						fseek(ppatch, (long) -k, 1);
						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 4:
						fwrite(bnew, 1, inew, pnew);
						for (j=i+1; j!=leidos; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[j]=bpatch[j]^pass[pi];
						}
						i++;
						memcpy(&iold, &bpatch[i], 2);
						i+=2;
						fwrite(&bpatch[i], 1, iold, pnew);
						k=leidos-(i+iold);
						k--;
						fseek(ppatch, (long) -k, 1);
						break;

					default:
						closefiles();
						salir(12);
				}
				inew+=d.chunk;
			}
			while (push!=3 && push!=4);
			llevo+=(inew-d.chunk)+1;
			memset(barra, '', ((llevo*50)/d.lnew));
			textattr(15);
			gotoxy(23, wherey());
			cputs(barra);
			gotoxy(74, wherey());
			textattr(14);
			cprintf("[%03u%]", ((llevo*100)/d.lnew));
		}
		while (push!=4);
		if ((i+d.chunk)>=leidos)
			push=0;

		fclose(pold);
		fflush(pnew);
		if (filelength(fileno(pnew))!=d.lnew)
			salir(9);
		textattr(7);
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		gotoxy(23, wherey());
		cputs("                                                         ");
		textattr(2);
		gotoxy(23, wherey());
		cputs("Just created.\r\n");
		calccrc(2);

		_dos_setftime(fileno(pnew), d.date, d.time);
		fclose(pnew);
		if (memcmp(nnew, "_SAME_", 6)==0)
		{
			strcpy(aux, nold);
			aux[strlen(aux)-1]='~';
			rename(nold, aux);
			rename(nnew, nold);
		}
		_dos_setfileattr(d.nuevo, d.attrib);
	}
	while (push!=0);
//	while (leidos==(d.buftam<<1) && push!=0);
	closefiles();
}

#pragma option -1
/* --------------------------- Aplica el PAT/EXE -------------------------- */
void _fastcall undiff1 (void)
{
  register unsigned int j=0;
	register unsigned char pi=0, files=0;
	unsigned char lenght;
	unsigned char push;
	int k=0;
	unsigned int leidos, leidos2, i=0;
	unsigned int iold=0, inew=0;
	unsigned long int llevo;
	char barra[51];
	char aux[80];

	do
	{
		if ((fread(&d, 1, sizeof(struct diff), ppatch)!=sizeof(struct diff)))
			salir(8);
		files++;
		if (d.marca!=1)
		{
			if (j==0xFFFF)
				salir(7);
			if (files!=0)
			{
        /* textattr(12);
				cputs("Warning(03): Damaged PAT. Self Reconstruction (Y/n)?");
				push=toupper(bioskey(0));
				cputs("\r                                                          \r");
				if (push!='Y')
          salir(7); */
				rewind(ppatch);
				fread(bpatch, 1, 20000U, ppatch);
				j=memstr1(bpatch, "Patch by D.T.", 20000U, 12);
				if (j==0xFFFF)
					salir(7);
				fseek(ppatch, (long) j, 0);
				fread(&p, 1, sizeof (struct patch), ppatch);
				pi=1;
				do
				{
					fread(&d, 1, sizeof(struct diff), ppatch);
					fseek(ppatch, (long) d.longa, 1);
					pi++;
				}
				while (pi<files);
				j=0xFFFF;
				continue;
			}
			else
				salir(7);
		}
		if (d.ver>109)
			salir(2);

		fnsplit(d.viejo, nada, nada, nold, ext);
		strcat(nold, ext);
		fnsplit(d.nuevo, nada, nada, nnew, ext);
		strcat(nnew, ext);

		pold=fopen(d.viejo, "rb");
		if (pold==NULL)
			salir(10);

		pnew=fopen(d.nuevo, "wb+");
		if (pnew==NULL)
			salir(11);

		if (filelength(fileno(pold))!=d.lold)
			salir(8);

		calccrc(1);

    textattr(135);
		gotoxy (1, wherey());
		cputs("                       ");
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		memset(barra, 0, 51);
		memset(barra, '', 50);
		textattr(15);
		gotoxy(23, wherey());
		cputs(barra);
		gotoxy(74, wherey());
		textattr(14);
		cputs("[000%]");
    memset(bpatch, 0, (d.buftam<<1));

		llevo=0;
		leidos2=d.buftam;
		leidos=d.buftam<<1;
		lenght=strlen(pass)-1;
		pi=1;
		do
		{
			if (leidos2==d.buftam)
				leidos2=fread(bold, 1, d.buftam, pold);
      if (leidos==(d.buftam<<1))
			{
				leidos=fread(bpatch, 1, d.buftam<<1, ppatch);		// Arreglo 1
				i=0;
			}
			else
				i++;
			inew=0;
			do
			{
				push=bpatch[i] ^ pass[pi];
				switch (push)
				{
					case 1:
						i++;
						for (j=0; j!=d.chunk; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&bnew[inew], &bpatch[i], d.chunk);

						i=i+(d.chunk);

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 2:
						i++;
						for (j=0; j!=2; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&iold, &bpatch[i], 2);
						memcpy(&bnew[inew], &bold[iold], d.chunk);
						i+=2;

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;

					case 3:
						fwrite(bnew, 1, inew, pnew);

						k=(leidos-i)-1;
						fseek(ppatch, (long) -k, 1);
						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 4:
						fwrite(bnew, 1, inew, pnew);
						for (j=i+1; j!=leidos; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[j]=bpatch[j]^pass[pi];
						}
						i++;
						memcpy(&iold, &bpatch[i], 2);
						i+=2;
						fwrite(&bpatch[i], 1, iold, pnew);
						k=leidos-(i+iold);
						k--;
						fseek(ppatch, (long) -k, 1);
						break;

					default:
            closefiles();
						salir(12);
				}
				inew+=d.chunk;
			}
			while (push!=3 && push!=4);
			llevo+=(inew-d.chunk)+1;
			memset(barra, '', ((llevo*50)/d.lnew));
			textattr(15);
			gotoxy(23, wherey());
			cputs(barra);
			gotoxy(74, wherey());
			textattr(14);
			cprintf("[%03u%]", ((llevo*100)/d.lnew));
		}
		while (push!=4);
		if ((i+d.chunk)>=leidos)
			push=0;

		fclose(pold);
		fflush(pnew);
		if (filelength(fileno(pnew))!=d.lnew)
			salir(9);
		textattr(7);
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		gotoxy(23, wherey());
		cputs("                                                         ");
		textattr(2);
		gotoxy(23, wherey());
		cputs("Just created.\r\n");
		calccrc(2);

		_dos_setftime(fileno(pnew), d.date, d.time);
		fclose(pnew);
		if (memcmp(nnew, "_SAME_", 6)==0)
		{
			strcpy(aux, nold);
			aux[strlen(aux)-1]='~';
			rename(nold, aux);
			rename(nnew, nold);
		}
		_dos_setfileattr(d.nuevo, d.attrib);
	}
	while (push!=0);
//	while (leidos==(d.buftam<<1) && push!=0);
  closefiles();
}

#pragma option -1-
/* --------------------------- Aplica el PAT/EXE -------------------------- */
void _fastcall undiff0 (void)
{
  register unsigned int j=0;
	register unsigned char pi=0, files=0;
	unsigned char lenght;
	unsigned char push;
	int k=0;
	unsigned int leidos, leidos2, i=0;
	unsigned int iold=0, inew=0;
	unsigned long int llevo;
	char barra[51];
	char aux[80];

	do
	{
		if ((fread(&d, 1, sizeof(struct diff), ppatch)!=sizeof(struct diff)))
			salir(8);
		files++;
		if (d.marca!=1)
		{
			if (j==0xFFFF)
				salir(7);
			if (files!=0)
			{
        /* textattr(12);
				cputs("Warning(03): Damaged PAT. Self Reconstruction (Y/n)?");
				push=toupper(bioskey(0));
				cputs("\r                                                          \r");
				if (push!='Y')
          salir(7); */
				rewind(ppatch);
				fread(bpatch, 1, 20000U, ppatch);
				j=memstr1(bpatch, "Patch by D.T.", 20000U, 12);
				if (j==0xFFFF)
					salir(7);
				fseek(ppatch, (long) j, 0);
				fread(&p, 1, sizeof (struct patch), ppatch);
				pi=1;
				do
				{
					fread(&d, 1, sizeof(struct diff), ppatch);
					fseek(ppatch, (long) d.longa, 1);
					pi++;
				}
				while (pi<files);
				j=0xFFFF;
				continue;
			}
			else
				salir(7);
		}
		if (d.ver>109)
			salir(2);

		fnsplit(d.viejo, nada, nada, nold, ext);
		strcat(nold, ext);
		fnsplit(d.nuevo, nada, nada, nnew, ext);
		strcat(nnew, ext);

		pold=fopen(d.viejo, "rb");
		if (pold==NULL)
			salir(10);

		pnew=fopen(d.nuevo, "wb+");
		if (pnew==NULL)
			salir(11);

		if (filelength(fileno(pold))!=d.lold)
			salir(8);

		calccrc(1);

    textattr(135);
		gotoxy (1, wherey());
		cputs("                       ");
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		memset(barra, 0, 51);
		memset(barra, '', 50);
		textattr(15);
		gotoxy(23, wherey());
		cputs(barra);
		gotoxy(74, wherey());
		textattr(14);
		cputs("[000%]");
    memset(bpatch, 0, (d.buftam<<1));

		llevo=0;
		leidos2=d.buftam;
		leidos=d.buftam<<1;
		lenght=strlen(pass)-1;
		pi=1;
		do
		{
			if (leidos2==d.buftam)
				leidos2=fread(bold, 1, d.buftam, pold);
      if (leidos==(d.buftam<<1))
			{
				leidos=fread(bpatch, 1, d.buftam<<1, ppatch);		// Arreglo 1
				i=0;
			}
			else
				i++;
			inew=0;
			do
			{
				push=bpatch[i] ^ pass[pi];
				switch (push)
				{
					case 1:
						i++;
						for (j=0; j!=d.chunk; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&bnew[inew], &bpatch[i], d.chunk);

						i=i+(d.chunk);

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 2:
						i++;
						for (j=0; j!=2; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[i+j]=bpatch[i+j] ^ pass[pi];
						}
						memcpy(&iold, &bpatch[i], 2);
						memcpy(&bnew[inew], &bold[iold], d.chunk);
						i+=2;

						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;

					case 3:
						fwrite(bnew, 1, inew, pnew);

						k=(leidos-i)-1;
						fseek(ppatch, (long) -k, 1);
						if (pi==lenght)
							pi=0;
						else
							pi++;

						break;
					case 4:
						fwrite(bnew, 1, inew, pnew);
						for (j=i+1; j!=leidos; j++)
						{
							if (pi==lenght)
								pi=0;
							else
								pi++;
							bpatch[j]=bpatch[j]^pass[pi];
						}
						i++;
						memcpy(&iold, &bpatch[i], 2);
						i+=2;
						fwrite(&bpatch[i], 1, iold, pnew);
						k=leidos-(i+iold);
						k--;
						fseek(ppatch, (long) -k, 1);
						break;

					default:
            closefiles();
						salir(12);
				}
				inew+=d.chunk;
			}
			while (push!=3 && push!=4);
			llevo+=(inew-d.chunk)+1;
			memset(barra, '', ((llevo*50)/d.lnew));
			textattr(15);
			gotoxy(23, wherey());
			cputs(barra);
			gotoxy(74, wherey());
			textattr(14);
			cprintf("[%03u%]", ((llevo*100)/d.lnew));
		}
		while (push!=4);
		if ((i+d.chunk)>=leidos)
			push=0;

		fclose(pold);
		fflush(pnew);
		if (filelength(fileno(pnew))!=d.lnew)
			salir(9);
		textattr(7);
		gotoxy (1, wherey());
		cprintf("Pass 2: %s", nnew);
		gotoxy(23, wherey());
		cputs("                                                         ");
		textattr(2);
		gotoxy(23, wherey());
		cputs("Just created.\r\n");
		calccrc(2);

		_dos_setftime(fileno(pnew), d.date, d.time);
		fclose(pnew);
		if (memcmp(nnew, "_SAME_", 6)==0)
		{
			strcpy(aux, nold);
			aux[strlen(aux)-1]='~';
			rename(nold, aux);
			rename(nnew, nold);
		}
		_dos_setfileattr(d.nuevo, d.attrib);
	}
	while (push!=0);
//	while (leidos==(d.buftam<<1) && push!=0);
  closefiles();
}

/* ---- Busca en una regin de memoria de longitud ldest la cadena org ---- */
unsigned int pascal memstr1 (unsigned char *dest, unsigned char *org, unsigned int ldest, unsigned int lorg)
{
	/* ptro ->       DS:SI */
	/* ptrd ->       ES:DI */
	/* ptra ->       ES:BX optimizacin en ES:BX, pues ptrd y ptra comparten el mismo segmento */
	/* ldest ->      AX */
	/* lorg ->       DX */
	/* Temporales -> CL */
	/*               CX */

	asm {
		push		ds
		mov			dx, lorg
		/* ptrd=(unsigned char *) dest; */
		les     di, dest
		/* ldest=ldest+(unsigned int) ptrd; */
		mov     ax, ldest
		add     ax, di
		/* while (ptrd!=(unsigned char *)ldest) */
	}
while1:
	asm {
		cmp     ax, di
		je      endwhile1
		/* { */
		/* ptro=org; */
		lds     si, org
		/* ptra=ptrd; */
		mov		 	bx, di
		/* while (*ptra==*ptro) */
	}
while2:
	asm {
		mov     cx, es:[bx]
		cmp     cx, ds:[si]
		jne     endwhile2
		/* { */
		/* if (ptra>(unsigned char *) ldest) */
	}
if1:
	asm {
		cmp			ax, bx
		jg			else1
	}
then1:
	asm {
		pop			ds
	}
	/* return (0xFFFF); */
	return(0xFFFF);
else1:
	asm {
		/* ptra++; */
		inc			bx
		inc			bx
		/* ptro++; */
		inc			si
		inc			si
		/* if ((ptra-ptrd)==lorg) */
	}
if2:
	asm {
		mov     cx, bx
		sub     cx, di
		cmp     cx, dx
		jne     else2
	}
then2:
	asm {
		pop			ds
	}
	/* return ((unsigned int)(((ptra-4)-lorg))); */
	return ((unsigned int)(((_BX-4)-lorg)));
	/* } */
else2:
	asm {
		jmp     while2
	}
endwhile2:
	asm {
		 /* ptrd++; */
		inc		di
		/* } */
		jmp     while1
	}
endwhile1:
	asm {
		pop			ds
	}
	/* return (0xFFFF); */
	return(0xFFFF);
}

/* --------------------- Chapa ficheros, y libera memoria ----------------- */
void _fastcall closefiles (void)
{
  free(bold);
  free(bnew);
  free(bpatch);
  fclose(pold);
  fclose(pnew);
  fclose(ppatch);
}

/* --------------------- Muestra la ayuda por pantalla -------------------- */
void _fastcall info (char *nombre)
{
  FILE *f;

  f=fopen(nombre, "rb");
  textattr(3);
	cputs("\r\n");
  cputs("                       Version 1 Revision 04\r\n");
  cputs("                            (c) Copyright 1995-1997\r\n");
  cputs("                                       by\r\n");
  cputs("                                  De Trans Software (DTS)\r\n");
  cputs("\r\n\r\n");
	textattr(7);
  cputs(" Compiler:                         Borland C++ v4.5.\r\n");
	cputs(" Assembler:                        Turbo Assembler v3.2.\r\n");
	#ifdef __TINY__
		cputs(" Memory model:                     TINY.\r\n");
	#endif
	#ifdef __SMALL__
		cputs(" Memory model:                     SMALL.\r\n");
	#endif
	#ifdef __MEDIUM__
		cputs(" Memory model:                     MEDIUM.\r\n");
	#endif
	#ifdef __COMPACT__
		cputs(" Memory model:                     COMPACT.\r\n");
	#endif
	#ifdef __LARGE__
		cputs(" Memory model:                     LARGE.\r\n");
	#endif
	#ifdef __HUGE__
		cputs(" Memory model:                     HUGE.\r\n");
	#endif
	cprintf(" File:                             %s.\r\n", strupr(__FILE__));
	cprintf(" Lines:                            %s.\r\n", puntua((long int) __LINE__+10));
	cprintf(" Date:                             %s.\r\n", __DATE__);
	cprintf(" Time:                             %s.\r\n", __TIME__);
  cprintf(" Build:                            %u.\r\n", BUILD);
  cprintf(" Executable size:                  %s.\r\n", puntua(filelength(fileno(f))));
	#ifdef COMERCIAL
	cputs("\r\nREGISTERED VERSION!\r\n");
	#endif
	#ifndef COMERCIAL
	cputs("\r\nSHAREWARE VERSION!\r\n");
	#endif
  fclose(f);
	salir(200);
}
