/*                                                                         */
/*  PSHELLD.C   Versin 1 Revision 04                                      */
/*  Shell que gestiona al DIFF, DIF2PAT, y INFOPAT.                        */
/*                                                                         */
/*                                                                         */
/*  Usar modelo de memoria LARGE. Optimizaciones para velocidad            */
/*                                                                         */

#pragma option -1-
#pragma option -ml
#pragma option -O2

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <bios.h>
#include <conio.h>
#include <io.h>
#include <string.h>
#include <dir.h>
#include <alloc.h>
#include <ctype.h>
/*//#define COMERCIAL*/

#define BUILD 57
/*#define system(tmp) 0*/

void pascal doit (char *, char *, char *, char *, unsigned char, char *);
char pascal compfecha (FILE *f1, FILE *f2);
char pascal comptamano (FILE *f1, FILE *f2);
char pascal compcrc (FILE *f1, FILE *f2);
char pascal compbytes (FILE *f1, FILE *f2);
void _fastcall copyright (char *);
void _fastcall info (char *);
void _fastcall ayuda (void);
void _fastcall salir(unsigned char);
char * pascal puntua (long int);

/* ----------------- Rutina de salida con Control-Break ------------------- */
int c_break(void)
{
  textattr(12);
  cputs("\r\nCtrl-Break pressed. Do you want to abort the program (y/N)?");
  if (toupper(bioskey(0))=='Y')
  {
    cputs("\r                                                            ");
    salir(100);
  }
  else
    cputs("\r                                                            ");
  return(0);        /* Para mantener al compilador contento */
}

void main (unsigned argc, char *argv[])
{
	register unsigned char i;
	unsigned char storepath;
	char pname[80];

  /* Pasa cada argumento a maysculas */
	for (i=0; i<argc; i++)
    strupr(argv[i]);
	copyright (argv[0]);
  if (memcmp(argv[1],"/?", 2)==0)
		ayuda();
  else if (memcmp(argv[1],"/*", 2)==0)
		info(argv[0]);
	if (argc<3)
		salir(1);
	/* Poner los argumentos no usados a vaco */
	argv[argc+1][0]=0;
	argv[argc+2][0]=0;
	argv[argc+3][0]=0;
	argv[argc+4][0]=0;
	argv[argc+5][0]=0;
	storepath=0;
	strcpy(pname, "PSHELLD.PAT");
	for (i=0; i<argc; i++)
	{
		if (memcmp(argv[i], "/S", 2)==0)
		{
			storepath=1;
			argv[i]=0;
		}
		else if (memcmp(argv[i], "/P", 2)==0)
		{
			memcpy(pname, &argv[i][2], 80);
			argv[i]=0;
		}
	}
	/* Instala mi interrupcin de Ctrl-Break */
	setcbrk(1);
	ctrlbrk(c_break);
	doit(argv[1], argv[2], argv[3], argv[4], storepath, pname);
  salir(0);
}

/* ------------------------------- Lo bsico ------------------------------ */
void pascal doit (char *n1, char *n2, char *op1, char *op2, unsigned char def, char *pname)
{
	register unsigned char tec;
	register unsigned int llevo;
	int fin1, fin2;
	FILE *f1, *f2;
	struct ffblk ffblk1, ffblk2;
	char drive1[4], dir1[80], name1[9], ext1[5], path1[80], mask1[13], tmp1[80];
	char drive2[4], dir2[80], name2[9], ext2[5], path2[80], mask2[13], tmp2[80];
	char ar1[80], ar2[80], ar3[80], ar4[10], ar5[10], tmp[128];
	char plst[80];

	textattr(15);
	if (strlen(op1)<2)
		op1[0]=0;
	if (strlen(op1)<2)
		op2[0]=0;
	cprintf("\r\nMaking DIF's from %s to %s\r\n\r\n", n1, n2);
	/* Borrar los DIFF que haya en el directorio actual */
  fin1=findfirst("PSD*.DIF", &ffblk1, 0);
	do
	{
		remove(ffblk1.ff_name);
		fin1=findnext(&ffblk1);
	}
	while (!fin1);

	/* Separar parmetros */
	fnsplit(n1, drive1, dir1, name1, ext1);
	if (def==1)
	{
		/* Por defecto los parmetros son los actuales */
		if (drive1[0]==0)
		{
			drive1[0]=getdisk()+'A';
			drive1[1]=':';
			drive1[2]=0;
		}
		if (dir1[0]==0)
		{
			getcurdir(drive1[0]-'A'+1, dir1);
			if (dir1[0]==0)
			{
				dir1[0]='\\';
				dir1[1]=0;
			}
		}
	}
	if (name1[0]==0)
	{
		name1[0]='*';
		name1[1]=0;
	}
	if (ext1[0]==0)
	{
		ext1[0]='.';
		ext1[1]='*';
		ext1[2]=0;
	}
	sprintf(path1, "%s%s", drive1, dir1);
	sprintf(mask1, "%s%s", name1, ext1);

	/* Separar parmetros */
	fnsplit(n2, drive2, dir2, name2, ext2);
	/* Por defecto los parmetros son los actuales */
	if (def==1)
	{
		if (drive2[0]==0)
		{
			drive2[0]=getdisk()+'A';
			drive2[1]=':';
			drive2[2]=0;
		}
		if (dir2[0]==0)
		{
			getcurdir(drive2[0]-'A'+1, dir2);
			if (dir2[0]==0)
			{
				dir2[0]='\\';
				dir2[1]=0;
			}
		}
	}
	if (name2[0]==0)
	{
		name2[0]='*';
		name2[1]=0;
	}
	if (ext2[0]==0)
	{
		ext2[0]='.';
		ext2[1]='*';
		ext2[2]=0;
	}
	sprintf(path2, "%s%s", drive2, dir2);
	sprintf(mask2, "%s%s", name2, ext2);

	sprintf(tmp2, "%s%s", path2, mask2);
	fin2=findfirst(tmp2, &ffblk2, FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_ARCH);
	if (fin2<0)
		salir(2);
  llevo=0;
	do
	{
    if ((memcmp(ffblk2.ff_name, "PSD", 3)==0) && (memcmp(&ffblk2.ff_name[8], ".DIF", 4)==0))
    {
			fin2=findnext(&ffblk2);
			continue;
    }
		sprintf(ar2, "%s%s", path2, ffblk2.ff_name);
		sprintf(tmp1, "%s%s", path1, mask1);
		fin1=findfirst(tmp1, &ffblk1, FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_ARCH);
		/* Si no encuentra el fichero viejo, coger cualquier otro */
		if (fin1<0)
		{
			sprintf(tmp1, "%s*.*", path1);
			fin1=findfirst(tmp1, &ffblk1, FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_ARCH);
			sprintf(ar2, "%s%s", path1, ffblk1.ff_name);
			sprintf(tmp1, "%s%s", path1, mask1);
			fin1=findfirst(tmp1, &ffblk1, FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_ARCH);
		}
		else
		{
			do
			{
				if (strcmp(ffblk1.ff_name, ffblk2.ff_name)==0)
					break;
				else
					fin1=findnext(&ffblk1);
			}
			while (!fin1);
			sprintf(ar1, "%s%s", path1, ffblk1.ff_name);
		}
		textattr(7);
		cprintf("%s and %s ", ar1, ar2);
    sprintf(ar3, "PSD%05u.DIF", llevo);
		strcpy(ar4, op1);
		strcpy(ar5, op2);
		sprintf(tmp, "DIFF %s %s %s %s %s /.", ar1, ar2, ar3, ar4, ar5);
		if (strcmp(ar1, ar2)==0)
			salir(5);
		f1=fopen(ar1, "rb");
		if (f1==0)
			salir(3);
		f2=fopen(ar2, "rb");
		if (f2==0)
			salir(3);
		if (comptamano(f1, f2)!=0)
		{
			textattr(12);
			cputs("\r\nDifferent length. Diff required.\r\n");
			textattr(14);
			cprintf("%s\r\n\r\n", tmp);
      textattr(7);
      strcat(tmp, ">NUL");
      if (system(tmp)!=0)
        salir(4);
      fcloseall();
			fin2=findnext(&ffblk2);
      llevo++;
			continue;
		}
		else if (compfecha(f1, f2)!=0)
		{
			textattr(12);
			cputs("\r\nDifferent date/time. Diff required.\r\n");
      textattr(14);
			cprintf("%s\r\n\r\n", tmp);
      textattr(7);
      strcat(tmp, ">NUL");
      if (system(tmp)!=0)
        salir(4);
      fcloseall();
			fin2=findnext(&ffblk2);
      llevo++;
			continue;
		}
		else if (compbytes(f1, f2)!=0)
		{
			textattr(12);
			cputs("\r\nDifferent contents. Diff required.\r\n");
			textattr(14);
			cprintf("%s\r\n\r\n", tmp);
      textattr(7);
      strcat(tmp, ">NUL");
      if (system(tmp)!=0)
        salir(4);
      fcloseall();
			fin2=findnext(&ffblk2);
      llevo++;
			continue;
		}
		else
		{
			textattr(2);
			cputs("\r\nIdentical. Diff not required.\r\n");
      fcloseall();
			textattr(14);
      cputs("NONE\r\n\r\n");
			fin2=findnext(&ffblk2);
			continue;
		}
	}
	while (!fin2);
	textattr(7);
	cprintf("Creating %s from *.DIF\r\n", pname);
  sprintf(tmp, "DIF2PAT PSD*.DIF %s /P /C /.", pname);
	textattr(14);
	cprintf("%s\r\n\r\n", tmp);
  textattr(7);
  strcat(tmp, ">NUL");
  if (system(tmp)!=0)
    salir(4);
	/* Borrar los DIFF que haya en el directorio actual */
  fin1=findfirst("PSD*.DIF", &ffblk1, 0);
	do
	{
		remove(ffblk1.ff_name);
		fin1=findnext(&ffblk1);
	}
	while (!fin1);
	/* Quitarle la extension */
	strcpy(plst, pname);
	*(strchr(plst, '.'))=0;
	strcat(plst, ".LST");
	textattr(7);
	cprintf("Creating %s from %s\r\n", plst, pname);
  sprintf(tmp, "INFOPAT %s /. >%s", pname, plst);
	textattr(14);
	cprintf("%s\r\n\r\n", tmp);
  textattr(7);
  if (system(tmp)!=0)
		salir(4);
	llevo=2;
	tec=0;
	textattr(11);
	cprintf("Listing of %s:\r\n", plst);
	textattr(7);
	f1=fopen(plst, "rb");
	if (f1==0)
		salir(3);
	do
	{
		fgets(tmp, 80, f1);
		cputs(tmp);
		llevo++;
		if (llevo>24)
		{
			textattr(3);
			cputs("Press any key to continue or ESC to abort.");
			textattr(7);
			tec=bioskey(0);
			cputs("\r\n");
			llevo=1;
		}
	}
	while ((!feof(f1)) && (tec!=27));
	fclose(f1);
}

/* --------------- Compara la hora y la fecha de dos ficheros -------------- */
char pascal compfecha (FILE *f1, FILE *f2)
{
	unsigned int t1, d1, t2, d2;
	struct REGPACK r;

	r.r_ax=0x5700;
	r.r_bx=fileno(f1);
	intr(0x21, &r);
	t1=r.r_cx;
	d1=r.r_dx;
	r.r_ax=0x5700;
	r.r_bx=fileno(f2);
	intr(0x21, &r);
	t2=r.r_cx;
	d2=r.r_dx;
	if (d1>d2)
		return(1);
	else if (d2>d1)
		return(2);
	else
	{
		if (t1>t2)
			return(1);
		else if (t2>t1)
			return(2);
		else
			return(0);
	}
}

/* --------------------- Compara el tamao de dos fichero ------------------ */
char pascal comptamano (FILE *f1, FILE *f2)
{
	long int s1, s2;

	s1=filelength(fileno(f1));
	if (s1<0)
		return(-1);
	s2=filelength(fileno(f2));
	if (s2<0)
		return(-1);

	if (s1>s2)
		return(1);
	else if (s2>s1)
		return(2);
	else
		return(0);
}

/* ---------------------- Compara el CRC de dos fichero -------------------- */
/* char pascal compcrc (FILE *f1, FILE *f2)
{
  register unsigned int i, leidos;
	unsigned char *mem, *aux;
	long int c1, c2;

	mem=malloc(16384);
	if (mem==0)
		return(-1);

	c1=0;
	rewind(f1);
	do
	{
		leidos=fread(mem, 1, 16384, f1);
		aux=mem;
		for (i=0; i!=leidos; i++)
		{
			c1+=*aux;
			aux++;
		}
	}
	while (leidos==16384);

	c2=0;
	rewind(f2);
	do
	{
		leidos=fread(mem, 1, 16384, f2);
		aux=mem;
		for (i=0; i!=leidos; i++)
		{
			c2+=*aux;
			aux++;
		}
	}
	while (leidos==16384);

	free(mem);
	if (c1>c2)
		return(1);
	else if (c2>c1)
		return(2);
	else
		return(0);
} */

/* ---------------------- Compara el CRC de dos fichero -------------------- */
char pascal compbytes (FILE *f1, FILE *f2)
{
	register unsigned int i, leidos;
	unsigned char ig;
	unsigned char *mem1, *mem2, *aux1, *aux2;

	mem1=malloc(16384);
	if (mem1==0)
		return(-1);
	mem2=malloc(16384);
	if (mem2==0)
	{
		free(mem1);
		return(-1);
	}
	ig=1;
	rewind(f1);
	rewind(f2);
	do
	{
		leidos=fread(mem1, 1, 16384, f1);
		leidos=fread(mem2, 1, 16384, f2);
		aux1=mem1;
		aux2=mem2;
		for (i=0; i!=leidos; i++)
		{
			if ((*aux1)!=(*aux2))
				ig=0;
			else
			{
				aux1++;
				aux2++;
			}
		}
	}
	while ((leidos==16384) && (ig==1));

	free(mem1);
	free(mem2);

	if (ig==1)
		return(0);
	else
		return(1);
}

/* ------------------------------ Sale al DOS ----------------------------- */
void _fastcall salir(unsigned char e)
{
	cputs("\r\n\r\n");
	if (e==0)
	{
    textattr(2);
    cputs("Everything went O.k.\r\n");
	}
  else if (e==1)
	{
    textattr(12);
		cputs("Error(01): Wrong number of arguments.\r\n");
	}
	else if (e==2)
	{
    textattr(12);
		cputs("Error(02): No files found.\r\n");
	}
	else if (e==3)
	{
    textattr(12);
		cputs("Error(03): Cannot open file.\r\n");
	}
  else if (e==4)
	{
    textattr(12);
    cputs("Error(04): Cannot execute command.\r\n");
	}
	else if (e==5)
	{
    textattr(12);
		cputs("Error(05): OLD files and NEW files cannot be the same.\r\n");
	}
	else if (e==100)
	{
		textattr(12);
    cputs("\r\Error(100): Program aborted by user.\r\n");
	}
	textattr(7);
	setcbrk(0);
  cputs(" \r\n");
  fcloseall();
	exit(e);
}

/* ----------- Muestra el copyright del programa por pantalla ------------ */
void _fastcall copyright (char *ruta)
{
	char nombre[9];
	char nada[80];

	fnsplit(ruta, nada, nada, nombre, nada);
	textattr(3);
	cputs("\r\n\r\n");
  cputs("            (c) Copyright 1996-1997 ");
	textattr(11);
	cputs("De Trans Software\r\n");
	textattr(3);
  cputs("                              PSHELLD Version 1 Revision 04\r\n");
	cputs("                \r\n");
  cputs("                            DOS based shell for DIFF, DIF2PAT,\r\n");
  cputs("                           and INFOPAT.\r\n");
	textattr(3);
	cputs("\r\n");
  #ifndef COMERCIAL
  cputs("Shareware Version ");
  #endif
  #ifdef COMERCIAL
  cputs("Registered Version ");
  #endif
	textattr(7);
	cprintf("[DOS v%u.%02u; %uK/%uK]", _osmajor, _osminor, biosmemory(), (unsigned int) (farcoreleft()>>10));
	textattr(11);
	cprintf("\r\nType %s /? if you need help and %s /* for internal information.\r\n", nombre, nombre);
}

/* ------------------------- Puntua un long ------------------------------- */
char * pascal puntua (long int n)
{
	register unsigned int i, j=0, k=0;
	static char tmp[15], res[20];

	memset(tmp, 0, 15);
	memset(res, 0, 20);
	ltoa(n, tmp, 10);
	if (n<1000)
		return(tmp);
	strrev(tmp);
	for (i=0; i!=strlen(tmp); i++)
	{
		if (j==3)
		{
			j=0;
			res[k]=',';
			k++;
		}
		res[k]=tmp[i];
		j++;
		k++;
	}
	strrev(res);
	return(res);
}

/* --------------------- Muestra la ayuda por pantalla -------------------- */
void _fastcall ayuda (void)
{
	textattr(3);
	cputs("\r\n");
  cputs("                     Version 1 Revision 04\r\n");
  cputs("                      (c) Copyright 1996-1997\r\n");
  cputs("                                   by\r\n");
  cputs("                De Trans Software (DTS)\r\n");
	cputs("\r\n\r\n");
	textattr(7);
  cputs("  PSHELLD is a shell for using DIFF, DIF2PAT, and INFOPAT. It will be call\r\n");
  cputs("the apropiate program for making the entire patch process.\r\n");
  cputs("  PShellD <Old><New></P></S>\r\n\r\n");
  cputs("  <Old> and <New> are the specifications that complain the old and new.\r\n\r\n");
	#ifdef COMERCIAL
    cputs("  This is the registered version of PShellD, so, please, don't\r\n");
    cputs("distribute this program. Thank you for registering.\r\n\r\n");
		cputs("  You are allowed to distribute files that use PATCH package due of having\r\n");
    cputs("the registered version.\r\n\r\n");
		cputs("  If you have questions, or suggestions, please write to:\r\n\r\n");
  #endif
	#ifndef COMERCIAL
    cputs("  You are not allowed to distribute files that use PATCH package due of\r\n");
		cputs("having the shareware version.\r\n\r\n");
    cputs("  If you want to distribute files that use PATCH, you must register\r\n");
    cputs("by sending 2500 Ptas or 25 US$ to us, and you will receive the latest\r\n");
		cputs("registered version available, and a written permission for using PATCH.\r\n\r\n");
		cputs("  If you want to register, have questions, or suggestions, please write to:\r\n\r\n");
	#endif
	textattr(15);
	cputs("                    De Trans Software (DTS)\r\n");
	cputs("                    Javier Gutirrez Chamorro\r\n");
	cputs("                    Av. Meridiana 336, 7 C\r\n");
	cputs("                    08027. Barcelona. [SPAIN]");
	bioskey(0);
	salir(200);
}

/* --------------------- Muestra la ayuda por pantalla -------------------- */
void _fastcall info (char *nombre)
{
  FILE *f;

  f=fopen(nombre, "rb");
  textattr(3);
	cputs("\r\n");
  cputs("                     Version 1 Revision 04\r\n");
  cputs("                      (c) Copyright 1996-1997\r\n");
  cputs("                                   by\r\n");
  cputs("                De Trans Software (DTS)\r\n");
	cputs("\r\n\r\n");
	textattr(7);
  cputs(" Compiler:                         Borland C++ v4.5.\r\n");
	cputs(" Assembler:                        Turbo Assembler v3.2.\r\n");
	#ifdef __TINY__
		cputs(" Memory model:                     TINY.\r\n");
	#endif
	#ifdef __SMALL__
		cputs(" Memory model:                     SMALL.\r\n");
	#endif
	#ifdef __MEDIUM__
		cputs(" Memory model:                     MEDIUM.\r\n");
	#endif
	#ifdef __COMPACT__
		cputs(" Memory model:                     COMPACT.\r\n");
	#endif
	#ifdef __LARGE__
		cputs(" Memory model:                     LARGE.\r\n");
	#endif
	#ifdef __HUGE__
		cputs(" Memory model:                     HUGE.\r\n");
	#endif
	cprintf(" File:                             %s.\r\n", strupr(__FILE__));
	cprintf(" Lines:                            %s.\r\n", puntua((long int) __LINE__+10));
	cprintf(" Date:                             %s.\r\n", __DATE__);
	cprintf(" Time:                             %s.\r\n", __TIME__);
  cprintf(" Build:                            %u.\r\n", BUILD);
  cprintf(" Executable size:                  %s.\r\n", puntua(filelength(fileno(f))));
  fclose(f);
	salir(200);
}
