#include <alloc.h>
#include <bios.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PAUSA 250

/* -------------------------- Funcions de suport -------------------------- */
unsigned int pascal esrata (void);
void pascal mostrarrata (void);
void pascal ocultarrata (void);
void pascal llegirrata (int *, int *, int *);
void pascal guardarrata (int, int, int);
void pascal margerata (int, int, int, int);

/* ----------------------- Funcions de baix nivell  ----------------------- */
void pascal entrar (void);
void pascal sortir (unsigned int);
void pascal fons (void);
void pascal caixa (unsigned int, unsigned int, unsigned int, unsigned int, char *);
void pascal estat (char *);
unsigned int pascal vmenu (unsigned int, unsigned int, char [][41], unsigned int, unsigned int);
unsigned int pascal hmenu (unsigned int, unsigned int, char [][21], unsigned int, unsigned int);
void pascal boto (unsigned int, unsigned int, char *);
void escriure (unsigned int, unsigned int, unsigned int, unsigned int, char *, ...);
void pascal cursor (int *, int *);

/* ------------------------ Funcions d'alt nivell  ------------------------ */
void pascal sobre (void);
void pascal info (void);
void pascal principal (void);
void pascal linia_bres (void);
void pascal circumferencia_bres (void);
void pascal dibuixar_punts (int, int, int, int);



/* ------------------------- Programa pricipal ---------------------------- */
void main (void)
{
	entrar();
	fons();
	sobre();
	info();
	principal();
	sortir(0);
}

/* ------------------------- Mira si hi ha ratoli ------------------------- */
unsigned int pascal esrata (void)
{
	union REGS r;

	r.x.ax=0;
	int86(0x33, &r, &r);
	if (r.x.ax==0)
		return(0);
	else
		return(r.x.bx);
}

/* -------------------------- Ensenya el ratol --------------------------- */
void pascal mostrarrata (void)
{
	union REGS r;

	r.x.ax=1;
	int86(0x33, &r, &r);
}

/* --------------------------- Oculta el ratol --------------------------- */
void pascal ocultarrata (void)
{
	union REGS r;

	r.x.ax=2;
	int86(0x33, &r, &r);
}

/* ------------------- Llegeix les coordenades del ratol ----------------- */
void pascal llegirrata (int *x, int *y, int *b)
{
	union REGS r;

	r.x.ax=3;
	int86(0x33, &r, &r);
	*b=r.x.bx;
	*x=r.x.cx;
	*y=r.x.dx;
}

/* ------------------- Guarda les coordenades del ratol ------------------ */
void pascal guardarrata (int x, int y, int b)
{
	union REGS r;

	r.x.ax=4;
	r.x.bx=b;
	r.x.cx=x;
	r.x.dx=y;
	int86(0x33, &r, &r);
}

/* ------------------- Guarda les coordenades del ratol ------------------ */
void pascal margerata (int x1, int y1, int x2, int y2)
{
	union REGS r;

	r.x.ax=7;
	r.x.cx=x1;
	r.x.dx=x2;
	int86(0x33, &r, &r);
	r.x.ax=8;
	r.x.cx=y1;
	r.x.dx=y2;
	int86(0x33, &r, &r);

}

/* ------------ Inicialitza el mode grfic 640x480 16/256 colors  --------- */
void pascal entrar (void)
{
	int driver, mode;

	textattr(15);
	cprintf("Prctica de Geometria Computacional I v1.00 per DOS ");
	textattr(7);
	cputs("[VGA 640x480 16 colors]\r\n");
	delay(PAUSA);
	/* 640x480 16 colors */
	driver=VGA;
	mode=VGAHI;
	initgraph (&driver, &mode, "");
	if (graphresult()!=grOk)
		sortir(1);
	if (!esrata())
		sortir(2);
	guardarrata(320, 240, 0);
	margerata(1, 1, 639, 471);
}

/* -------------------------- Surt del programa --------------------------- */
void pascal sortir (unsigned int e)
{
	register unsigned int i;
	char *oldb;
	char sino[][21]={	"Si, vull sortir",
							"No, vull seguir"};

	if (e==0)
	{
		oldb=malloc(imagesize(180, 180, 459, 259));
		if (oldb==0)
			sortir(3);
		getimage(180, 180, 459, 259, oldb);
		caixa(180, 180, 459, 259, "Sortir al OS");
		escriure(200, 200, 0, 15, "Segur que vols sortir del");
		escriure(200, 210, 0, 15, "programa?");
		estat("[Sortir]. Tria el bot desitjat.");
		i=hmenu(190, 239, sino, 2, 17*8);
		putimage(180, 180, oldb, COPY_PUT);
		free(oldb);
		if (i==1)
			return;
		else
		{
			closegraph();
			textattr(15);
			cputs("Prctica de Geometria Computacional I v1.00 per DOS\r\n");
			textattr(2);
			cputs("Tot ha concluit correctament.\r\n");
		}
	}
	else if (e==1)
	{
		closegraph();
		textattr(12);
		cprintf("Error(01): Impossible inicialitzar grfics.\r\n");
	}
	else if (e==2)
	{
		closegraph();
		textattr(12);
		cprintf("Error(02): Impossible inicialitzar ratol.\r\n");
	}
	else if (e==2)
	{
		closegraph();
		textattr(12);
		cprintf("Error(03): Impossible reservar memria.\r\n");
	}
	textattr(7);
	cputs(" \r");
	exit(e);
}

/* ------------------- Dibuixa el fons de la pantalla --------------------- */
void pascal fons (void)
{
	cleardevice();
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 0, 639, 471);
	setcolor(8);
	rectangle(0, 470, 639, 479);
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 471, 638, 478);
}

/* --------------------- Actualiza la linia d'estat ----------------------- */
void pascal estat (char *text)
{
	setcolor(8);
	rectangle(0, 470, 639, 479);
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 471, 638, 478);
	setcolor(0);
	outtextxy(4, 471, text);
}

/* ---------------------------- Dibuixa un boto --------------------------- */
void pascal boto (unsigned int x, unsigned int y, char *text)
{
	setcolor(0);
	rectangle(x, y, x+(strlen(text)<<3)+4, y+12);
	setcolor(8);
	rectangle(x+1, y+1, x+(strlen(text)<<3)+3, y+11);
	setfillstyle(SOLID_FILL, 7);
	bar(x+2, y+2, x+(strlen(text)<<3)+2, y+10);
	setcolor(0);
	outtextxy(x+3, y+3, text);
}

/* -------------------------- Dibuixa una caixa --------------------------- */
void pascal caixa (unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, char *text)
{
	setcolor(15);
	setfillstyle(SOLID_FILL, 1);
	bar(x1+4, y1+4, x2-4, y1+15);
	escriure(x1+6, y1+6, 15, 1, text);
	setcolor(0);
	rectangle(x1, y1, x2, y2);
	rectangle(x1+1, y1+1, x2-1, y2-1);
	setcolor(8);
	rectangle(x1+2, y1+2, x2-2, y2-2);
	rectangle(x1+3, y1+3, x2-3, y2-3);
	setcolor(15);
	setfillstyle(SOLID_FILL, 15);
	bar(x1+4, y1+16, x2-4, y2-4);
}

/* -------------------------- Fa un menu vertical ------------------------- */
unsigned int pascal vmenu (unsigned int x1, unsigned int y1, char menu[][41], unsigned int noptions, unsigned int separation)
{
	register int y, x;
	int tx, ty, l;

	l=strlen(menu[0])-1;
	for (y=0; y!=noptions; y++)
		boto(x1, y1+y*separation, menu[y]);
	y=-1;
	do
	{
		cursor(&tx, &ty);
		if ((tx>=x1) && (tx<=(x1+(l<<3))))
		{
			x=(ty-y1)/separation;
			if ((x>=0) && (x<noptions))
				y=x;
		}
	}
	while (y==-1);
	return(y);
}

/* ------------------------- Fa un menu horitzontal ----------------------- */
unsigned int pascal hmenu (unsigned int x1, unsigned int y1, char menu[][21], unsigned int noptions, unsigned int separation)
{
	register int y, x;
	int tx, ty;

	for (x=0; x!=noptions; x++)
		boto(x1+x*separation, y1, menu[x]);
	x=-1;
	do
	{
		cursor(&tx, &ty);
		if ((ty>=y1) && (ty<=y1+8))
		{
			y=(tx-x1)/separation;
			if ((y>=0) && (y<noptions))
				x=y;
		}
	}
	while (x==-1);
	return(x);
}

/* ------------------- Actualitza la posici del cursor ------------------- */
void pascal cursor (int *x, int *y)
{
	register unsigned int tecla;
	int b;

	mostrarrata();
	delay(PAUSA);
	do
	{
		do
		{
			llegirrata(x, y, &b);
			if (b&1)
				tecla=0x1C0D;
			else if (b&2)
				tecla=0x011B;
			else
				tecla=bioskey(1);
		}
		while (!tecla);
		if (b&1)
			tecla=0x1C0D;
		else if (b&2)
				tecla=0x011B;
		else
			tecla=bioskey(0);
		if (tecla==0x4800)
			(*y)--;
		else if (tecla==0x5000)
			(*y)++;
		else if (tecla==0x4B00)
			(*x)--;
		else if (tecla==0x4D00)
			(*x)++;
		if ((*x)<0)
			*x=0;
		else if ((*x)>639)
			*x=639;
		if ((*y)<0)
			*y=0;
		else if ((*y)>479)
			*y=479;
		guardarrata(*x, *y, 0);
		escriure(520, 471, 0, 7, "(%03d, %03d)", *x, *y);

	}
	while ((tecla!=0x1C0D) && (tecla!=0x011B));
	if (tecla==0x011B)
	{
		*x=-1;
		*y=-1;
	}
	ocultarrata();
}

/* ---------------------- Escriu un text a pantalla ----------------------- */
void escriure (unsigned int x, unsigned int y, unsigned int c1, unsigned int c2, char *buf, ...)
{
	 va_list argptr;
	 char aux[256];

	 va_start(argptr, buf);
	 vsprintf(aux, buf, argptr);
	 va_end(argptr);

	 setcolor(c1);
	 setfillstyle(SOLID_FILL, c2);
	 bar(x, y, x+(strlen(aux)<<3), y+8);
	 outtextxy(x, y, aux);
}

/* --------------------- Mostra la ventana del sobre ---------------------- */
void pascal sobre (void)
{
	int k;
	char *oldb;

	oldb=malloc(imagesize(200, 100, 479, 300));
	if (oldb==0)
		sortir(3);
	getimage(200, 100, 479, 300, oldb);
	caixa(200, 100, 479, 300, "Sobre el programa");
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(0);
	outtextxy(339, 135, "Prctica de GEOC I v1.00");
	outtextxy(339, 155, "-");
	outtextxy(339, 175, "Aquest programari s");
	outtextxy(339, 185, "realitzat per:");
	outtextxy(339, 205, "Bernardino Casas Fernndez");
	outtextxy(339, 215, "Javier Gutirrez Chamorro");
	outtextxy(339, 235, "");
	outtextxy(339, 255, "(c) Copyright 1997-1998.");
	outtextxy(339, 265, "Tots els drets reservats");
	settextjustify(LEFT_TEXT, TOP_TEXT);
	estat("[Sobre]. Pitja qualsevol tecla o bot.");
	cursor(&k, &k);
	putimage(200, 100, oldb, COPY_PUT);
	free(oldb);
}

/* ------------------- Mostra la ventana d'informaci --------------------- */
void pascal info (void)
{
	int k;
	char *oldb;
	char tmp[80];

	oldb=malloc(imagesize(50, 180, 589, 320 ));
	if (oldb==0)
		sortir(3);
	getimage(50, 180, 589, 320, oldb);
	caixa(50, 180, 589, 320, "Informaci");
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(0);
	sprintf(tmp, "Memoria base total: %u Koctets", biosmemory());
	outtextxy(320, 200, tmp);
	sprintf(tmp, "Memoria base lliure: %u Koctets", coreleft()>>10);
	outtextxy(320, 210, tmp);
	sprintf(tmp, "Mode de video: VGA 640x480 16 colors");
	outtextxy(320, 230, tmp);
	if (_8087==0)
		sprintf(tmp, "Coprocessador matemtic: No instal.lat");
	else
		sprintf(tmp, "Coprocessador matemtic: 80%u87 instal.lat", _8087);
	outtextxy(320, 250, tmp);
	sprintf(tmp, "Ratol: %u botons instal.lat", esrata());
	outtextxy(320, 270, tmp);
	sprintf(tmp, "DOS versi: %u.%02u", _osmajor, _osminor);
	outtextxy(320, 290, tmp);
	settextjustify(LEFT_TEXT, TOP_TEXT);
	cursor(&k, &k);
	putimage(50, 180, oldb, COPY_PUT);
	free(oldb);
}

/* ---------------------- Mostra el men principal ------------------------ */
void pascal principal (void)
{
	register int i;
	int x, y;
	char *oldb;
	char menu[][41]={
										"       Linia Bres.       ",
										"   Circumferncia Bres.  ",
										"     Esborrar Pantalla   ",
										"        Cancel.lar       ",
										"          Sortir         "
									};
	while(1)
	{
		do
		{
			estat("[Principal]. Escape o bot dret per veure el menu");
			do
			{
				cursor(&x, &y);
			}
			while (x!=-1);
			estat("[Principal]. Marca la comanda desitjada");
			oldb=malloc(imagesize(190, 150, 449, 329));
			if (oldb==0)
				sortir(3);
			getimage(190, 150, 449, 329, oldb);
			caixa(190, 150, 449, 329, "Menu Bresenham");
			i=vmenu(215, 190, menu, 5, 18);
			putimage(190, 150, oldb, COPY_PUT);
			free(oldb);
			switch(i)
			{
				case 0:
						linia_bres();
						break;
				case 1:
						circumferencia_bres();
						break;
				case 2:
						fons();
						break;
			}
		}
		while (i!=4);
		sortir(0);
	}
}

/* -------------- Dibuixa una lnia amb el mtode de Bresenham ------------ */
void pascal linia_bres (void)
{
	int x1, y1, x2, y2;
	int ix, iy, aux, i, p, color=0;

	estat("[Linea]. Selecciona amb cursors el primer punt, i ENTER per confirmar");
	cursor(&x1, &y1);
	if (x1!=-1)
	{
		putpixel(x1, y1, 12);
		estat("[Linea]. Selecciona amb cursors el segon punt, i ENTER per confirmar");
		cursor(&x2, &y2);
		if (x2!=-1)
		{
			ix = x2-x1;		/* Calculem l'increment de x */
			iy = y2-y1;		/* Calculem l'increment de y */

			/* Pendents entre 0 i 1 (1 incls) quan ix i iy sn positius */
			if ( ((ix>=iy) && (ix>=0) && (iy>=0)) || ((ix<=iy) && (ix<=0) && (iy<=0)) )
			{
				if ((ix>=0) && (iy>=0)) i=1;
				else i=-1;

				ix = abs (x2-x1);
				iy = abs (y2-y1);

				p= 2*iy - ix;
				putpixel (x1, y1, color);

				while ((x1!=x2) || (y1!=y2))	/* No acabarem fins que els punts */
				{										/* no siguin iguals */
					x1+=i;
					if (p>0)
					{
						y1+=i;
						p+= 2*(iy-ix);
					}
					else p+= 2*iy;

					putpixel (x1, y1, color);
				}
			}	/* end if */

			else
			{
			/* Pendents ms grans que 1 */
				if (((ix<iy) && (ix>=0) && (iy>=0)) || ((ix>iy) && (ix<=0) && (iy<=0)))
				{
					if ((ix>=0) && (iy>=0)) i=1;
					else i=-1;

					aux = x1;
					x1 = y1;
					y1 = aux;
					aux = x2;
					x2 = y2;
					y2 = aux;

					ix = abs (x2-x1);
					iy = abs (y2-y1);

					p= 2*iy - ix;
					putpixel (y1, x1, color);

					while ((x1!=x2) || (y1!=y2))  /* No acabarem mentre els punts */
					{							   		/* no siguin iguals */
						x1+=i;
						if (p>0)
						{
							y1+=i;
							p+= 2*(iy-ix);
						}
						else p+= 2*iy;
						putpixel (y1, x1, color);
					}
				}	/* end if */

				/* Pendents negatives */
				else
				{
					if ((ix>0) && (iy<0)) i=1;
					else i=-1;

					ix = abs (x2-x1);
					iy = abs (y2-y1);

					if (ix>iy)
					{
						p= 2*iy - ix;
						putpixel (x1, y1, color);

						while ((x1!=x2) || (y1!=y2))	/* No acabarem mentre els punts */
						{										/*	no siguin iguals */
							x1+=i;
							if (p>0)
							{
								y1-=i;
								p+= 2*(iy-ix);
							}
							else p+= 2*iy;
							putpixel (x1, y1, color);
						}
					}
					else
					{
						aux = x1;
						x1 = y1;
						y1 = aux;
						aux = x2;
						x2 = y2;
						y2 = aux;

						ix = abs (x2-x1);
						iy = abs (y2-y1);

						p= 2*iy - ix;
						putpixel (y1, x1, color);

						while ((x1!=x2) || (y1!=y2))	/* No acabarem mentre els punts */
						{										/*	no siguin iguals */
							x1-=i;
							if (p>0)
							{
								y1+=i;
								p+= 2*(iy-ix);
							}
							else p+= 2*iy;
							putpixel (y1, x1, color);
						}
					}
				}	/* end if */
			}
		}
	}
}

/* --------- Dibuixa una circumferncia amb el mtode de Bresenham -------- */
void pascal circumferencia_bres (void)
{
	int centre_x, centre_y, x2, y2, r;
	int x=0, y, p;

	estat("[Circumferencia]. Selecciona amb cursors el centre, i ENTER per confirmar");
	cursor(&centre_x, &centre_y);
	if (centre_x!=-1)
	{
		putpixel(centre_x, centre_y, 12);
		estat("[Circumferencia]. Selecciona amb cursors el radi, i ENTER per confirmar");
		cursor(&x2, &y2);
		if (x2!=-1)
		{
			putpixel(x2, y2, 12);
			r=sqrt(pow((y2-centre_y),2)+pow((x2-centre_x),2));
			p=3-2*r;
			y=r;
			while (x<y)
			{
				dibuixar_punts(centre_x, centre_y, x, y);
				if (p<0)
					p+=4*x+6;
				else
				{
					p+=4*(x-y)+10;
					y--;
				}
				x++;
			}
			if (x==y)
				dibuixar_punts(centre_x, centre_y, x, y);
		}
   }
}

/* ------------------------ Dibuixar_punts -------------------------------- */
void pascal dibuixar_punts (int centre_x, int centre_y, int x, int y)
{
	putpixel(centre_x + x, centre_y + y, 0);
	putpixel(centre_x + x, centre_y - y, 0);
	putpixel(centre_x - x, centre_y + y, 0);
	putpixel(centre_x - x, centre_y - y, 0);
	putpixel(centre_x + y, centre_y + x, 0);
	putpixel(centre_x + y, centre_y - x, 0);
	putpixel(centre_x - y, centre_y + x, 0);
	putpixel(centre_x - y, centre_y - x, 0);
}