/********** includes **********/
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <dos.h>
#include "libgraf.h"


/********** Prototipus de les accions i funcions **********/
Pol2D CreaPoligon (void);
Window CalculaWindow (Capsa2D);
Viewport CalculaViewport (int, int, int, int);
void Visualitza (Pol2D, mat3x3);

void main (void)
{
	int graphdriver, graphmode;
	Pol2D pol;
	Capsa2D capsa;
	Window win;
	Viewport view;
	mat3x3 mat;
	int x, y;

	detectgraph (&graphdriver, &graphmode);

	if (graphdriver<0)
	{
		printf("No s'ha detectat hard grfic.");
		exit(1);
	}
	printf("Driver grfic nm.%d mode %d.", graphdriver, graphmode);
	initgraph(&graphdriver, &graphmode, "");

  randomize();
	pol=CreaPoligon();
	capsa=CapsaMinContPol2D(pol);
	win=CalculaWindow(capsa);
	x=getmaxx();
	y=getmaxy();

	view=CalculaViewport(0,0,x,y);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	view=CalculaViewport(0,0,x/2,y/2);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	view=CalculaViewport(x/2+1,0,x,y/2);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	view=CalculaViewport(0,y/2+1,x/2,y);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	view=CalculaViewport(x/2+1,y/2+1,x,y);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	getch();
	closegraph();
}

Pol2D CreaPoligon (void)
{
	Pol2D pol;

	pol.nv=3;
	pol.v[0].x=10;
	pol.v[0].y=11.3;
	pol.v[1].x=21;
	pol.v[1].y=11.3,
	pol.v[2].x=16;
	pol.v[2].y=21;

	return(pol);
}

Window CalculaWindow (Capsa2D capsa)
{
	Window win;
	float alcada, amplada;

	amplada=capsa.vmax.x-capsa.vmin.x;
	amplada=(amplada*5)/100;
	win.vmin.x=capsa.vmin.x-amplada;
	win.vmax.x=capsa.vmax.x+amplada;
	alcada=capsa.vmax.y-capsa.vmax.x;
	alcada=(alcada*5)/100;
	win.vmin.y=capsa.vmin.y-alcada;
	win.vmax.y=capsa.vmax.y+alcada;

	return(win);
}

Viewport CalculaViewport (int esquerra, int inf, int dreta, int sup)
{
	Viewport view;

	view.vmin.x=esquerra;
	view.vmin.y=inf;
	view.vmax.x=dreta;
	view.vmax.y=sup;

	return (view);
}

void Visualitza (Pol2D pol, mat3x3 mat)
{
	unsigned int i;
	PtDisp p;
	int poligon[2*MAXVER];

	for (i=0; i<pol.nv; i++)
	{
		p=TrMonDisp(pol.v[i], mat);
		poligon[2*i]=p.x;
		poligon[2*i+1]=p.y;
	}
	poligon[2*i]=poligon[0];
	poligon[2*i+1]=poligon[1];
	pol.nv++;
	setfillstyle(SOLID_FILL, random(15)+1);
	fillpoly(pol.nv, poligon);
}
