/********** includes **********/
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <dos.h>
#include <time.h>
#include <conio.h>
#include "libgraf.h"
#include "teclat.h"


/********** Prototipus de les accions i funcions **********/
Pol2D CreaPoligon (void);
Window CalculaWindow (Capsa2D);
Viewport CalculaViewport (int, int, int, int);
void Visualitza (Pol2D, mat3x3);

void main (void)
{
	int graphdriver, graphmode;
	Pol2D pol;
	Capsa2D capsa;
	Window win;
	Viewport view;
	mat3x3 mat;
	int x, y;

	detectgraph (&graphdriver, &graphmode);

	if (graphdriver<0)
	{
		printf("No s'ha detectat hard grfic.");
		exit(1);
	}
	printf("Driver grfic nm.%d mode %d.", graphdriver, graphmode);
	initgraph(&graphdriver, &graphmode, "");

	randomize();
	pol=CreaPoligon();
	clearviewport();
	capsa=CapsaMinContPol2D(pol);
	win=CalculaWindow(capsa);
	x=getmaxx();
	y=getmaxy();

	view=CalculaViewport(0,0,x,y);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	view=CalculaViewport(0,0,x/2,y/2);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	view=CalculaViewport(x/2+1,0,x,y/2);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	view=CalculaViewport(0,y/2+1,x/2,y);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	view=CalculaViewport(x/2+1,y/2+1,x,y);
	CreaMatTmd(win,view,mat);
	Visualitza(pol,mat);

	getch();
	closegraph();
}

Pol2D CreaPoligon (void)
{
	char c;
	mat3x3 mat;
	Pol2D pol;
	PtDisp pd, pd2, pdaux;
	int opc;
   boolea status;
	Window win;

	win.vmin.x=0;
	win.vmax.x=100;
	win.vmin.y=0;
	win.vmax.y=100;

	CreaMatTdm(win, CalculaViewport(1, 1, getmaxx(), getmaxy()), mat);
	IniLocatorTeclat(getmaxx()/2, getmaxy()/2, CalculaViewport(1, 1, getmaxx(), getmaxy()), 2);
	RequestLocatorTeclat(&pd.x, &pd.y, &c);
	putpixel(pd.x,pd.y,15);
	pol.v[0]=TrDispMon(pd, mat);
	pol.nv=1;
	pd2=pd;
	pdaux=pd2;
	c=RL_SPACE;
	setwritemode(XOR_PUT);

/*	do
	{
		RequestLocatorTeclat(&pd.x, &pd.y, &c);
		pol.v[pol.nv]=TrDispMon(pd, mat);
		pol.nv++;
		if (pol.nv==1)
		{
			putpixel(pd.x, pd.y, 15);
			moveto(pd.x, pd.y);
		}
		else
			lineto(pd.x, pd.y);
	}
	while(c!=RL_ESCAPE);*/

	do
	{
		SampleChoiceTeclat(&opc, &status);
		if (status)
		{
			switch (opc)
			{
				case C_FAMUNT: pd2.y-=4;
									if (pd2.y<0)
										pd2.y=0;
									break;

				case C_FAVALL: pd2.y+=4;
									if (pd2.y>getmaxy())
										pd2.y=getmaxy();
									break;

				case C_FESQ: pd2.x-=4;
									if (pd2.x<0)
										pd2.x=0;
									break;

				case C_FDRETA: pd2.x+=4;
									if (pd2.x>getmaxx())
										pd2.x=getmaxx();
									break;
				case C_RETURN: c=RL_RETURN;
									break;

				case C_ESCAPE: c=RL_ESCAPE;
									break;
			}
		}
		if ((pdaux.x!=pd2.x) || (pdaux.y!=pd2.y))
		{
			line(pd.x, pd.y, pdaux.x, pdaux.y);
			line(pd.x, pd.y, pd2.x, pd2.y);
			pdaux=pd2;
		}
		if (c==RL_RETURN)
		{
			pol.v[pol.nv]=TrDispMon(pd2, mat);
			pol.nv++;
			pd=pd2;
			c=RL_SPACE;
		}
	}
	while(c!=RL_ESCAPE);
	setwritemode(COPY_PUT);
	return(pol);
}

Window CalculaWindow (Capsa2D capsa)
{
	Window win;
	float alcada, amplada;

	amplada=capsa.vmax.x-capsa.vmin.x;
	amplada=(amplada*5)/100;
	win.vmin.x=capsa.vmin.x-amplada;
	win.vmax.x=capsa.vmax.x+amplada;
	alcada=capsa.vmax.y-capsa.vmin.y;
	alcada=(alcada*5)/100;
	win.vmin.y=capsa.vmin.y-alcada;
	win.vmax.y=capsa.vmax.y+alcada;

	return(win);
}

Viewport CalculaViewport (int esquerra, int inf, int dreta, int sup)
{
	Viewport view;

	view.vmin.x=esquerra;
	view.vmin.y=inf;
	view.vmax.x=dreta;
	view.vmax.y=sup;

	return (view);
}

void Visualitza (Pol2D pol, mat3x3 mat)
{
	unsigned int i;
	PtDisp p;
	int poligon[2*MAXVER];

	for (i=0; i<pol.nv; i++)
	{
		p=TrMonDisp(pol.v[i], mat);
		poligon[2*i]=p.x;
		poligon[2*i+1]=p.y;
	}
	poligon[2*i]=poligon[0];
	poligon[2*i+1]=poligon[1];
	pol.nv++;
	setfillstyle(SOLID_FILL, random(15)+1);
	fillpoly(pol.nv, poligon);
}
