/********** includes **********/
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <dos.h>
#include "libgraf.h"
#include "teclat.h"
#include "ratoli.h"


/********** Prototipus de les accions i funcions **********/
Pol2D CreaPoligon (void);
Window CalculaWindow (Capsa2D);
Viewport CalculaViewport (int, int, int, int);
void Visualitza (Pol2D, mat3x3);

void main (void)
{
	int graphdriver, graphmode;
	Pol2D pol;
	Capsa2D capsa;
	Window win;
	Viewport view;
	mat3x3 mat;
	int x1, y1, x2, y2;
	int tecla, boto, def;
	boolea status;
	float amplada, alcada;
	Pt2D p;
	PtDisp pd;

	detectgraph (&graphdriver, &graphmode);

	if (graphdriver<0)
	{
		printf("No s'ha detectat hard grfic.");
		exit(1);
	}
	printf("Driver grfic nm.%d mode %d.", graphdriver, graphmode);
	initgraph(&graphdriver, &graphmode, "");

	pol=CreaPoligon();
	capsa=CapsaMinContPol2D(pol);
	win=CalculaWindow(capsa);
	x1=0;
	y1=0;
	x2=getmaxx();
	y2=getmaxy();

	view=CalculaViewport(x1, y1, x2, y2);
	CreaMatTmd(win,view,mat);
	cleardevice();
	rectangle(0, 0, x2-x1, y2-y1);
	Visualitza(pol,mat);

	do
	{
		SampleChoiceTeclat(&tecla, &status);
		if (status)
		{
			AmagaRatoli();
			def=0;
			switch (toupper(tecla))
			{
				case 'P':
					x1=0;
					y1=0;
					x2=getmaxx();
					y2=getmaxy();
					break;

				case '+':
					x1-=getmaxx()*5/100;
					x2+=getmaxx()*5/100;
					y1-=getmaxy()*5/100;
					y2+=getmaxy()*5/100;
					if ((x1<0) || (y1<0) || (x2>getmaxx()) || (y2>getmaxy()))
					{
						x1+=getmaxx()*5/100;
						x2-=getmaxx()*5/100;
						y1+=getmaxy()*5/100;
						y2-=getmaxy()*5/100;
					}
					break;

				case '-':
					x1+=getmaxx()*5/100;
					x2-=getmaxx()*5/100;
					y1+=getmaxy()*5/100;
					y2-=getmaxy()*5/100;
					if (((x2-x1)<0) || ((y2-y1)<0))
					{
						x1-=getmaxx()*5/100;
						x2+=getmaxx()*5/100;
						y1-=getmaxy()*5/100;
						y2+=getmaxy()*5/100;
					}
					break;

				case C_FAMUNT:
					if ((y1-getmaxy()*5/100)<0)
					{
						y2=y2-y1;
						y1=0;
					}
					else
					{
						y1-=getmaxy()*5/100;
						y2-=getmaxy()*5/100;
					}
					break;

				case C_FAVALL:
					if ((y2+getmaxy()*5/100)>getmaxy())
					{
						y1+=getmaxy()-y2;
							y2=getmaxy();
					}
					else
					{
						y1+=getmaxy()*5/100;
						y2+=getmaxy()*5/100;
					}
					break;

				case C_FESQ:
					if ((x1-getmaxx()*5/100)<0)
					{
						x2=x2-x1;
						x1=0;
					}
					else
					{
						x1-=getmaxx()*5/100;
						x2-=getmaxx()*5/100;
					}
					break;

				case C_FDRETA:
					if ((x2+getmaxx()*5/100)>getmaxx())
					{
						x1+=getmaxx()-x2;
						x2=getmaxx();
					}
					else
					{
						x1+=getmaxx()*5/100;
						x2+=getmaxx()*5/100;
					}
					break;

				case 'C':
					capsa=CapsaMinContPol2D(pol);
					win=CalculaWindow(capsa);
					break;

				case 'I':
					amplada=(capsa.vmax.x-capsa.vmin.x)/4;
					alcada=(capsa.vmax.y-capsa.vmin.y)/4;
					capsa.vmin.x+=amplada;
					capsa.vmax.x-=amplada;
					capsa.vmin.y+=alcada;
					capsa.vmax.y-=alcada;
					win=CalculaWindow(capsa);
					break;

				case 'O':
					amplada=(capsa.vmax.x-capsa.vmin.x)/4;
					alcada=(capsa.vmax.y-capsa.vmin.y)/4;
					capsa.vmin.x-=amplada;
					capsa.vmax.x+=amplada;
					capsa.vmin.y-=alcada;
					capsa.vmax.y+=alcada;
					win=CalculaWindow(capsa);
					break;

				case C_INICIO:
				case C_SHIFT_FAMUNT:
					capsa.vmin.y--;
					capsa.vmax.y--;
					win=CalculaWindow(capsa);
					break;

				case C_FIN:
				case C_SHIFT_FAVALL:
					capsa.vmin.y++;
					capsa.vmax.y++;
					win=CalculaWindow(capsa);
					break;

				case C_DELETE:
				case C_SHIFT_FESQ:
					capsa.vmin.x++;
					capsa.vmax.x++;
					win=CalculaWindow(capsa);
					break;

				case C_AVPAG:
				case C_SHIFT_FDRETA:
					capsa.vmin.x--;
					capsa.vmax.x--;
					win=CalculaWindow(capsa);
					break;

				default:
					def=1;
					break;
			}
			if (!def)
			{
				view=CalculaViewport(x1, y1, x2, y2);
				CreaMatTmd(win,view,mat);
				cleardevice();
				rectangle(0, 0, x2-x1, y2-y1);
				Visualitza(pol,mat);
			}
		}
		MostraRatoli();
		SampleLocatorRatoli(&pd.x, &pd.y, &boto);
		if (boto==BOTO_ESQUERRE)
		{
			CreaMatTdm(win,view,mat);
			p=TrDispMon(pd, mat);
			settextstyle(DEFAULT_FONT, HORIZ_DIR, 2);
			setviewport(0,0,getmaxx(),getmaxy(),0);
			setfillstyle(SOLID_FILL, BLACK);
			bar(1, 1, (44-26)*16, 16);
			setcolor(WHITE);
			if (PtIntPol2D(p, pol))
				outtextxy(0, 0, "El punt s interior");
			else
				outtextxy(0, 0, "El punt s exterior");
		}
	}
	while (tecla!=C_ESCAPE && boto!=BOTO_DRET);

	closegraph();
}


Pol2D CreaPoligon (void)
{
	int boto;
	mat3x3 mat;
	Pol2D pol;
	PtDisp pd, pd2, pdaux;
	Window win;

	win.vmin.x=0;
	win.vmax.x=100;
	win.vmin.y=0;
	win.vmax.y=100;

	CreaMatTdm(win, CalculaViewport(1, 1, getmaxx(), getmaxy()), mat);
	IniLocatorRatoli(getmaxx()>>1, getmaxy()>>1, CalculaViewport(1, 1, getmaxx(), getmaxy()));
	pol.nv=0;
	RequestLocatorRatoli(&pd.x, &pd.y, &boto);
	pol.v[pol.nv]=TrDispMon(pd, mat);
	pol.nv++;
	pd2=pd;
	pdaux=pd2;
	setwritemode(XOR_PUT);

	do
	{
		MostraRatoli();
		SampleLocatorRatoli(&pd2.x, &pd2.y, &boto);
		if ((pdaux.x!=pd2.x) || (pdaux.y!=pd2.y))
		{
			AmagaRatoli();
			line(pd.x, pd.y, pdaux.x, pdaux.y);
			line(pd.x, pd.y, pd2.x, pd2.y);
			pdaux=pd2;
			MostraRatoli();
		}
		if (boto==BOTO_ESQUERRE)
		{
			pol.v[pol.nv]=TrDispMon(pd2, mat);
			pol.nv++;
			pd=pd2;
		}
	}
	while(boto!=BOTO_DRET);
	AmagaRatoli();
	setwritemode(COPY_PUT);
	return(pol);
}

Window CalculaWindow (Capsa2D capsa)
{
	Window win;
	float alcada, amplada;

	amplada=capsa.vmax.x-capsa.vmin.x;
	amplada=(amplada*5)/100;
	win.vmin.x=capsa.vmin.x-amplada;
	win.vmax.x=capsa.vmax.x+amplada;
	alcada=capsa.vmax.y-capsa.vmin.y;
	alcada=(alcada*5)/100;
	win.vmin.y=capsa.vmin.y-alcada;
	win.vmax.y=capsa.vmax.y+alcada;
	return(win);
}

Viewport CalculaViewport (int esquerra, int inf, int dreta, int sup)
{
	Viewport view;

	view.vmin.x=esquerra;
	view.vmin.y=inf;
	view.vmax.x=dreta;
	view.vmax.y=sup;

	return (view);
}

void Visualitza (Pol2D pol, mat3x3 mat)
{
	unsigned int i;
	PtDisp p;
	int poligon[2*MAXVER];

	for (i=0; i<pol.nv; i++)
	{
		p=TrMonDisp(pol.v[i], mat);
		poligon[2*i]=p.x;
		poligon[2*i+1]=p.y;
	}
	poligon[2*i]=poligon[0];
	poligon[2*i+1]=poligon[1];
	pol.nv++;
	setfillstyle(SOLID_FILL, 12);
	fillpoly(pol.nv, poligon);
}