#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#include <graphics.h>
#include "libgraf.h"
#include "pol3D.h"

typedef struct {
  float xc,yc,zc;
  float r;
	}esfera;

void EntraEsferes (int *n, esfera esf[20]);
Window CalculaWindow (int n, esfera esf[20]);
Viewport CalculaViewport (int esquerra, int inferior, int dreta, int superior);
int CalculaColor (int n,esfera esf[20],Pt2D pm);

void main(void)
{
struct palettetype pal;
esfera esf[20];
int color,i,j,graphdriver,graphmode,n;
Viewport vp;
Window win;
mat3x3 m;
Pt2D punt;
PtDisp pd;

detectgraph (&graphdriver, &graphmode);

if (graphdriver<0)
  {
  printf("No s'ha detectat hard grfic.");
  exit(1);
  }
printf("Driver grfic nm.%d mode %d.", graphdriver, graphmode);
initgraph(&graphdriver, &graphmode, "");
cleardevice();
getpalette(&pal);
for (i=0;i<pal.size;i++)
  {
  setrgbpalette(pal.colors[i],0,0,i*4);
  }

EntraEsferes (&n,esf);
vp=CalculaViewport(0,0,getmaxx()/2,getmaxy()/2);
win=CalculaWindow(n,esf);
CreaMatTdm (win,vp,m);

for (i=1;i<getmaxx()/2;i++)
  {
  for (j=1;j<getmaxy()/2;j++)
    {
    pd.x=i;
	 pd.y=j;
    punt=TrDispMon(pd,m);
    color=CalculaColor (n,esf,punt);
    putpixel(pd.x,pd.y,color);
    }
  }
outtextxy(200,300,"Prem una tecla per acabar");
getch();
}

int CalculaColor (int n,esfera esf[20],Pt2D pm)
{
int i,color;
float z,zunitari,modulvector,qx,qy,qr,prof,tindep,primgrau,seggrau;
double arrel,res;
z=-10000;
color=0;
  
for (i=0;i<n;i++)
  {
  qx=(pm.x-esf[i].xc)*(pm.x-esf[i].xc);
  qy=(pm.y-esf[i].yc)*(pm.y-esf[i].yc);
  qr=(esf[i].r)*(esf[i].r);
  if ((qx+qy)<qr)
	 {
    seggrau=1;
	 primgrau=-2*esf[i].zc;
    tindep=-(esf[i].r * esf[i].r)+(esf[i].zc * esf[i].zc)+qy+qx;
    arrel=(primgrau*primgrau)-(4*seggrau*tindep);
    if (arrel>0)
      {
      res=sqrt(arrel);
      }
    else
      {
      outtextxy(200,200,"Arrel negativa");
		getch();
		}
    prof=(-primgrau+res)/(2*seggrau);
	 if (prof>z)
      {
      z=prof;
      modulvector=sqrt(((pm.x-esf[i].xc)*(pm.x-esf[i].xc))+((pm.y-esf[i].yc)*(pm.y-esf[i].yc))+((z-esf[i].zc)*(z-esf[i].zc)));
      zunitari=(z-esf[i].zc)/modulvector;
      color=zunitari*15;
		}
	 }
  }
return(color);
}

Window CalculaWindow (int n, esfera esf[20])
{
	int i;
	Window w;

	w.vmin.x=esf[0].xc-esf[0].r;
	w.vmin.y=esf[0].yc-esf[0].r;
	w.vmax.x=esf[0].xc+esf[0].r;
	w.vmax.y=esf[0].yc+esf[0].r;

	for (i=1;i<n;i++)
	{
		if ((esf[i].xc-esf[i].r)<(w.vmin.x))
			w.vmin.x=esf[i].xc-esf[i].r;
		if ((esf[i].xc+esf[i].r)>(w.vmax.x))
			w.vmax.x=esf[i].xc+esf[i].r;
		if ((esf[i].yc-esf[i].r)<(w.vmin.y))
			w.vmin.y=esf[i].yc-esf[i].r;
		if ((esf[i].yc+esf[i].r)>(w.vmax.y))
			w.vmax.y=esf[i].yc+esf[i].r;
	}
/*	if (w.vmin.x>w.vmin.y)
		w.vmin.x=w.vmin.y;
	else if (w.vmin.x<w.vmin.y)
		w.vmin.y=w.vmin.x;
	if (w.vmax.x>w.vmax.y)
		w.vmax.y=w.vmax.x;
	else if (w.vmax.x<w.vmax.y)
		w.vmax.x=w.vmax.y;*/

/* w.vmin.x=max(w.vmin.x,w.vmin.y);
	w.vmin.y=max(w.vmin.x,w.vmin.y);*/
	w.vmax.x=min(w.vmax.x,w.vmax.y);
	w.vmax.y=min(w.vmax.x,w.vmax.y);

/* w.vmin.x=0;
	w.vmin.y=0;
	w.vmax.x=100;
	w.vmax.y=100;*/

	return(w);
}

void EntraEsferes (int *n, esfera esf[20])
{
	*n=3;
	esf[0].xc=50;
	esf[0].yc=50;
	esf[0].zc=100;
	esf[0].r=10;
	esf[1].xc=65;
	esf[1].yc=50;
	esf[1].zc=110;
	esf[1].r=15;
	esf[2].xc=60;
	esf[2].yc=100;
	esf[2].zc=100;
	esf[2].r=10;
}

Viewport CalculaViewport (int esquerra, int inferior, int dreta, int superior)
{
	Viewport v;

	v.vmin.x=esquerra;
	v.vmin.y=inferior;
	v.vmax.x=dreta;
	v.vmax.y=superior;
	if (v.vmax.x>v.vmax.y)
		v.vmax.y=v.vmax.x;
	else if (v.vmax.x<v.vmax.y)
		v.vmax.x=v.vmax.y;

	return(v);
}