/* Pol3d.h */

/* Tipus 3D */

#define MAXPOL 30
#define MAXARES 200
#define MAXVERT 60

typedef struct {
   float x, y, z;} Pt3D;

typedef struct {
   float vx, vy, vz;} Vec3D;

typedef struct{
   int na, pa;
   Vec3D norm; } Cara;

typedef struct{
   int nc, na, nv;
   Cara car[MAXPOL];
   int ares [MAXARES];
   Pt3D vert[MAXVERT];
   } Pol3D;

typedef struct {
   Pt3D vmin, vmax;} Capsa3D;

typedef float mat4x4[4][4];
typedef float vector4[4];

void Identitat4x4 (mat4x4 M);
void CreaMatTranslacio3D (float tx, float ty, float tz, mat4x4 M);
void CreaMatEscalat3D (float sx, float sy, float sz, mat4x4 M);
void CreaMatGir3DY (float a, mat4x4 M);
void CreaMatGir3DX (float a, mat4x4 M);
void ConcatMat4x4 (mat4x4 M1, mat4x4 M2);
void ProdMatVect4 (vector4 v, mat4x4 M, vector4 w);

Pol3D Translacional (Pol2D pol, Vec3D v);
void EscriuPoliedre (Pol3D obj);
void CalculaNormals (Pol3D *obj);
