/* ratoli.h  */

#define BOTO_NO 0
#define BOTO_ESQUERRE 1
#define BOTO_DRET 2

/*****************************************************************
 Inicialitza el dispositiu locator. Cal cridar-la almenys una vegada
 abans de realitzar un RequestLocatorRatoli o SampleLocatorRatoli.
      x, y: coordenades inicials del cursor.
         v: viewport d'entrada.
 *****************************************************************/
void IniLocatorRatoli (int x, int y, Viewport v);


/*****************************************************************
  Demana un punt via ratol.
  Retorna les coordenades del punt on s'ha apretat un bot.
      x, y: coordenades del punt seleccionat.
      boto: bot del ratol apretat (BOTO_ESQUERRA o BOTO DRET).
 *****************************************************************/
void RequestLocatorRatoli (int *x, int *y, int *boto);


/*************************************************************
   Mira un punt via ratol.
   Retorna les coordenades del punt on est situat el ratol
   i ens indica si s'ha apretat un bot i quin bot.
      x, y: coordenades del punt on est situat.
      boto: no apretat (BOTO_NO) o bot del
             ratol apretat (BOTO_ESQUERRA o BOTO DRET).
 *************************************************************/
void SampleLocatorRatoli (int *x, int *y, int *boto);

/* Aquestes funcions sn interessants per controlar quan volem
   veure el punter del ratol en l's de SampleLocatorRatoli */
void MostraRatoli(void);
void AmagaRatoli(void);
