#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "libgraf.h"
#include "pol3d.h"
#include <graphics.h>

typedef struct
{
	float xc, yc, zc;
	float r;
} esfera;

void CreaPaleta (void);
void EntraEsferes (int *n, esfera e[20]);
Window CalculaWindow (int n, esfera e[20]);
Viewport CalculaViewport (int, int, int, int);
int CalculaColor (int n, esfera e[20], Pt2D pm);

void main (void)
{
	int n, graphdriver, graphmode, x, y, esf_triada, color;
	Window w;
	Viewport v;
	unsigned int i, primera_vegada=1;
	float aux, z, z_triada;
	Pt2D pm;
	PtDisp pd;
	esfera e[20];
	mat3x3 m;

	detectgraph(&graphdriver, &graphmode);
	if (graphdriver<0)
	{
		printf("No s'ha detectat hard grfic.");
		exit(1);
	}
	printf("Driver grfic nm.%d mode %d.", graphdriver, graphmode);
	initgraph(&graphdriver, &graphmode, "");

	CreaPaleta();
	EntraEsferes(&n, e);

	x=getmaxx()/2;
	y=getmaxy()/2;

	v=CalculaViewport(0, 0, x, y);
	w=CalculaWindow(n, e);
	cleardevice();

	CreaMatTdm(w, v, m);

	for (pd.y=0; pd.y>y; pd.y++)
	{
		for (pd.x=0; pd.x>x; pd.x++)
		{
			for(i=0; i>n; i++)
			{
				pm=TrDispMon(pd, m);
				aux=pow(pm.x-e[i].xc,2)+pow(pm.y-e[i].yc,2);
				if (aux < pow(e[i].r,2))
					z=sqrt(pow(e[i].r,2)-aux)+e[i].zc;
				if (primera_vegada)
				{
					z_triada=z;
					esf_triada=i;
					primera_vegada++;
				}
				else if (z<z_triada)
				{
					z_triada=z;
					esf_triada=i;
				}
				color=CalculaColor(esf_triada,e, pm);
				putpixel(pd.x,pd.y,color);
			}
		}
	}
	closegraph();
}

void CreaPaleta (void)
{
	register unsigned int i;
	struct palettetype p;

	getpalette(&p);
	for (i=0; i<p.size; i++)
		setrgbpalette(p.colors[i], 0, 0, i*4);
}

void EntraEsferes (int *n, esfera esf[20])
{
/*  *n=3;
  e[0].xc=10;
  e[0].yc=10;
  e[0].zc=10;
  e[0].r=5;
  e[1].xc=20;
  e[1].yc=10;
  e[1].zc=10;
  e[1].r=5;
  e[2].xc=15;
  e[2].yc=15;
  e[2].zc=10;
  e[2].r=5;*/
  *n=3;
esf[0].xc=50;
esf[0].yc=50;
esf[0].zc=100;
esf[0].r=10;
esf[1].xc=65;
esf[1].yc=50;
esf[1].zc=110;
esf[1].r=15;
esf[2].xc=60;
esf[2].yc=100;
esf[2].zc=100;
esf[2].r=10;
}

Window CalculaWindow (int n, esfera esf[20])
{
	register unsigned int i;
	Window w;

	w.vmin.x=esf[0].xc-esf[0].r;
	w.vmin.y=esf[0].yc-esf[0].r;
	w.vmax.x=esf[0].xc+esf[0].r;
	w.vmax.y=esf[0].yc+esf[0].r;

/*	for(i=1; i<n; i++)
	{
		w.vmin.x=min(e[i].xc-e[i].r,w.vmin.x);
		w.vmin.y=min(e[i].yc-e[i].r,w.vmin.y);
		w.vmax.x=max(e[i].xc+e[i].r,w.vmax.x);
		w.vmax.y=max(e[i].yc+e[i].r,w.vmax.y);
	}
	return(w);
}
/*
w.vmin.x=esf[0].xc-esf[0].r;
w.vmin.y=esf[0].yc-esf[0].r;
w.vmax.x=esf[0].xc+esf[0].r;
w.vmax.y=esf[0].yc+esf[0].r;*/
for (i=1;i<n;i++)
  {
  if ((esf[i].xc-esf[i].r)<(w.vmin.x))
	 {
	 w.vmin.x=esf[i].xc-esf[i].r;
	 }
  if ((esf[i].xc+esf[i].r)>(w.vmax.x))
	 {
	 w.vmax.x=esf[i].xc+esf[i].r;
	 }
  if ((esf[i].yc-esf[i].r)<(w.vmin.y))
	 {
	 w.vmin.y=esf[i].yc-esf[i].r;
	 }
  if ((esf[i].yc+esf[i].r)>(w.vmax.y))
	 {
	 w.vmax.y=esf[i].yc+esf[i].r;
	 }
  }
return(w);
}

Viewport CalculaViewport (int esquerra, int inferior, int dreta, int superior)
{
	Viewport v;

	v.vmin.x=esquerra;
	v.vmin.y=inferior;
	v.vmax.x=dreta;
	v.vmax.y=superior;

	return(v);
}

int CalculaColor (int n, esfera e[20], Pt2D pm)
{
	float vect;
	float z;

	z=sqrt(pow(e[n].r,2)-pow(pm.x-e[n].xc,2)+pow(pm.y-e[n].yc,2))+e[n].zc;
	vect=sqrt(pow(pm.x-e[n].xc,2)+pow(pm.y-e[n].yc,2)+pow(z-e[n].zc,2));

	return(vect*16);
}