/**** Network errors ****/

#define FILE_IN_USE_ERROR					0x80	/* 128 */
#define NO_MORE_FILE_HANDLES				0x81	/* 129 */
#define NO_OPEN_PRIVILEGES					0x82	/* 130 */
#define IO_ERROR_NETWORK_DISK				0x83	/* 131 */
#define NO_CREATE_PRIVILEGES				0x84	/* 132 */
#define NO_CREATE_DELETE_PRIVILEGES			0x85	/* 133 */
#define CREATE_FILE_EXISTS_READ_ONLY		0x86	/* 134 */
#define WILD_CARDS_IN_CREATE_FILE_NAME		0x87	/* 135 */
#define INVALID_FILE_HANDLE					0x88	/* 136 */
#define NO_SEARCH_PRIVILEGES				0x89	/* 137 */
#define NO_DELETE_PRIVILEGES				0x8a	/* 138 */
#define NO_RENAME_PRIVILEGES				0x8b	/* 139 */
#define NO_MODIFY_PRIVILEGES				0x8c	/* 140 */
#define SOME_FILES_AFFECTED_IN_USE			0x8d	/* 141 */
#define NO_FILES_AFFECTED_IN_USE			0x8e	/* 142 */
#define SOME_FILES_AFFECTED_READ_ONLY		0x8f	/* 143 */
#define NO_FILES_AFFECTED_READ_ONLY			0x90	/* 144 */
#define SOME_FILES_RENAMED_NAME_EXISTS		0x91	/* 145 */
#define NO_FILES_RENAMED_NAME_EXISTS		0x92	/* 146 */
#define NO_READ_PRIVILEGES					0x93	/* 147 */
#define NO_WRITE_PRIVILEGES_OR_READONLY		0x94	/* 148 */
#define FILE_DETACHED						0x95	/* 149 */
#define SERVER_OUT_OF_MEMORY				0x96	/* 150 */
#define NO_DISK_SPACE_FOR_SPOOL_FILE		0x97	/* 151 */
#define VOLUME_DOES_NOT_EXIST				0x98	/* 152 */
#ifndef DIRECTORY_FULL
#define DIRECTORY_FULL						0x99	/* 153 */
#endif
#define RENAMING_ACROSS_VOLUMES				0x9a	/* 154 */
#define BAD_DIRECTORY_HANDLE				0x9b	/* 155 */
#define INVALID_PATH						0x9c	/* 156 */
#define NO_MORE_TRUSTEES					0x9c
#define NO_MORE_DIRECTORY_HANDLES			0x9d	/* 157 */
#define INVALID_FILENAME					0x9e	/* 158 */
#define DIRECTORY_ACTIVE					0x9f	/* 159 */
#define DIRECTORY_NOT_EMPTY					0xa0	/* 160 */
#define DIRECTORY_IO_ERROR					0xa1	/* 161 */
#define READ_FILE_WITH_RECORD_LOCKED		0xa2	/* 162 */
#define LOGIN_DENIED_NO_ACCOUNT_BALANCE		0xc1	/* 193 */
#define LOGIN_DENIED_NO_CREDIT				0xc2	/* 194 */
#define INTRUDER_DETECTION_LOCK				0xc5	/* 197 */
#define PASSWORD_NOT_UNIQUE					0xd7	/* 215 */
#define PASSWORD_TOO_SHORT					0xd8	/* 216 */
#define LOGIN_DENIED_NO_CONNECTION			0xd9	/* 217 */
#define UNAUTHORIZED_LOGIN_TIME				0xda	/* 218 */
#define UNAUTHORIZED_LOGIN_STATION			0xdb	/* 219 */
#define ACCOUNT_DISABLED					0xdc	/* 220 */
#define PASSWORD_HAS_EXPIRED_NO_GRACE		0xde	/* 222 */
#define PASSWORD_HAS_EXPIRED				0xdf	/* 223 */
#define NOT_ITEM_PROPERTY					0xe8	/* 232 */
#define WRITE_PROPERTY_TO_QROUP				0xe8
#define MEMBER_ALREADY_EXISTS				0xe9	/* 233 */
#define NO_SUCH_MEMBER						0xea	/* 234 */
#define NOT_GROUP_PROPERTY					0xeb	/* 235 */
#define NO_SUCH_SEGMENT						0xec	/* 236 */
#define PROPERTY_ALREADY_EXISTS				0xed	/* 237 */
#define OBJECT_ALREADY_EXISTS				0xee	/* 238 */
#define INVALID_NAME						0xef	/* 239 */
#define WILD_CARD_NOT_ALLOWED				0xf0	/* 240 */
#define IPX_NOT_INSTALLED					0xf0
#define INVALID_BINDERY_SECURITY			0xf1	/* 241 */
#define NO_OBJECT_READ_PRIVILEGE			0xf2	/* 242 */
#define NO_OBJECT_RENAME_PRIVILEGE			0xf3	/* 243 */
#define NO_OBJECT_DELETE_PRIVILEGE			0xf4	/* 244 */
#define NO_OBJECT_CREATE_PRIVILEGE			0xf5	/* 245 */
#define NO_PROPERTY_DELETE_PRIVILEGE		0xf6	/* 246 */
#define NOT_SAME_LOCAL_DRIVE 				0xf6
#define NO_PROPERTY_CREATE_PRIVILEGE		0xf7	/* 247 */
#define TARGET_DRIVE_NOT_LOCAL				0xf7
#define ALREADY_ATTACHED_TO_SERVER			0xf8	/* 248 */
#define NO_PROPERTY_WRITE_PRIVILEGE			0xf8
#define NOT_ATTACHED_TO_SERVER				0xf8
#define NO_FREE_CONNECTION_SLOTS			0xf9	/* 249 */
#define NO_PROPERTY_READ_PRIVILEGE			0xf9
#define NO_MORE_SERVER_SLOTS				0xfa	/* 250 */
#define TEMP_REMAP_ERROR					0xfa
#define INVALID_PARAMETERS					0xfb	/* 251 */
#define NO_SUCH_PROPERTY					0xfb
#define UNKNOWN_REQUESE						0xfb
#define INTERNET_PACKET_REQT_CANCELED		0xfc	/* 252 */
#define UNKNOWN_FILE_SERVER					0xfc
#define MESSAGE_QUEUE_FULL					0xfc
#define NO_SUCH_OBJECT						0xfc
#define BAD_STATION_NUMBER					0xfd	/* 253 */
#define INVALID_PACKET_LENGTH				0xfd
#define UNKNOWN_REQUEST						0xfd
#define FIELD_ALREADY_LOCKED				0xfd
#define BINDERY_LOCKED						0xfe	/* 254 */
#define DIRECTORY_LOCKED					0xfe
#define INVALID_SEMAPHORE_NAME_LENGTH		0xfe
#define PACKET_NOT_DELIVERABLE				0xfe
#define SERVER_BINDERY_LOCKED				0xfe
#define SOCKET_TABLE_FULL					0xfe
#define SPOOL_DIRECTORY_ERROR				0xfe
#define SUPERVISOR_HAS_DISABLED_LOGIN		0xfe
#define TIMEOUT_FAILURE						0xfe
#define BAD_PRINTER_ERROR					0xff	/* 255 */
#define BAD_RECORD_OFFSET					0xff
#define CLOSE_FCB_ERROR						0xff
#define FILE_EXTENSION_ERROR				0xff
#define FILE_NAME_ERROR						0xff
#define HARDWARE_FAILURE					0xff
#define INVALID_DRIVE_NUMBER				0xff
#define INVALID_INITIAL_SEMAPHORE_VALUE		0xff
#define INVALID_SEMAPHORE_HANDLE			0xff
#define IO_BOUND_ERROR						0xff
#define NO_FILES_FOUND_ERROR				0xff
#define NO_RESPONSE_FROM_SERVER				0xff
#define NO_SUCH_OBJECT_OR_BAD_PASSWORD		0xff
#define PATH_NOT_LOCATABLE					0xff
#define QUEUE_FULL_ERROR					0xff
#define REQUEST_NOT_OUTSTANDING				0xff
#define SOCKET_ALREADY_OPEN					0xff
#define NO_CONSOLE_OPERATOR					0xc6

