/*****************************************************************************
 *
 * Program Name:  Novell 'C' Library
 *
 * Filename:	  nitipx.h
 *
 * Date Created:  January 5, 1988
 *
 * Version:		  1.0
 *
 * Programmers:	  Tom L. Bogart
 *
 * Files used:	  prolog.h
 *
 * Date Modified: 
 *
 * Modifications: 
 *
 * Comments:
 *
 * COPYRIGHT (c) 1986 by Novell, Inc.  All Rights Reserved.
 *
 ****************************************************************************/

#ifndef PROLOG
#include <prolog.h>
#endif
    /**************************/
    /* Definimos WORD y BYTE  */
    /**************************/

#define WORD unsigned short
#define BYTE unsigned char

typedef struct IPXAddress
{
	BYTE	network[4];	/* high-low */
	BYTE	node[6];	/* high-low */
	BYTE	socket[2];	/* high-low */
} IPXAddress;

typedef struct IPXHeader
{
	WORD		checkSum;			/* high-low */
	WORD		length;				/* high-low */
	BYTE		transportControl;
	BYTE		packetType;
	IPXAddress	destination;
	IPXAddress	source;
} IPXHeader;

#ifndef ECB_STRUCTURES_DEFINED
	typedef struct ECBFragment
	{
#ifdef MSC
		void	far *address;
#else
		WORD	address[2];		/* offset-segment */
#endif
		WORD	size;	 		/* low-high */
	} ECBFragment;

	typedef struct ECB
	{
#ifdef MSC
		void		far *linkAddress;
		void		(far *ESRAddress)();
#else
		WORD		linkAddress[2];		/* offset-segment */
		WORD		ESRAddress[2];		/* offset-segment */
#endif
		BYTE		inUseFlag;
		BYTE		completionCode;
		BYTE		socketNumber[2];					/* high-low */
		BYTE		IPXWorkspace[4];				/* N/A */
		BYTE		driverWorkspace[12];			/* N/A */
		BYTE		immediateAddress[6];			/* high-low */
		WORD		fragmentCount;					/* low-high */
		ECBFragment	fragmentDescriptor[2];
	} ECB;

#define ECB_STRUCTURES_DEFINED
#endif

#ifdef BIG_MEMORY
#ifdef PROTOTYPE
extern int  IPXCancelEvent(ECB *);
extern void IPXCloseSocket(WORD);
extern void IPXDisconnectFromTarget(BYTE *);
extern void IPXGetDataAddress(BYTE *, WORD *);
extern void IPXGetInternetworkAddress(BYTE *);
extern WORD IPXGetIntervalMarker(void);
extern int  IPXGetLocalTarget(BYTE *, BYTE *, WORD *);
extern int  IPXInitialize(void);
extern void IPXListenForPacket(ECB *);
extern int  IPXOpenSocket(BYTE *, BYTE);
extern void IPXRelinquishControl(void);
extern void IPXScheduleIPXEvent(WORD, ECB *);
extern void IPXScheduleSpecialEvent(WORD, ECB *);
extern void IPXSendPacket(ECB *);
#else
extern int  IPXCancelEvent();
extern void IPXCloseSocket();
extern void IPXDisconnectFromTarget();
extern void IPXGetDataAddress();
extern void IPXGetInternetworkAddress();
extern WORD IPXGetIntervalMarker();
extern int  IPXGetLocalTarget();
extern void IPXGetProcAddress();
extern int  IPXInitialize();
extern void IPXListenForPacket();
extern int  IPXOpenSocket();
extern void IPXRelinquishControl();
extern void IPXScheduleIPXEvent();
extern void IPXScheduleSpecialEvent();
extern void IPXSendPacket();
#endif
#else
extern WORD IPXGetIntervalMarker();
#endif
