/*****************************************************************************
 *
 * Program Name:  Novell 'C' Library
 *
 * Filename:	  nitspx.h
 *
 * Date Created:  January 5, 1988
 *
 * Version:		  1.0
 *
 * Programmers:	  Tom L. Bogart
 *
 * Files used:	  prolog.h
 *
 * Date Modified: 
 *
 * Modifications: 
 *
 * Comments:
 *
 * COPYRIGHT (c) 1986 by Novell, Inc.  All Rights Reserved.
 *
 ****************************************************************************/

#ifndef PROLOG
#include <prolog.h>
#endif

typedef struct SPXHeader
{
	WORD	checksum;				/* high-low 1's complement */
	WORD	length;					/* high-low unsigned int */
	BYTE	transportControl;
	BYTE	packetType;
	BYTE	destinationNetwork[4];	/* high-low unsigned */
	BYTE	destinationNode[6];		/* high-low unsigned */
	WORD	destinationSocket;		/* high-low unsigned */
	BYTE	sourceNetwork[4];		/* high-low unsigned */
	BYTE	sourceNode[6];			/* high-low unsigned */
	WORD	sourceSocket;			/* high-low unsigned */
	BYTE	connectionControl;		/* bit flags */
	BYTE	dataStreamType;
	WORD	sourceConnectionID;		/* high-low unsigned */	
	WORD	destConnectionID;		/* high-low unsigned */
	WORD	sequenceNumber;			/* high-low unsigned */
	WORD	acknowledgeNumber;		/* high-low unsigned */
	WORD	allocationNumber;		/* high-low unsigned */
} SPXHeader;

#ifndef ECB_STRUCTURES_DEFINED
	typedef struct ECBFragment
	{
#ifdef MSC
		void	far *address;
#else
		WORD	address[2];		/* offset-segment */
#endif
		WORD	size;	 		/* low-high */
	} ECBFragment;

	typedef struct ECB
	{
#ifdef MSC
		void		far *linkAddress;
		void		(far *ESRAddress)();
#else
		WORD		linkAddress[2];		/* offset-segment */
		WORD		ESRAddress[2];		/* offset-segment */
#endif
		BYTE		inUseFlag;
		BYTE		completionCode;
		WORD		socketNumber;			/* high-low */
		BYTE		IPXWorkspace[4];		/* N/A */
		BYTE		driverWorkspace[12];	/* N/A */
		BYTE		immediateAddress[6];	/* high-low */
		WORD		fragmentCount;			/* low-high */
		ECBFragment	fragmentDescriptor[2];
	} ECB;

#define ECB_STRUCTURES_DEFINED
#endif

#define SPX_IS_INSTALLED			0xFF
#define SPX_NOT_INSTALLED			0x00
#define SPX_CONNECTION_OK			0x00
#define SPX_CONNECTION_STARTED		0x00
#define SPX_CONNECTION_ESTABLISHED	0x00
#define SPX_PACKET_SUCCESSFUL		0x00
#define SPX_SOCKET_NOT_OPENED		0xFF
#define SPX_MALFORMED_PACKET		0xFD
#define SPX_PACKET_OVERFLOW			0xFD
#define SPX_LISTEN_CANCELED			0xFC
#define SPX_CONNECTION_TABLE_FULL	0xEF
#define SPX_INVALID_CONNECTION		0xEE
#define SPX_NO_ANSWER_FROM_TARGET	0xED
#define SPX_CONNECTION_FAILED		0xED
#define SPX_CONNECTION_TERMINATED	0xED
#define SPX_TERMINATED_POORLY		0xEC

#ifdef BIG_MEMORY
#ifdef PROTOTYPE
extern void SPXAbortConnection(WORD);
extern int  SPXEstablishConnection(BYTE, BYTE, WORD *, ECB *);
extern int  SPXGetConnectionStatus(WORD, BYTE *);
extern int  SPXInitialize(BYTE *, BYTE *, WORD *, WORD *);
extern void SPXListenForConnection(BYTE, BYTE, ECB *);
extern void SPXListenForSequencedPacket(ECB *);
extern void SPXSendSequencedPacket(WORD, ECB *);
extern void SPXTerminateConnection(WORD, ECB *);
#else
extern void SPXAbortConnection();
extern int  SPXEstablishConnection();
extern int  SPXGetConnectionStatus();
extern int  SPXInitialize();
extern void SPXListenForConnection();
extern void SPXListenForSequencedPacket();
extern void SPXSendSequencedPacket();
extern void SPXTerminateConnection();
#endif
#endif
