/*****************************************************************************
 *
 * Program Name:  Novell 'C' Library
 *
 * Filename:	  prolog.h
 *
 * Date Created:  January 5, 1988
 *
 * Version:		  1.0
 *
 * Programmers:   Tom L. Bogart
 *
 * Files used:
 *
 * Date Modified: 
 *
 * Modifications: 
 *
 * Comments:
 *
 * COPYRIGHT (c) 1986 by Novell, Inc.  All Rights Reserved.
 *
 ****************************************************************************/

/********************************* LC215 ************************************/

#ifdef LC215

#ifndef void
#define void  int
#endif

#ifndef BYTE
#define	BYTE  char
#endif

#ifndef WORD
#define WORD  unsigned
#endif

#ifndef	NULL
#ifdef SPTR
#define NULL 0
#else
#define NULL 0L
#endif
#endif
 
#ifndef memset
#define memset(dest, c, cnt)	setmem((dest), (cnt), (c))
#endif

#ifndef memcpy
#define memcpy(dest, src, cnt)	movmem((src), (dest), (cnt))
#endif

#endif

/*********************************** LC300 **********************************/

#ifdef LC300
#ifndef BIG_MEMORY
#define BIG_MEMORY
#define _ELIPSIS_
#ifndef NARGS
#define PROTOTYPE
#endif
#endif

#ifndef BYTE
#define BYTE  unsigned char
#endif

#ifndef WORD
#define WORD  unsigned short
#endif

#ifndef	NULL
#ifdef SPTR
#define NULL 0
#else
#define NULL 0L
#endif
#endif

#endif

/******************************** TURBO C ***********************************/

/*
	if running TURBO 'C' pretend to be Microsoft with prototypes.
*/

#ifdef __TURBOC__
	#define MSC
	#define LINT_ARGS
	#if defined(__TINY__)
		#define M_I86TM __TINY__
	#elif defined(__SMALL__)
		#define M_I86SM __SMALL__
	#elif defined(__MEDIUM__)
		#define M_I86MM __MEDIUM__
	#elif defined(__COMPACT__)
		#define M_I86CM __COMPACT__
	#elif defined(__LARGE__)
		#define M_I86LM __LARGE__
	#elif defined(__HUGE__)
		#define M_I86HM __HUGE__
	#endif
#endif

/******************************** MSC400 ************************************/
 
#ifdef MSC
	#ifndef BIG_MEMORY
		#define BIG_MEMORY
		#define _ELIPSIS_ ...
		#ifdef LINT_ARGS
			#define PROTOTYPE
		#endif
	#endif

	#ifndef BYTE
		#define BYTE  unsigned char
	#endif

	#ifndef WORD
		#define WORD  unsigned short
	#endif

	#ifndef O_RAW
		#define O_RAW O_BINARY
	#endif

	#ifndef NPrintF
		#define NPrintF	printf
	#endif

	#ifndef	NULL
		#if defined(M_I86LM) || defined(M_I86CM) || defined(M_I86HM)
			#define NULL 0L
		#else
			#define NULL 0
		#endif
	#endif

	#ifndef Free
		#define Free(p)	(free(p), 0)
	#endif
#endif

/****************************************************************************/

#ifndef NOPROC
#define NOPROC ((int (*)())0)
#endif

#ifndef TRUE
#define TRUE	1
#define FALSE	0
#endif

#define PROLOG

/******************************* DOS ERRORS *********************************/

#ifndef DOS_INVALID_FUNCTION_NUMBER

/* DOS errors */
#define DOS_INVALID_FUNCTION_NUMBER		 1
#define DOS_FILE_NOT_FOUND				 2
#define DOS_PATH_NOT_FOUND				 3
#define DOS_TOO_MANY_OPEN_FILES			 4
#define DOS_ACCESS_DENIED				 5
#define DOS_INVALID_FILE_HANDLE			 6
#define DOS_MEMORY_BLOCKS_DESTROYED		 7
#define DOS_INSUFFICIENT_MEMORY			 8
#define DOS_INVALID_MEMORY_BLOCK_ADDR	 9
#define DOS_INVALID_ENVIRONMENT			10
#define DOS_INVALID_FORMAT				11
#define DOS_INVALID_ACCESS_CODE			12
#define DOS_INVALID_DATA				13
#define DOS_INVALID_DRIVE_SPECIFIED		15
#define DOS_ATTEMPT_TO_DEL_CURRENT_DIR	16
#define DOS_NOT_SAVE_DEVICE				17
#define DOS_NO_MORE_FILES				18
#define DOS_SHARING_VIOLATION			32
#define DOS_LOCK_VIOLATION				33

#endif
